;*** Ethernet ArmTNC - S53MV 21.08.2011 ***

;*** Tacke LPC2368/2387 (58.9824MHz@kristal=14.7456MHz) ***
;P0.0 - digitalni izhod TXD UART3
;P0.1 - digitalni vhod RXD UART3
;P0.2 - digitalni izhod TXD UART0
;P0.3 - digitalni vhod RXD UART0
;P0.4 - digitalni izhod vezan na P0.6
;P0.5 - dgitalni vhod /DCD (SSP1)
;P0.6=SSEL - digitalni vhod vezan na P0.4
;P0.7=SCK1 - digitalni vhod /CLK (SSP1)
;P0.8=MISO1 - digitalni izhod TXD (SSP1)
;P0.9=MOSI1 - digitalni vhod RXD (SSP1)
;P0.10 - digitalni izhod TXD UART2
;P0.11 - digitalni vhod RXD UART2
;P0.15 - digitalni izhod TXD UART1
;P0.16 - digitalni vhod RXD UART1
;P0.17-22 - neuporabljeni digitalni vhodi
;P0.23-25=AD0.1-3 - analogni vhod (TLM#1)
;P0.26=AD0.4 - analogni vhod (TLM#2)
;P0.27-30 - neuporabljeni digitalni vhodi
;P1.0,1,4,8,9,10,14,15,16,17 - Ethernet RMII (digitalni)
;P1.18-30 - neuporabljeni digitalni vhodi
;P1.31 - digitalni izhod (telekomanda)
;P2.0-9 - neuporabljeni digitalni vhodi (TRACE)
;P2.10 - digitalni vhod /bootloader, pullup na +3.3V 
;P2.11-13 - neuporabljeni digitalni vhodi
;P3.25-26 - neuporabljena digitalna vhoda
;P4.28 - digitalni izhod /PTT (SSP1)
;P4.29 - neuporabljen digitalni izhod

;*** Ukazi za delovanje zbirnika ARM ***
	AREA	RESET, CODE, READONLY, ALIGN=9
	ENTRY
	CODE32

;*** Dodelitev pomnilnika RAM ***
SKLAD	EQU	0x40000090	;glavni sklad (navzdol ???)
ISKLAD	EQU	0x400000A8	;IRQ sklad (navzdol -16)
FSKLAD	EQU	0x400000C0	;FIQ sklad (navzdol -16)

SLTXBLO	EQU	0x400000C0	;SLIP TX blok (32bit)
SLRXTIM	EQU	0x400000C4	;SLIP RX cas prejsnje prekinitve (32bit)
SLRXBLO	EQU	0x400000C8	;SLIP RX blok (32bit)
SLTXKAZ	EQU	0x400000CC	;SLIP TX kazalec (16bit)
SLTXSTA	EQU	0x400000CE	;SLIP TX stanje (8bit)
SPREKLP	EQU	0x400000CF	;PREKLOP stanje (8bit)
TPREKLP	EQU	0x400000D0	;PREKLOP cas (32bit)
BPREKLP	EQU	0x400000D4	;PREKLOP okvir za sproscanje (32bit)
ZPONOVI	EQU	0x400000D8	;PREKLOP zadnje ponavljanje (32bit)
POLINOM	EQU	0x400000DC	;PSEVNAK vsebina LFSR (32bit)
DVOJKAZ	EQU	0x400000E0	;kazalec v tabeli dvojnikov (16bit)
NODZIV	EQU	0x400000E2	;stevilo byte odziva, 0=izklop (16bit)
MIKRSEK	EQU	0x400000E4	;mikrosekundni stevec (16bit)
MILISEK	EQU	0x400000E6	;milisekundni stevec (16bit)
SEKUNDA	EQU	0x400000E8	;sekundni stevec (32bit)
NZANK	EQU	0x400000EC	;izmerjeno stevilo zank (32bit)
SZANK	EQU	0x400000F0	;stevec zank (32bit)
NDCD	EQU	0x400000F4	;izmerjeni promil DCD (16bit)
SDCD	EQU	0x400000F6	;stevec DCD (16bit)
NPTT	EQU	0x400000F8	;izmerjeni promil PTT (16bit)
SPTT	EQU	0x400000FA	;stevec PTT (16bit)
MPONOVI	EQU	0x400000FC	;minimum ponavljanja (8bit)
DPONOVI	EQU	0x400000FD	;neizvedena ponavljanja (8bit)
NICBLOK	EQU	0x400000FE	;zastavica nic blokov (8bit)
ZNACIN	EQU	0x400000FF	;zastavice (8bit):
;bit0(1)=(0)ukaz/(1)pogovor s tipkovnice
;bit1(2)=(0)uporabni/(1)vsi okvirji na zaslon
;bit2(4)=(0)izklop/(1)vklop izpisa stanja vsako sekundo
;bit3(8)=(0)zaslon/(1)okvir izpis znakov
;bit4(16)=(0)izklop/(1)vklop izpisa PHY vsako sekundo
;bit5(32)=(0)naslov36/(1)naslovHEX

MCACHE	EQU	25		;velikost cacheja (max 25 vpisov)
ECACHE	EQU	0x40000100	;EthernetARP cache (MCACHE*16byte)
;Ethernet/ARP cache: max 25 vpisov po 16byte v 0x40000100-0x4000028F
;odmik 0 - IP stevilka (32bit)
;odmik 4 - MAC stevilka (48bit)
;odmik 10 - preostalo trajanje vpisa (16bit)
;odmik 12 - zakasnitev ARP odgovora (32bit)

KCACHE	EQU	0x40000290	;kazalec v cache (32bit)
MACMAC	EQU	0x40000294	;zadnji sogovornikov MAC (48bit)

ARPCAS	EQU	0x400002A0	;cas oddaje ARP (32bit)
ETXBLOK	EQU	0x400002A4	;cakajoci blok na ARP (32bit)
ZASKAZ	EQU	0x400002A8	;kazalca zaslona (2*16bit)
ZASTRI	EQU	0x400002AC	;vmesnik za 1-3 znake (32bit)
MAXZAS	EQU	0x800		;dolzina vmesnika 2kbyte BATRAM

HDLCNRZ	EQU	-12	;HDLC NRZI/NRZ dekodiranje (relativno na R10) (32bit)
HDLCSTX	EQU	-8	;stevec HDLC bajtov (relativno na R10) (16bit)
HDLCKTX	EQU	-4	;kazalec HDLC oddajnika (relativno na R10) (32bit)
TABCRC	EQU	0x40000300	;CRC tabela 256*16bitov (R10 FIQ)

;parametri iz FLASH 0x40000500-0x400008FF (1024byte)
RAMFPAR	EQU	0x40000500	;zacetek parametrov iz FLASH (1024byte)
MNASLOV	EQU	0x40000500	;moj naslov (32bit)
TSLOT	EQU	0x40000504	;trajanje slota (us) (32bit)
TGLAVA	EQU	0x40000508	;dolzina glave (us) (32bit)
TREP	EQU	0x4000050C	;dolzina repa (us) (32bit)
TECEN1	EQU	0x40000510	;tecnoba z DCD /65536 (16bit)
TECEN2	EQU	0x40000512	;tecnoba brez DCD /65536 (16bit)
GESLO	EQU	0x40000514	;geslo za telekomando (32bit)
BAUDMOD	EQU	0x40000518	;baudrate modulo UART1 (16bit)
MINBLOK	EQU	0x4000051A	;najmanj prostih blokov (8bit)
NPONOVI	EQU	0x4000051B	;stevilo ponavljanj (8bit)
ARMTAKT	EQU	0x4000051C	;takt ARM procesorja (32bit)
TPONOVI	EQU	0x40000520	;zakasnitev ponavljanj (32bit)
TIMEOUT	EQU	0x40000524	;Hayes/EthernetARP timeout (32bit)

NENOTA	EQU	0x40000528	;skala in enote ADC TLM (MENOTA*32BIT)
MENOTA	EQU	6
NASLOV	EQU	0x40000540	;naslov poti (MAXNAS*32bit)
INASLOV	EQU	0x40000580	;naslov IP poti (MAXNAS*32bit)
MAXNAS	EQU	16
JAVITXT	EQU	0x400005C0	;besedilo javljanja (MAXJAVI byte)
MAXJAVI	EQU	64		;najvecja dolzina besedila
ANASLOV	EQU	0x40000600	;naslov ARP tabele (MAXARP*(MAXNAS+1)*32bit)
AKORAK	EQU	68		;korak v tabeli ARP (1+MAXNAS)*4
MAXARP	EQU	10
ANACIN	EQU	0x400008A8	;nacin delovanja ARP (8bit)

LNASLOV	EQU	0x400008B0	;naslovi lokalne zanke (MAXLOK*32bit)
MAXLOK	EQU	8

DOMENA	EQU	0x400008E0	;IP domena (12byte)
TCACHE	EQU	0x400008EC	;EthernetARP cache trajanje (16bit)
GATEWAY	EQU	0x400008F0	;Privzeti prehod/maska (8byte)
ESPEED	EQU	0x400008F9	;Ethernet hitrost in MDIX (8bit)
ETHMAC	EQU	0x400008FA	;Ethernet MAC naslov (6byte)

ZNASLOV	EQU	0x40000900	;zacasni naslov za vnos ARP ((MAXNAS+1)*32bit)

TIPVMES	EQU	0x40000950	;vmesnik tipk ((MAXUKAZ+1)*8bit)
MAXUKAZ	EQU	170
KSTEVEC	EQU	0x400009FE	;perioda/stevec kokodakanja (2byte)

MAXBLOK	EQU	44		;RAMBLOK dolzine (MAXBLOK+1)*32bit
RAMBLOK	EQU	0x40000A00	;naslov blokov RAM

MAXVMES	EQU	47		;nnXVMES dolzine 2*16bit+MAXVMES*32bit
HRXVMES	EQU	0x40000AC0	;naslov vmesnika RX HDLC
HTPVMES	EQU	0x40000B80	;naslov potrdilnega vmesnika TX HDLC
HTXVMES	EQU	0x40000C40	;naslov vmesnika TX HDLC
HTZVMES	EQU	0x40000D00	;naslov zacasnega vmesnika TX HDLC
SRXVMES	EQU	0x40000DC0	;naslov vmesnika RX SLIP
STXVMES	EQU	0x40000E80	;naslov vmesnika TX SLIP
ETXVMES	EQU	0x40000F40	;naslov mesnika TX ETH

DVOJTAB	EQU	0x40001000	;tabela dvojnikov (4kbyte) lihi 0x1000!!!

;bloki pomnilnika (RAM, USBRAM), 20-45 blokov dolzine 1632=0x660
;odmik 0 - dolzina vsebine (16bit)
;odmik 2 - zacetek vsebine (16bit)
;odmik 4 - stevilo ponavljanj (8bit)
;odmik 5 - zakasnitev ponavljanja (8bit)
;odmik 4 - ARP IP4 cilj (32bit) samo v ETXBLOK

;IAP ukazi za programiranje FLASH 0x40007FA0-0x40007FFF
IAPCMD	EQU	0x40007FA0	;ukaz IAP
IAPRES	EQU	0x40007FA0	;rezultat IAP
POTBLOK	EQU	0x40007FA0	;kratki potrditveni blok (max 96byte)

;Ethernet RAM (16kB 0x7FE00000-0x7FE03FFF)
RXDESC	EQU	0x7FE00000	;RxDescriptor
RXSTAT	EQU	0x7FE00100	;RxStatus
RXDESCN	EQU	8		;RxDescriptorNumber-1
RXCONT	EQU	0x800005FF	;RxDescriptorControlWord=Int,1536-1
TXDESC	EQU	0x7FE00200	;TxDescriptor
TXSTAT	EQU	0x7FE00300	;TxStatus
TXDESCN	EQU	8		;TxDescriptorNumber-1

ZACERX	EQU	0x7FE003F2	;zacetni naslov blokov sprejemnika (-14)
ZACETX	EQU	0x7FE039F2	;zacetni naslov bloka oddajnika (-14)
ETHBLOK	EQU	0x600		;dolzina bloka 1536

;baterijsko napajani RAM (2kbyte 0xE0084000-0xE00847FF, 32-bitni dostop)
BATRAM	EQU	0xE0084000	;vmesnik 2kbyte za ZNAK,ZASLON

;*** Tabela izjem na zacetnem naslovu 0 ***
IZJEME	B	ZACNI
	B	IZJEME	;Undef
	B	IZJEME	;SWI
	B	IZJEME	;PAbt
	B	IZJEME	;DAbt
	NOP		;Reserved Vector
	B	SLIPRX	;IRQ
;*** Podprogram FIQ - HDLC sprejem/oddaja preko SPI1 *** (sklad -16)
HDLCZAC	EQU	8	;zacetek podatkov RX
HDLCMIN	EQU	18	;min kazalec podatkov RX (8byte+CRC)
HDLCMAX	EQU	1616	;max kazalec podatkov RX (16byte rezerve)
;R14	LR
;R13	SP
;R12	HDLC pomikalni register
;R11	NRZI dekodirano negirano
;R10	naslov tabele HDLC CRC
;R9	RX izracun CRC / TX NRZI+stevec32
;R8	naslov bloka za RX okvir
	STR	LR,[SP,#-4]!	;resi link
	STR	R0,[SP,#-4]!	;resi R0
	STR	R1,[SP,#-4]!	;resi R1
	LDR	R0,=0xE0030008	;naslov SSP1DR
	MOV	R1,R11,LSR#16	;oddaja 2x16bitov iz R11
	STRH	R1,[R0]
	STRH	R11,[R0]
	LDRH	R1,[R0]		;sprejem 2x16bitov v R1
	LDRH	R0,[R0]
	ORR	R1,R0,R1,LSL#16
	LDR	R0,=0x3FFFC097	;FIO4PIN3 P4.28 sprejem/oddaja?
	LDRB	R0,[R0]
	TST	R0,#0x10
	BEQ	HDLCTX

;*** NRZI/NRZ dekodiranje negirano v R11 ***
	LDR	R11,[R10,#HDLCNRZ]
	STR	R1,[R10,#HDLCNRZ]
	ADDS	R1,R1,R1
	ADC	R0,R11,R11
	EOR	R11,R11,R0

;*** Makro za HDLC sprejemnik (se ponovi 32-krat) ***
	MACRO
	MRHDLC
	ADDS	R11,R11,R11	;obrni vrstni red iz R11 v R12
	MOVS	R12,R12,RRX
	BLCS	RXNICLA		;izloci niclo za 5 (pet) enicami
	TST	R12,#0x3F000000	;zastavica?
	BLEQ	RXOKVIR
	TST	R12,#0x7C000000	;5 (pet) zaporednih enic?
	ORREQ	R12,R12,#0x00000080
	TST	R12,#0x00008000	;cel byte veljavnih podatkov?
	BLNE	RXBYTE
	MEND

;*** Sprejem 32 bitov ***
	MRHDLC	;bit 1
	MRHDLC	;bit 2
	MRHDLC	;bit 3
	MRHDLC	;bit 4
	MRHDLC	;bit 5
	MRHDLC	;bit 6
	MRHDLC	;bit 7
	MRHDLC	;bit 8
	MRHDLC	;bit 9
	MRHDLC	;bit 10
	MRHDLC	;bit 11
	MRHDLC	;bit 12
	MRHDLC	;bit 13
	MRHDLC	;bit 14
	MRHDLC	;bit 15
	MRHDLC	;bit 16
	MRHDLC	;bit 17
	MRHDLC	;bit 18
	MRHDLC	;bit 19
	MRHDLC	;bit 20
	MRHDLC	;bit 21
	MRHDLC	;bit 22
	MRHDLC	;bit 23
	MRHDLC	;bit 24
	MRHDLC	;bit 25
	MRHDLC	;bit 26
	MRHDLC	;bit 27
	MRHDLC	;bit 28
	MRHDLC	;bit 29
	MRHDLC	;bit 30
	MRHDLC	;bit 31
	MRHDLC	;bit 32
	LDR	R1,[SP],#4	;povrni R1
	LDR	R0,[SP],#4	;povrni R0
	LDR	LR,[SP],#4	;povrni link
	SUBS	PC,LR,#4	;izhod iz prekinitve FIQ
	LTORG

;*** Izloci niclo za 5 (pet) enicami ***
	ALIGN	16
RXNICLA	MOV	R0,R12
	BIC	R12,R12,#0x00FF0000
	ADD	R0,R0,R0
	AND	R0,R0,#0x00FF0000
	ORR	R12,R12,R0
	BIC	R12,R12,#0x00008000
	BX	LR
	LTORG

;*** Sprejem byte podatkov in obracun CRC ***
	ALIGN	16
RXBYTE	MVN	R0,R12,LSR#16	;byte podatkov v R0
	BIC	R12,R12,#0x007F0000
	BIC	R12,R12,#0x0000F000
	ORR	R12,R12,#0x00800000
	MOVS	R8,R8		;sprejemni blok obstaja?
	BXEQ	LR
	LDRH	R1,[R8]
	CMP	R1,#HDLCMAX	;prostor v vmesniku?
	BXCS	LR
	STRB	R0,[R8,R1]	;shrani byte in povecaj kazalec
	ADD	R1,R1,#1
	STRH	R1,[R8]
	EOR	R0,R0,R9	;obracunaj CRC za byte v R0
	AND	R0,R0,#0x000000FF
	ADD	R0,R0,R0
	LDRH	R1,[R10,R0]	;R10=TABCRC
	AND	R9,R9,#0x0000FF00
	EOR	R9,R1,R9,LSR#8
	BX	LR
	LTORG

;*** Zacetek in zakljucek sprejema HDLC okvirja ***
	ALIGN	16
RXOKVIR	STR	LR,[SP,#-4]!	;resi link
	MOVS	R8,R8		;sprejemni blok ne obstaja?	
	BEQ	RXOKVI1
	AND	R0,R12,#0x00FF0000	;celostevilo byte brez ostanka?
	CMP	R0,#0x00C00000
	BNE	RXOKVI2
	MOV	R0,R9,LSL#16	;izloci okvir z napacnim CRCjem?
	LDR	R1,=0xF0B80000
	CMP	R0,R1
	BNE	RXOKVI2
	LDRH	R0,[R8]		;blok premajhen?
	CMP	R0,#HDLCMIN
	BCC	RXOKVI2
	SUB	R0,R0,#HDLCZAC	;odstej zacetek
	SUB	R0,R0,#2	;odstej dva byte CRC
	STRH	R0,[R8]
	MOV	R0,#HDLCZAC	;zapisi zacetek okvirja
	STRH	R0,[R8,#2]
	LDR	R0,=HRXVMES	;sprejeti okvir v vmesnik
	BL	VVMES
RXOKVI1	BL	DODELI		;dodeli nov sprejemni blok
RXOKVI2	MOV	R0,#HDLCZAC	;kazalec na zacetek obstojecega bloka?
	MOVS	R8,R8
	STRHNE	R0,[R8]
	MOVEQ	R11,#-1		;unici podatke brez bloka!
	MOV	R9,#-1		;postavi CRC na 0xFFFF
	AND	R12,R12,#0xC0000000	;pobrisi zgodovino v R12
	ORR	R12,R12,#0x40000000
	LDR	PC,[SP],#4	;povrni link
	LTORG

;*** Makro za HDLC oddajnik (se ponovi 32-krat) ***
	MACRO
	MTHDLC
	TST	R12,#0x0000FF00	;vstavi veljaven byte/zastavico?
	BLEQ	TXBYTE
	TST	R12,#0x0000007C	;5 (pet) zaporednih enic?
	BLEQ	TXNICLA
	MOVS	R12,R12,LSR#1	;obrnjeno NRZI kodirano v R11
	EORCS	R11,R11,R9
	MOV	R9,R9,LSR#1	;pomik R9
	MEND

;*** Oddaja 32 bitov ***
	ALIGN	16
HDLCTX	MOV	R0,R11,LSL#31	;pripravi R11 za naslednje podatke
	MOV	R11,R0,ASR#31
	MOV	R9,#-1
	MTHDLC	;bit 1
	MTHDLC	;bit 2
	MTHDLC	;bit 3
	MTHDLC	;bit 4
	MTHDLC	;bit 5
	MTHDLC	;bit 6
	MTHDLC	;bit 7
	MTHDLC	;bit 8
	MTHDLC	;bit 9
	MTHDLC	;bit 10
	MTHDLC	;bit 11
	MTHDLC	;bit 12
	MTHDLC	;bit 13
	MTHDLC	;bit 14
	MTHDLC	;bit 15
	MTHDLC	;bit 16
	MTHDLC	;bit 17
	MTHDLC	;bit 18
	MTHDLC	;bit 19
	MTHDLC	;bit 20
	MTHDLC	;bit 21
	MTHDLC	;bit 22
	MTHDLC	;bit 23
	MTHDLC	;bit 24
	MTHDLC	;bit 25
	MTHDLC	;bit 26
	MTHDLC	;bit 27
	MTHDLC	;bit 28
	MTHDLC	;bit 29
	MTHDLC	;bit 30
	MTHDLC	;bit 31
	MTHDLC	;bit 32
	LDR	R1,[SP],#4	;povrni R1
	LDR	R0,[SP],#4	;povrni R0
	LDR	LR,[SP],#4	;povrni link
	SUBS	PC,LR,#4	;izhod iz prekinitve FIQ
	LTORG

;*** Vrini niclo za 5 (pet) podatkovnih enic (brez zastavic) ***
	ALIGN	16
TXNICLA	TST	R12,#0x00C00000	;zastavica zastavice?
	BXNE	LR
	MOV	R0,R12		;vstavi niclo za 5 (pet) enicami
	AND	R12,R12,#0x0000007F
	BIC	R0,R0,#0x0000007F
	ADD	R0,R0,R0
	ORR	R0,R0,#0x00000080
	ORR	R12,R12,R0
	BX	LR
	LTORG

;*** Vstavi byte podatkov ali zastavico ***
	ALIGN	16
TXBYTE	AND	R12,R12,#0x0000007F	;pobrisi zgodovino
	LDRH	R1,[R10,#HDLCSTX]	;konec podatkov?
	MOVS	R1,R1
	LDREQ	R0,=0x2000C080	;vstavi zastavico z zastavico
	ORREQ	R12,R12,R0
	BXEQ	LR
	SUB	R1,R1,#1		;odstej stevec podatkov
	STRH	R1,[R10,#HDLCSTX]
	LDR	R1,[R10,#HDLCKTX]	;byte (kazlec) v HDLC TX
	LDRB	R0,[R1],#1
	STR	R1,[R10,#HDLCKTX]
	EOR	R0,R0,#0x000000FF
	ORR	R12,R12,R0,LSL#7
	ORR	R12,R12,#0x00008000
	BX	LR
	LTORG

;*** Inicializiraj SSP1 v LPC2368/2387 *** (R0,R1)
SSP1	LDR	R0,=0xE0030000	;SSP1CR0
	LDR	R1,=0x000000CF	;SCR=0,CPHA=1,CPOL=1,SPI,16bit
	STR	R1,[R0]
	LDR	R0,=0xE0030004	;SSP1CR1
	LDR	R1,=0x00000004	;slave:MS=1
	STR	R1,[R0]
	LDR	R0,=0xE0030010	;SSP1CPSR
	LDR	R1,=0x00000002	;CPSDVSRmin=2
	STR	R1,[R0]
	LDR	R0,=0xE0030014	;SSP1IMSC
	LDR	R1,=0x0000000C	;TXIM=1,RXIM=1
	STR	R1,[R0]
	LDR	R0,=0xE0030004	;SSP1CR1
	LDR	R1,=0x00000006	;slave:MS=1,SSPenable:SSE=1
	STR	R1,[R0]
	BX	LR
	LTORG

;*** HDLC preklop sprejem/oddaja v LPC2368/2387 *** (R0-3,R8)
	ALIGN	16
PREKLOP	STR	LR,[SP,#-4]!
	LDR	R0,=0x3FFFC097	;FIO4PIN3 P4.28 sprejem/oddaja?
	LDRB	R0,[R0]
	TST	R0,#0x10
	BEQ	PREKLO1
	LDR	R0,=0xE0004008	;T0TC - Timer0
	LDR	R2,[R0]
	LDR	R0,=ZPONOVI	;cas ponavljanja se je iztekel?
	LDR	R1,[R0]
	SUB	R1,R2,R1
	LDR	R3,=TPONOVI
	LDR	R3,[R3]
	CMP	R1,R3
	LDRCC	PC,[SP],#4
	LDR	R0,=TPREKLP	;cas slota se je iztekel?
	LDR	R1,[R0]
	SUB	R1,R2,R1
	LDR	R3,=TSLOT	
	LDR	R3,[R3]
	CMP	R1,R3
	LDRCC	PC,[SP],#4
	STR	R2,[R0]		;postavi novo casovno mejo
	LDR	R0,=HTPVMES	;cakajoce stevilke potrditev na oddajo?
	LDRH	R1,[R0]
	LDRH	R2,[R0,#2]
	CMP	R1,R2
	BNE	VKLOP
	LDR	R0,=HTXVMES	;cakajoci podatkovni okvirji na oddajo?
	LDRH	R1,[R0]
	LDRH	R2,[R0,#2]
	CMP	R1,R2
	BNE	VKLOP
	LDR	PC,[SP],#4
	ALIGN	16
PREKLO1	LDR	R0,=SPREKLP	;stanje oddaje v R0
	LDRB	R0,[R0]
	CMP	R0,#1		;stanje 1 - oddaja sinhronizacijske glave?
	BEQ	GLAVA
	CMP	R0,#2		;stanje 2 - poslji okvir v oddajo?
	BEQ	OKVIR
	CMP	R0,#3		;stanje 3 - cakanje konca okvirja?
	BEQ	KONEC
	B	REP		;stanje 4 (ali drugo) - oddaja repa za okvirjem!

;*** Vklop oddajnika v LPC2368/2387 *** (R0-2,SP+4)
	ALIGN	16
VKLOP	BL	PSEVNAK		;psevdonakljucno(16bit)
	MOV	R0,R0,LSR#16
	LDR	R1,=TECEN2	;pn(16bit)<>TECEN2 brez DCD?
	LDRH	R1,[R1]
	CMP	R0,R1
	BCC	VKLOP1
	LDR	R1,=0x3FFFC014	;FIO0PIN0 P0.5=/DCD?
	LDRB	R1,[R1]
	TST	R1,#0x20
	LDREQ	PC,[SP],#4
	LDR	R1,=TECEN1	;pn(16bit)<>TECEN1 z DCD?
	LDRH	R1,[R1]
	CMP	R0,R1
	LDRCS	PC,[SP],#4
VKLOP1	LDR	R0,=MPONOVI	;minimum ponavljanja?
	LDRB	R1,[R0]
	SUBS	R1,R1,#1
	STRB	R1,[R0]
	BMI	VKLOP2
	LDR	R0,=DPONOVI	;povecaj neizvedena ponavljanja
	LDRB	R1,[R0]
	ADD	R1,R1,#1
	STRB	R1,[R0]
	LDR	R0,=0xE0004008	;T0TC - Timer0
	LDR	R1,[R0]
	LDR	R0,=ZPONOVI	;zadnje ponavljanje
	STR	R1,[R0]
	LDR	PC,[SP],#4
VKLOP2	LDR	R0,=TABCRC	;resetiraj stevec oddajnika
	MOV	R1,#0
	STRH	R1,[R0,#HDLCSTX]
	LDR	R0,=0x3FFFC097	;FIO4PIN3 vklopi oddajnik
	MOV	R1,#0x00
	STRB	R1,[R0]
	MRS	R0,CPSR		;nacin FIQ in izklop FIQ+IRQ
	BIC	R0,R0,#0x0000001F
	ORR	R0,R0,#0x000000D1
	MSR	CPSR_c,R0	;popravi CPSR
	BL	SPROSTI		;sprosti sprejemni blok in zamenjaj z 0
	MRS	R0,CPSR		;nacin supervisor in vklop FIQ+IRQ
	BIC	R0,R0,#0x000000DF
	ORR	R0,R0,#0x00000013
	MSR	CPSR_c,R0	;popravi CPSR
	LDR	R0,=SPREKLP	;postavi stanje 1
	MOV	R1,#1
	STRB	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** Oddaja sinhronizacijske glave *** (R0-2,SP+4)
	ALIGN	16
GLAVA	LDR	R0,=0xE0004008	;T0TC - Timer0
	LDR	R2,[R0]
	LDR	R0,=TPREKLP	;cas glave se je iztekel?
	LDR	R1,[R0]
	SUB	R1,R2,R1
	LDR	R2,=TGLAVA
	LDR	R2,[R2]
	CMP	R1,R2
	LDRCC	PC,[SP],#4
	LDR	R0,=SPREKLP	;postavi stanje 2
	MOV	R1,#2
	STRB	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** Poslji okvir v oddajo *** (R0-2,R8,SP+4)+TIZPOKV
	ALIGN	16
OKVIR	LDR	R0,=HTPVMES	;stevilka potrditve iz vmesnika?
	BL	IZVMES
	MOVS	R1,R8
	BEQ	OKVIR1
	LDR	R8,=POTBLOK	;sestavi potrdilni okvir s CRCjem
	MOV	R0,#8		;dolzina 8
	STRH	R0,[R8]
	MOV	R0,#8		;zacetek 8
	STRH	R0,[R8,#2]
	STR	R1,[R8,#8]	;stevilka potrditve
	MOV	R0,#-1		;naslov VSEM=0xFFFFFFFF
	STR	R0,[R8,#12]
	BL	HDLCCRC
	LDR	R0,=BPREKLP	;vstavi niclo za sproscanje!!!!!!!!!!!
	MOV	R1,#0
	STR	R1,[R0]
	B	OKVIR2
OKVIR1	LDR	R0,=HTXVMES	;podatkovni okvir iz vmesnika?
	BL	IZVMES
	MOVS	R8,R8
	BEQ	IZKLOP		;izklop oddajnika
	LDR	R0,=BPREKLP	;shrani stevilko okvirja za sproscanje
	STR	R8,[R0]
	LDRB	R0,[R8,#5]	;izvajanje ponavljanja?
	LDR	R1,=DPONOVI
	LDRB	R1,[R1]
	SUB	R0,R0,R1	;odstej neizvedena ponavljanja
	SUBS	R0,R0,#1
	STRB	R0,[R8,#5]
	BMI	OKVIR2
	LDR	R0,=HTZVMES	;shrani v zacasni pomnilnik
	BL	VVMES
	LDR	PC,[SP],#4
OKVIR2	LDR	R0,=TABCRC	;poslji okvir v oddajnik
	LDRH	R1,[R8,#2]
	ADD	R1,R1,R8
	STR	R1,[R0,#HDLCKTX]
	LDRH	R1,[R8]
	STRH	R1,[R0,#HDLCSTX]
	BL	TIZPOKV		;prikazi vse oddane okvirje brez CRC?
	LDR	R0,=SPREKLP	;postavi stanje 3
	MOV	R1,#3
	STRB	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** Cakanje konca okvirja *** (R0-3,R8,SP+4)
	ALIGN	16
KONEC	LDR	R0,=TABCRC	;konec okvirja?
	LDRH	R1,[R0,#HDLCSTX]
	MOVS	R1,R1
	LDRNE	PC,[SP],#4
	LDR	R0,=0xE0004008	;T0TC - Timer0
	LDR	R1,[R0]
	LDR	R0,=TPREKLP	;casovna meja za oddajo repa
	STR	R1,[R0]
	LDR	R0,=SPREKLP	;postavi stanje 4
	MOV	R1,#4
	STRB	R1,[R0]
	LDR	R0,=BPREKLP	;shrani/sprosti oddani okvir?
	LDR	R8,[R0]
	MOVS	R8,R8		;neobstojec blok (potrditev)?
	LDREQ	PC,[SP],#4
	LDRB	R3,[R8,#4]	;odstej ponavljanja
	SUBS	R3,R3,#1
	STRB	R3,[R8,#4]
	BMI	KONEC1		;sprosti/SLIP, ko se stevec iztece?
	BL	PSEVNAK		;psevdonakljucno(20bit)
	MOV	R0,R0,LSR#12
	LDR	R1,=NPONOVI	;izracunaj zakasnitev ponavljanja
	LDRB	R1,[R1]
	SUBS	R1,R1,R3
	MOVMI	R1,#0
	MUL	R2,R1,R0
	MOV	R0,R2,LSR#19
	STRB	R0,[R8,#5]
	LDR	R0,=HTZVMES	;shrani v zacasni pomnilnik
	BL	VVMES
	LDR	PC,[SP],#4
	LTORG
KONEC1	LDR	R0,=MNASLOV	;KISS brez naslova?
	LDR	R0,[R0]
	MOVS	R0,R0
	BEQ	KONEC2
	LDR	R0,=LNASLOV	;lokalni naslovi vkljuceni?
	LDR	R0,[R0]
	MOVS	R0,R0
	BEQ	KONEC2
	LDRH	R0,[R8,#2]	;okvir VSEM na SLIP TX?
	ADD	R0,R0,#4
	LDR	R1,[R8,R0]
	MVNS	R0,R1
	BNE	KONEC2
	LDRH	R0,[R8]		;odrezi CRC
	SUB	R0,R0,#2
	STRH	R0,[R8]
	LDR	R0,=STXVMES	;okvir v SLIP oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
KONEC2	BL	SPROSTI		;KISS, izkljuceni lokalni, ni VSEM
	LDR	PC,[SP],#4
	LTORG

;*** Oddaja repa za okvirjem *** (R0-2,SP+4)
	ALIGN	16
REP	LDR	R0,=0xE0004008	;T0TC - Timer0, stanje 4 - oddaja repa?
	LDR	R2,[R0]
	LDR	R0,=TPREKLP	;cas repa se je iztekel?
	LDR	R1,[R0]
	SUB	R1,R2,R1
	LDR	R2,=TREP
	LDR	R2,[R2]
	CMP	R1,R2
	LDRCC	PC,[SP],#4
	LDR	R0,=SPREKLP	;postavi stanje 2
	MOV	R1,#2
	STRB	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** Izklop oddajnika v LPC2368/2387 *** (R0-3,R8,SP+4)
	ALIGN	16
IZKLOP	BL	PROSTO		;izracunaj primanjkljaj v R3
	LDR	R1,=MINBLOK
	LDRB	R3,[R1]
	SUB	R3,R0,R3
	SUB	R3,R3,#1
IZKLOP1	LDR	R0,=HTZVMES	;iz zacasnega vmesnika
	BL	IZVMES
	MOVS	R8,R8		;izklop, ko ni vec bloka
	BEQ	IZKLOP3
	ADDS	R3,R3,#1	;primanjkljaj se obstaja?
	BMI	IZKLOP2
	LDRB	R0,[R8,#5]	;poisci minimum ponavljanja
	LDR	R1,=MPONOVI
	LDRB	R2,[R1]
	CMP	R2,R0
	STRBCS	R0,[R1]
	LDR	R0,=HTXVMES	;v oddajni vmesnik
	BL	VVMES
	B	IZKLOP1
IZKLOP2	BL	SPROSTI		;sprosti odvecni blok
	B	IZKLOP1
IZKLOP3	LDR	R0,=0x3FFFC097	;FIO4PIN3 izklopi oddajnik
	MOV	R1,#0xFF
	STRB	R1,[R0]
	LDR	R0,=DPONOVI	;resetiraj neizvedena ponavljanja
	MOV	R1,#0
	STRB	R1,[R0]
	LDR	R0,=0xE0004008	;T0TC - Timer0
	LDR	R1,[R0]
	LDR	R0,=ZPONOVI	;zadnje ponavljanje
	STR	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** Prekinitev IRQ - SLIP sprejem UART1 *** (R12,sklad -16)
SLIPZAC	EQU	8	;zacetek podatkov
SLIPMIN	EQU	16	;min kazalec podatkov RX (8byte)
SLIPMAX	EQU	1616	;max kazalec podatkov RX (16byte rezerve)
	ALIGN	16
SLIPRX	STR	R0,[SP,#-4]!	;resi R0
	LDRB	R0,[R12,#ULSR]	;U1LSR - RDR napacni IRQ?
	TST	R0,#0x01
	BEQ	SLIPR11
	STR	R1,[SP,#-4]!	;resi R1
	STR	R8,[SP,#-4]!	;resi R8
	STR	LR,[SP,#-4]!	;resi link
	LDR	R0,=LNASLOV	;lokalni naslovi vkljuceni?
	LDR	R0,[R0]
	MOVS	R0,R0
	BEQ	WINSRX		;WIN SLIP sprejem UART1 (izhod IRQ)
	LDR	R1,=SLRXBLO	;SLRXBLO v R8
	LDR	R8,[R1]
	MOVS	R8,R8		;isci zacetek, ce ni sprejemnega bloka?
	BEQ	SLIPRX7
SLIPRX1	LDRB	R0,[R12,#URBR]	;U1RBR - precitaj znak v R0
	CMP	R0,#SLFEND	;znak FEND - konec SLIP okvirja?
	BEQ	SLIPRX4
	LDRH	R1,[R8,#2]	;preveri stanje=SLFESC iz [R8,#2]?
	CMP	R1,#SLFESC
	BEQ	SLIPRX3
	CMP	R0,#SLFESC	;znak FESC?
	STRHEQ	R0,[R8,#2]	;postavi stanje=SLFESC v [R8,#2]
	BEQ	SLIPRX9
SLIPRX2	LDRH	R1,[R8]		;prostor v vmesniku?
	CMP	R1,#SLIPMAX
	BCS	SLIPRX9
	STRB	R0,[R8,R1]	;shrani byte in povecaj kazalec
	ADD	R1,R1,#1
	STRH	R1,[R8]
	B	SLIPRX9
	ALIGN	16
SLIPRX3	MOV	R1,#SLFEND	;zamenjaj TFEND>FEND
	CMP	R0,#SLTFESC	;zamenjaj TFESC>FESC?
	MOVEQ	R1,#SLFESC
	MOV	R0,R1
	MOV	R1,#0		;postavi stanje=0 v [R8,#2]
	STRH	R1,[R8,#2]
	B	SLIPRX2
	ALIGN	16
SLIPRX4	LDRH	R0,[R8]		;sprejeti blok premajhen?
	CMP	R0,#SLIPMIN
	BCC	SLIPRX6
	SUB	R0,R0,#SLIPZAC	;odstej zacetek
	STRH	R0,[R8]
	MOV	R0,#SLIPZAC	;zapisi zacetek okvirja
	STRH	R0,[R8,#2]
	LDR	R0,=SRXVMES	;sprejeti okvir v vmesnik
	BL	VVMES
	MOV	R8,#0
	LDRB	R1,[R12,#ULSR]	;U1LSR - ReceiveDataReady?
	TST	R1,#0x01
	BEQ	SLIPR10
SLIPRX5	BL	DODELI		;dodeli nov sprejemni blok
	MOVS	R8,R8		;izprazni FIFO, ce ni bloka?
	BEQ	SLIPRX8
SLIPRX6	MOV	R0,#SLIPZAC	;kazalec na zacetek bloka
	STRH	R0,[R8]
	MOV	R0,#0		;postavi stanje=0 v [R8,#2]
	STRH	R0,[R8,#2]
	B	SLIPRX9
	ALIGN	16
SLIPRX7	LDRB	R0,[R12,#URBR]	;U1RBR - precitaj znak v R0
	CMP	R0,#SLFEND	;znak FEND - zacetek SLIP okvirja?
	BEQ	SLIPRX5
SLIPRX8	LDRB	R1,[R12,#ULSR]	;U1LSR - ReceiveDataReady?
	TST	R1,#0x01
	BEQ	SLIPR10
	B	SLIPRX7
	ALIGN	16
SLIPRX9	LDRB	R1,[R12,#ULSR]	;U1LSR - ReceiveDataReady?
	TST	R1,#0x01
	BNE	SLIPRX1
SLIPR10	LDR	LR,[SP],#4	;povrni link
	LDR	R0,=SLRXBLO	;R8 v SLRXBLO
	STR	R8,[R0]
	LDR	R8,[SP],#4	;povrni R8
	LDR	R1,[SP],#4	;povrni R1
	LDR	R0,[SP],#4	;povrni R0
	SUBS	PC,LR,#4	;izhod iz prekinitve IRQ
	ALIGN	16
SLIPR11	LDRB	R0,[R12,#URBR]	;U1RBR - precitaj v prazno napacni IRQ
	LDR	R0,[SP],#4	;povrni R0
	SUBS	PC,LR,#4	;izhod iz prekinitve IRQ
	LTORG

;*** WIN SLIP sprejem UART1 (izhod IRQ) *** (R12,sklad -16)
WINSZAC	EQU	100	;zacetek podatkov
WINSMIN	EQU	108	;min kazalec podatkov RX (8byte)
WINSMAX	EQU	1616	;max kazalec podatkov RX (16byte rezerve)
	ALIGN	16
WINSRX	LDR	R0,=0xE0004008	;T0TC - Timer0
	LDR	R0,[R0]
	LDR	R8,=SLRXTIM	;casovna razlika v R0
	SWP	R1,R0,[R8]
	SUB	R0,R0,R1
	LDR	R8,=SLRXBLO	;SLRXBLO v R8
	LDR	R8,[R8]
	MOVS	R8,R8		;dodeli, ce ni sprejemnega bloka?
	BEQ	WINSRX6
	LDR	R1,=TIMEOUT	;cas se je iztekel?
	LDR	R1,[R1]
	CMP	R0,R1
	BCS	WINSRX7		;kazalec na zacetek in stanje=0
WINSRX1	LDRB	R0,[R12,#URBR]	;U1RBR - precitaj znak v R0
	CMP	R0,#SLFEND	;znak FEND - konec SLIP okvirja?
	BEQ	WINSRX5
	LDRH	R1,[R8,#2]	;preveri stanje=SLFESC iz [R8,#2]?
	CMP	R1,#SLFESC
	BEQ	WINSRX4
	CMP	R0,#SLFESC	;znak FESC?
	STRHEQ	R0,[R8,#2]	;postavi stanje=SLFESC v [R8,#2]
	BEQ	WINSRX9
WINSRX2	LDRH	R1,[R8]		;prostor v vmesniku?
	CMP	R1,#WINSMAX
	BCS	WINSRX9
	STRB	R0,[R8,R1]	;shrani byte in povecaj kazalec
	ADD	R1,R1,#1
	STRH	R1,[R8]
	CMP	R0,#13		;<CR> konec ukaza std-win modema?
	BNE	WINSRX9
	MOV	R1,#WINSZAC	;prvi znak okvirja "A"?
	LDRB	R0,[R8,R1]
	CMP	R0,#"A"
	BNE	WINSRX9
	ADD	R1,R1,#1	;drugi znak okvirja "T"?
	LDRB	R0,[R8,R1]	
	CMP	R0,#"T"
	BNE	WINSRX9
	ADD	R1,R1,#1	;tretji znak okvirja "D"?
	LDRB	R0,[R8,R1]
	CMP	R0,#"D"
	BNE	WINSRX3
	MOV	R0,#WINSZAC	;brisi vsebino okvirja
	STRH	R0,[R8]
	MOV	R0,#"C"		;U1THR - odgovori "CONNECT<CR>"
	STRB	R0,[R12,#UTHR]
	MOV	R0,#"O"
	STRB	R0,[R12,#UTHR]
	MOV	R0,#"N"
	STRB	R0,[R12,#UTHR]
	MOV	R0,#"N"
	STRB	R0,[R12,#UTHR]
	MOV	R0,#"E"
	STRB	R0,[R12,#UTHR]
	MOV	R0,#"C"
	STRB	R0,[R12,#UTHR]
	MOV	R0,#"T"
	STRB	R0,[R12,#UTHR]
	MOV	R0,#13
	STRB	R0,[R12,#UTHR]
	B	WINSRX9
WINSRX3	MOV	R0,#WINSZAC	;brisi vsebino okvirja
	STRH	R0,[R8]
	MOV	R0,#"O"		;U1THR - odgovori "OK<CR>"
	STRB	R0,[R12,#UTHR]
	MOV	R0,#"K"
	STRB	R0,[R12,#UTHR]
	MOV	R0,#13
	STRB	R0,[R12,#UTHR]
	B	WINSRX9
	ALIGN	16
WINSRX4	MOV	R1,#SLFEND	;zamenjaj TFEND>FEND
	CMP	R0,#SLTFESC	;zamenjaj TFESC>FESC?
	MOVEQ	R1,#SLFESC
	MOV	R0,R1
	MOV	R1,#0		;postavi stanje=0 v [R8,#2]
	STRH	R1,[R8,#2]
	B	WINSRX2
	ALIGN	16
WINSRX5	LDRH	R0,[R8]		;sprejeti blok premajhen?
	CMP	R0,#WINSMIN
	BCC	WINSRX7
	SUB	R0,R0,#WINSZAC	;odstej zacetek
	STRH	R0,[R8]
	MOV	R0,#WINSZAC	;zapisi zacetek okvirja
	STRH	R0,[R8,#2]
	LDR	R0,=SRXVMES	;sprejeti okvir v vmesnik
	BL	VVMES
	MOV	R8,#0
	LDRB	R1,[R12,#ULSR]	;U1LSR - ReceiveDataReady?
	TST	R1,#0x01
	BEQ	WINSR10
WINSRX6	BL	DODELI		;dodeli nov sprejemni blok
	MOVS	R8,R8		;izprazni FIFO, ce ni bloka?
	BEQ	WINSRX8
WINSRX7	MOV	R0,#WINSZAC	;kazalec na zacetek bloka
	STRH	R0,[R8]
	MOV	R0,#0		;postavi stanje=0 v [R8,#2]
	STRH	R0,[R8,#2]
	B	WINSRX9
	ALIGN	16
WINSRX8	LDRB	R1,[R12,#ULSR]	;U1LSR - ReceiveDataReady?
	TST	R1,#0x01
	BEQ	WINSR10
	LDRB	R0,[R12,#URBR]	;U1RBR - precitaj znak v R0
	B	WINSRX8
	ALIGN	16
WINSRX9	LDRB	R1,[R12,#ULSR]	;U1LSR - ReceiveDataReady?
	TST	R1,#0x01
	BNE	WINSRX1
WINSR10	LDR	LR,[SP],#4	;povrni link
	LDR	R0,=SLRXBLO	;R8 v SLRXBLO
	STR	R8,[R0]
	LDR	R8,[SP],#4	;povrni R8
	LDR	R1,[SP],#4	;povrni R1
	LDR	R0,[SP],#4	;povrni R0
	SUBS	PC,LR,#4	;izhod iz prekinitve IRQ
	LTORG

;*** Oddaja SLIP okvirja na UART1 *** (R0-8,R12)
SLFEND	EQU	0xC0	;FEND
SLFESC	EQU	0xDB	;FESC
SLTFEND	EQU	0xDC	;TFEND
SLTFESC	EQU	0xDD	;TFESC
MAXFIFO	EQU	16	;dolzina TX FIFO
	ALIGN	16
SLIPTX	LDRB	R0,[R12,#ULSR]	;U1LSR bit5=TxHoldingRegisterEmpty?
	TST	R0,#0x20
	BXEQ	LR
	STR	LR,[SP,#-4]!
	MOV	R4,#MAXFIFO
	LDR	R0,=SLTXSTA	;SLTXSTA v R6
	LDRB	R6,[R0]
	LDR	R0,=SLTXKAZ	;SLTXKAZ v R7
	LDRH	R7,[R0]
	LDR	R0,=SLTXBLO	;SLTXBLO v R8
	LDR	R8,[R0]
	BL	SLIPTX1
	LDR	R0,=SLTXBLO	;R8 v SLTXBLO
	STR	R8,[R0]
	LDR	R0,=SLTXKAZ	;R7 v SLTXKAZ
	STRH	R7,[R0]
	LDR	R0,=SLTXSTA	;R6 v SLTXSTA
	STRB	R6,[R0]
	LDR	PC,[SP],#4
	LTORG
	ALIGN	16
SLIPTX1	SUBS	R4,R4,#1	;stej znake v FIFO?
	BXMI	LR
	CMP	R6,#1		;stanje=1 - oddaja vsebine?
	BNE	SLIPTX5
	LDRH	R0,[R8]		;konec podatkov?
	CMP	R7,R0
	BCS	SLIPTX2
	LDRH	R0,[R8,#2]	;precitaj znak v R1
	ADD	R0,R0,R7
	LDRB	R1,[R8,R0]
	ADD	R7,R7,#1	;povecaj kazalec
	CMP	R1,#SLFESC	;znak FESC?
	BEQ	SLIPTX3
	CMP	R1,#SLFEND	;znak FEND?
	BEQ	SLIPTX4
	STRB	R1,[R12,#UTHR]	;oddaj znak v U1THR
	B	SLIPTX1
SLIPTX2	MOV	R0,#SLFEND	;oddaj FEND na koncu v U1THR
	STRB	R0,[R12,#UTHR]
	STR	LR,[SP,#-4]!
	LDR	R0,=MNASLOV	;moj naslov in lokalno vkljucena?
	LDR	R1,[R0]
	LDR	R0,=LNASLOV
	LDR	R0,[R0]
	MOVS	R1,R1
	MOVEQ	R0,#0
	MOVS	R0,R0
	BLNE	SIZPOKV		;prikazi vse lokalno oddane okvirje?
	BL	SPROSTI		;sprosti oddani blok
	LDR	LR,[SP],#4
	MOV	R6,#0		;postavi stanje=0 cakanje
	BX	LR
SLIPTX3	MOV	R0,#SLFESC	;oddaj FESC v U1THR
	STRB	R0,[R12,#UTHR]
	MOV	R6,#2		;postavi stanje=2 oddaja TFESC
	B	SLIPTX1
SLIPTX4	MOV	R0,#SLFESC	;oddaj FESC v U1THR
	STRB	R0,[R12,#UTHR]
	MOV	R6,#3		;postavi stanje=3 oddaja TFEND
	B	SLIPTX1
SLIPTX5	CMP	R6,#2		;stanje=2 - oddaja TFESC?
	BNE	SLIPTX6
	MOV	R0,#SLTFESC	;oddaj TFESC v U1THR
	STRB	R0,[R12,#UTHR]
	MOV	R6,#1		;postavi stanje=1 oddaja vsebine
	B	SLIPTX1
SLIPTX6	CMP	R6,#3		;stanje=3 - oddaja TFEND?
	BNE	SLIPTX7
	MOV	R0,#SLTFEND	;oddaj TFEND v U1THR
	STRB	R0,[R12,#UTHR]
	MOV	R6,#1		;postavi stanje=1 oddaja vsebine
	B	SLIPTX1
SLIPTX7	STR	LR,[SP,#-4]!	;nov blok - stanje=0 - cakanje?
	LDR	R0,=STXVMES
	BL	IZVMES
	LDR	LR,[SP],#4
	MOVS	R8,R8		;bloka ni?
	BXEQ	LR
	MOV	R7,#0		;kazalec na 0
	MOV	R0,#SLFEND	;oddaj FEND na zacetku v U1THR
	STRB	R0,[R12,#UTHR]
	MOV	R6,#1		;postavi stanje=1 oddaja vsebine
	B	SLIPTX1
	LTORG

;*** Inicializiraj UART1 *** (R0-1,R12)
UDLL	EQU	0x00
UTHR	EQU	0x00
URBR	EQU	0x00
UDLM	EQU	0x04
UIER	EQU	0x04
UFCR	EQU	0x08
ULCR	EQU	0x0C
ULSR	EQU	0x14
UART1	STR	LR,[SP,#-4]!
	LDR	R12,=0xE0010000 ;osnovni naslov UART1 v R12
	MOV	R0,#0x83	;U1LCR=0x83 DLAB=1,no-parity,1stop,8bit
	STRB	R0,[R12,#ULCR]
	LDR	R0,=BAUDMOD	;baudrate modulo (16bit)
	LDRH	R0,[R0]
	STRB	R0,[R12,#UDLL]	;U1DLL
	MOV	R0,R0,LSR#8	;U1DLM
	STRB	R0,[R12,#UDLM]
	MOV	R0,#0x81	;U1FCR=0x81 RXtrig=8bit,FIFOenable
	STRB	R0,[R12,#UFCR]
	MOV	R0,#0x03	;U1LCR=0x03 DLAB=0,no-parity,1stop,8bit
	STRB	R0,[R12,#ULCR]
	MOV	R0,#0x01	;U1IER=0x01 ReceiveDataAvailable
	STRB	R0,[R12,#UIER]
	LDR	R0,=SLTXSTA	;zacetno stanje SLIP TX
	MOV	R1,#0
	STRB	R1,[R0]
	LDR	R0,=SLRXBLO	;neobsotjeci zacetni blok 0 za SLIP RX
	MOV	R1,#0
	STR	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** Sprejem Ethernet okvirjev *** (R0-6)+ETHIP/ETHARP
ERXMAX	EQU	1529		;max dolzina GLAVA+1512byte+CRC-1
	ALIGN	16
ETHRX	LDR	R0,=0xFFE00FE0	;IntStatus RxDoneInt=?
	LDR	R0,[R0]
	TST	R0,#0x0008
	BXEQ	LR
	LDR	R0,=0xFFE00FE8	;IntClear RxDoneInt
	MOV	R1,#0x0008
	STR	R1,[R0]
ETHRX1	LDR	R0,=0xFFE00114	;RxProduceIndex primerjaj z
	LDR	R1,[R0]
	LDR	R0,=0xFFE00118	;RxConsumeIndex v R2
	LDR	R2,[R0]
	CMP	R2,R1		;nov Ethernet okvir?
	BXEQ	LR
	STR	LR,[SP,#-4]!	;resi link
	BL	ETHRX2		;obdelaj okvir
	LDR	R0,=0xFFE00118	;RxConsumeIndex povecaj za 1
	LDR	R1,[R0]
	ADD	R1,R1,#1
	RSBS	R2,R1,#RXDESCN	;preveri gornjo mejo
	MOVCC	R1,#0
	STR	R1,[R0]
	LDR	LR,[SP],#4
	B	ETHRX1		;takoj naslednji okvir?
	LTORG
ETHRX2	STR	LR,[SP,#-4]!	;resi link
	LDR	R0,=RXSTAT	;RX status v R6
	LDR	R6,[R0,R2,LSL#3]
	TST	R6,#0x11800000	;preveri Overrun, SymbolError in CRCError?
	LDRNE	PC,[SP],#4
	LDR	R0,=0x7FF	;dolzina-1 v R6
	AND	R6,R6,R0
	LDR	R0,=ERXMAX	;preveri dolzino-1
	CMP	R6,R0
	MOVCS	R6,R0
	LDR	R0,=RXDESC	;zacetek sprejetega bloka v R5
	LDR	R5,[R0,R2,LSL#3]
	ADD	R1,R5,#6	;zapomni si sogovornikov MAC
	LDR	R2,=MACMAC
	MOV	R3,#6
ETHRX3	LDRB	R0,[R1],#1
	STRB	R0,[R2],#1
	SUBS	R3,R3,#1
	BNE	ETHRX3
	LDR	R0,=LNASLOV	;Ethernet vkljucen (L<>0)?
	LDR	R0,[R0]
	MOVS	R0,R0
	LDREQ	PC,[SP],#4
	LDRB	R0,[R5,#12]	;preveri IP4 ali ARP?
	CMP	R0,#0x08
	LDRNE	PC,[SP],#4
	LDRB	R0,[R5,#13]	;preveri IP4?
	CMP	R0,#0x00
	BEQ	ETHIP
	LDRB	R0,[R5,#13]	;preveri ARP?
	CMP	R0,#0x06
	BEQ	ETHARP
	LDR	PC,[SP],#4
	LTORG

;*** Obdelava Ethernet IP4 okvirjev (R5,R6) *** (R0-6,R8,SP+4)+IPODDAJ
	MACRO
	ERXKOP
	LDR	R0,[R2],#4	;4
	STR	R0,[R1],#4
	LDR	R0,[R2],#4	;8
	STR	R0,[R1],#4
	LDR	R0,[R2],#4	;12
	STR	R0,[R1],#4
	MEND
ETHIP	BL	DODELI		;sprejemni blok obstaja?
	MOVS	R8,R8
	BNE	ETHIP1
	LDR	PC,[SP],#4
ETHIP1	MOV	R0,#WINSZAC	;zacetek ponora v blok in R1
	STRH	R0,[R8,#2]
	ADD	R1,R8,R0
	SUBS	R0,R6,#17	;preverjena dolzina v blok
	MOVMI	R0,#0
	STRH	R0,[R8]
	ADD	R2,R5,#14	;odrezi glavo
	SUB	R3,R6,#18	;max vsebina 1512byte=42*36byte
ETHIP2	;;;;;;;;;;;;;;;;;;;;;;;;;prepisi vsebino po 36byte
	ERXKOP	;12
	ERXKOP	;24
	ERXKOP	;36
	SUBS	R3,R3,#36
	BPL	ETHIP2
	LDR	R0,=MNASLOV	;brez naslova Ethernet >>> SLIP?
	LDR	R0,[R0]
	MOVS	R0,R0
	BNE	IPODDAJ		;oddaja IP okvirjev
	LDR	R0,=STXVMES	;okvir v SLIP oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
	LTORG

;*** Obdelava Ethernet ARP okvirjev (R5) *** (R0-5,R8,SP+4)+ETHTX
ARPOP	EQU	21	;Operation (byte) 1=vprasanje, 2=odgovor
ARPSHA	EQU	22	;Sender Hardware Address
ARPSPA	EQU	28	;Sender Protocol Address
ARPTHA	EQU	32	;Target Hardware Address
ARPTPA	EQU	38	;Target Protocol Address
ETHARP	LDRB	R0,[R5,#ARPOP]	;ARP vprasanje/odgovor?
	CMP	R0,#1
	BNE	ETHARP7
	MOV	R4,#0		;ARP vprasanje v ARP cache
	BL	VCACHE
	ADD	R0,R5,#ARPSPA	;IP izprasevalca v R2
	LDRB	R2,[R0],#1
	LDRB	R1,[R0],#1
	ORR	R2,R1,R2,ROR#8
	LDRB	R1,[R0],#1
	ORR	R2,R1,R2,ROR#8
	LDRB	R1,[R0],#1
	ORR	R2,R1,R2,ROR#8
	MOV	R2,R2,ROR#8
	ADD	R0,R5,#ARPTPA	;ciljni IP v R3
	LDRB	R3,[R0],#1
	LDRB	R1,[R0],#1
	ORR	R3,R1,R3,ROR#8
	LDRB	R1,[R0],#1
	ORR	R3,R1,R3,ROR#8
	LDRB	R1,[R0],#1
	ORR	R3,R1,R3,ROR#8
	MOV	R3,R3,ROR#8
	CMP	R2,R3		;izloci enake IPje?
	LDREQ	PC,[SP],#4
	LDR	R0,=DOMENA	;primerjava z IP domeno
	LDR	R1,[R0],#4
	EOR	R1,R1,R3
	LDR	R2,[R0],#4	;maska sprejmi?
	TST	R1,R2
	LDRNE	PC,[SP],#4
	LDR	R2,[R0],#4	;maska zavrni?
	TST	R1,R2
	LDREQ	PC,[SP],#4
	BL	ETOBCW		;oddajni blok (R2), control word (R0)
	LDR	R1,=0xF4000029	;Int,Last,CRC,Pad,Override,dolzina=42-1
	STR	R1,[R0]
	ADD	R0,R5,#ARPSHA	;MAC izprasevalca
	MOV	R1,#6
ETHARP1	LDRB	R3,[R0],#1
	STRB	R3,[R2],#1
	SUBS	R1,R1,#1
	BNE	ETHARP1
	LDR	R0,=ETHMAC	;lastni MAC
	MOV	R1,#6
ETHARP2	LDRB	R3,[R0],#1
	STRB	R3,[R2],#1
	SUBS	R1,R1,#1
	BNE	ETHARP2
	MOV	R0,#0x08	;type=0x0806 ARP
	STRB	R0,[R2],#1
	MOV	R0,#0x06
	STRB	R0,[R2],#1
	MOV	R0,#0x00	;hardware=0x0001 Ethernet
	STRB	R0,[R2],#1
	MOV	R0,#0x01
	STRB	R0,[R2],#1
	MOV	R0,#0x08	;IP4=0x0800
	STRB	R0,[R2],#1
	MOV	R0,#0x00
	STRB	R0,[R2],#1
	MOV	R0,#0x06	;HLEN=0x06 Ethernet
	STRB	R0,[R2],#1
	MOV	R0,#0x04	;PLEN=0x04 IP
	STRB	R0,[R2],#1
	MOV	R0,#0x00	;OPER=0x0002 odgovor
	STRB	R0,[R2],#1
	MOV	R0,#0x02
	STRB	R0,[R2],#1
	LDR	R0,=ETHMAC	;SHA=lastni MAC
	MOV	R1,#6
ETHARP3	LDRB	R3,[R0],#1
	STRB	R3,[R2],#1
	SUBS	R1,R1,#1
	BNE	ETHARP3
	ADD	R0,R5,#ARPTPA	;SPA=ciljni IP
	MOV	R1,#4
ETHARP4	LDRB	R3,[R0],#1
	STRB	R3,[R2],#1
	SUBS	R1,R1,#1
	BNE	ETHARP4
	ADD	R0,R5,#ARPSHA	;THA=MAC izprasevalca
	MOV	R1,#6
ETHARP5	LDRB	R3,[R0],#1
	STRB	R3,[R2],#1
	SUBS	R1,R1,#1
	BNE	ETHARP5
	ADD	R0,R5,#ARPSPA	;TPA=IP izprasevalca
	MOV	R1,#4
ETHARP6	LDRB	R3,[R0],#1
	STRB	R3,[R2],#1
	SUBS	R1,R1,#1
	BNE	ETHARP6
	B	ETXTPI		;TxProduceIndex povecaj za 1
	LTORG
ETHARP7	LDR	R0,=ETXBLOK	;ARP odgovor >>> obstaja ETXBLOK?
	LDR	R8,[R0]
	MOVS	R8,R8
	BEQ	ETHARP9		;nepoklicani (zamujeni) ARP v cache
	ADD	R0,R8,#4	;ARP IP4 cilj iz ETXBLOK
	ADD	R1,R5,#ARPSPA	;IP naslovnika ARPodgovor>(R1)
	MOV	R2,#4
ETHARP8	LDRB	R3,[R0],#1
	LDRB	R4,[R1],#1
	CMP	R4,R3		;neenaka IPja?
	BNE	ETHARP9		;nepoklicani (zamujeni) ARP v cache
	SUBS	R2,R2,#1
	BNE	ETHARP8
	LDR	R4,=ARPCAS	;izracunaj odzivni cas ARP v R4
	LDR	R4,[R4]
	LDR	R0,=0xE0004008	;T0TC - Timer0
	LDR	R0,[R0]
	SUB	R4,R0,R4
	BL	VCACHE		;ARP podatki (R5), odziv R4 v ARP cache
	LDR	R0,=ETXBLOK	;brisi obstojeci ETXBLOK
	MOV	R1,#0
	STR	R1,[R0]
	ADD	R5,R5,#ARPSHA	;oddaj blok (R8) na ARP odgovor
	B	ETHTX
	LTORG
ETHARP9	LDR	R0,=TIMEOUT	;nepoklicani ARP v cache
	LDR	R4,[R0]
	BL	VCACHE		;ARP podatki (R5), odziv R4 v ARP cache
	LDR	PC,[SP],#4
	LTORG

;*** Oddajni blok (R2), control word (R0) *** (R0-2)
ETOBCW	LDR	R0,=0xFFE00128	;TxProduceIndex v R1
	LDR	R1,[R0]
	LDR	R0,=0xFFE0012C	;TxConsumeIndex
	LDR	R0,[R0]
	CMP	R1,R0		;oddajnik prazen?
	BNE	ETOBCW
	LDR	R0,=TXDESC	;TxDescriptor
	ADD	R0,R0,R1,LSL#3
	LDR	R2,[R0],#4	;oddajni blok (R2), control word (R0)
	BX	LR
	LTORG

;*** TxProduceIndex povecaj za 1 *** (R0-2,SP+4)
ETXTPI	LDR	R0,=0xFFE00128	;TxProduceIndex
	LDR	R1,[R0]
	ADD	R1,R1,#1
	RSBS	R2,R1,#TXDESCN	;preveri gornjo mejo
	MOVCC	R1,#0
	STR	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** ARP podatki (R5), odziv R4 v ARP cache *** (R0-5)
VCACHE	LDR	R0,=KCACHE	;povecaj in preveri kazalec EthernetARP cache
	LDR	R1,[R0]
	ADD	R1,R1,#1
	CMP	R1,#MCACHE
	MOVCS	R1,#0
	STR	R1,[R0]
	LDR	R0,=ECACHE	;izracunaj naslov ECACHE v R0
	ADD	R0,R0,R1,LSL#4
	ADD	R1,R5,#ARPSPA	;IP v ECACHE
	MOV	R2,#4
VCACHE1	LDRB	R3,[R1],#1
	STRB	R3,[R0],#1
	SUBS	R2,R2,#1
	BNE	VCACHE1
	ADD	R1,R5,#ARPSHA	;MAC v ECACHE
	MOV	R2,#6
VCACHE2	LDRB	R3,[R1],#1
	STRB	R3,[R0],#1
	SUBS	R2,R2,#1
	BNE	VCACHE2
	LDR	R1,=TCACHE	;trajanje v ECACHE
	LDRH	R1,[R1]
	STRH	R1,[R0],#2
	STR	R4,[R0],#4	;odzivni cas ARP v ECACHE
	BX	LR
	LTORG

;*** Oddaj blok (R8) na MAC(R5) *** (R0-5,R8,SP+4)
ETXMAX	EQU	1511		;max dolzina 1512byte-1
	MACRO
	ETXKOP
	LDR	R1,[R3],#4	;4
	STR	R1,[R2],#4
	LDR	R1,[R3],#4	;8
	STR	R1,[R2],#4
	LDR	R1,[R3],#4	;12
	STR	R1,[R2],#4
	MEND
ETHTX	BL	ETOBCW		;oddajni blok (R2), control word (R0)
	LDRH	R4,[R8]		;dolzina-1 v R4
	SUB	R4,R4,#1
	LDR	R3,=ETXMAX	;preveri dolzino 1512byte-1=42*36byte-1
	CMP	R4,R3
	MOVCS	R4,R3
	ADD	R3,R4,#14	;dodaj glavo in Int,Last,CRC,Pad,Override
	ORR	R3,R3,#0xF4000000
	STR	R3,[R0]
	MOV	R0,#6		;naslovnikov MAC(R5)
ETHTX1	LDRB	R1,[R5],#1
	STRB	R1,[R2],#1
	SUBS	R0,R0,#1
	BNE	ETHTX1
	LDR	R3,=ETHMAC	;lastni MAC v posiljatelja
	MOV	R0,#6
ETHTX2	LDRB	R1,[R3],#1
	STRB	R1,[R2],#1
	SUBS	R0,R0,#1
	BNE	ETHTX2
	MOV	R1,#8		;oznaka Ethernet IP4 0x08,0x00
	STRB	R1,[R2],#1
	MOV	R1,#0
	STRB	R1,[R2],#1
	LDRH	R3,[R8,#2]
	ADD	R3,R3,R8
ETHTX3	;;;;;;;;;;;;;;;;;;;;;;;;;prepisi vsebino po 36byte
	ETXKOP	;12
	ETXKOP	;24
	ETXKOP	;36
	SUBS	R4,R4,#36
	BPL	ETHTX3
	BL	SPROSTI		;sprosti blok prepisanega okvirja
	B	ETXTPI		;TxProduceIndex povecaj za 1
	LTORG

;*** Ethernet oddaja IP okvirjev z/brez ARP *** (R0-6,R8)
	ALIGN	16
EODDAJ	STR	LR,[SP,#-4]!	;resi link
	LDR	R0,=ETXBLOK	;cakajoci ETXBLOK na ARP?
	LDR	R8,[R0]
	MOVS	R8,R8
	BNE	EODDAJ9
	LDR	R0,=ETXVMES	;ETH TX vmesnik prazen?
	BL	IZVMES
	MOVS	R8,R8
	LDREQ	PC,[SP],#4
	LDRH	R0,[R8] 	;najmanjsa dolzina IP4 okvirja?
	CMP	R0,#MINIP4
	BCC	EODDAJ0
	LDRH	R0,[R8,#2]	;prvi znak IP4 okvirja?
	LDRB	R0,[R8,R0]
	CMP	R0,#IP4MIN
	BCC	EODDAJ0
	CMP	R0,#IP4MAX
	BCS	EODDAJ0
	LDRH	R0,[R8,#2]	;iskani naslovnikov IP v R6
	ADD	R0,R0,R8
	LDR	R6,[R0,#IPCILJ]
	LDR	R0,=GATEWAY	;privzeti prehod R1 in maska R2
	LDR	R1,[R0],#4
	LDR	R2,[R0],#4
	EOR	R0,R1,R6	;primerjaj s privzetim prehodom/maska
	TST	R0,R2
	MOVNE	R6,R1		;zamenjaj IP naslovnika s prehodom?
	STR	R6,[R8,#4]	;ARP IP4 cilj v ETXBLOK
	LDR	R2,=ECACHE	;poisci veljaven vpis v ECACHE
	LDR	R0,=KCACHE	;kazalec v R3
	LDR	R3,[R0]
	MOV	R4,#MCACHE
EODDAJ1	CMP	R3,#MCACHE	;preveri kazalec, naslov v R5
	MOVCS	R3,#MCACHE
	SUBCS	R3,R3,#1
	ADD	R5,R2,R3,LSL#4
	LDRH	R0,[R5,#10]	;veljaven vpis?
	MOVS	R0,R0
	BEQ	EODDAJ2
	LDR	R0,[R5],#4	;enaki IPji?
	CMP	R0,R6	
	BEQ	ETHTX		;takoj oddaj okvir (R8) brez ARP!
	SUB	R3,R3,#1
	SUBS	R4,R4,#1
	BNE	EODDAJ1
EODDAJ2	LDR	R0,=ETXBLOK	;okvir (R8) v ETXBLOK, sestavi ARP vprasanje
	STR	R8,[R0]
	BL	ETOBCW		;oddajni blok (R2), control word (R0)
	LDR	R1,=0xF4000029	;CW=Int,Last,CRC,Pad,Override,dolzina=42-1
	STR	R1,[R0]
	MOV	R0,#255		;naslovnik VSEM
	MOV	R1,#6
EODDAJ3	STRB	R0,[R2],#1
	SUBS	R1,R1,#1
	BNE	EODDAJ3
	LDR	R0,=ETHMAC	;lastni MAC
	MOV	R1,#6
EODDAJ4	LDRB	R3,[R0],#1
	STRB	R3,[R2],#1
	SUBS	R1,R1,#1
	BNE	EODDAJ4
	MOV	R0,#0x08	;type=0x0806 ARP
	STRB	R0,[R2],#1
	MOV	R0,#0x06
	STRB	R0,[R2],#1
	MOV	R0,#0x00	;hardware=0x0001 Ethernet
	STRB	R0,[R2],#1
	MOV	R0,#0x01
	STRB	R0,[R2],#1
	MOV	R0,#0x08	;IP4=0x0800
	STRB	R0,[R2],#1
	MOV	R0,#0x00
	STRB	R0,[R2],#1
	MOV	R0,#0x06	;HLEN=0x06 Ethernet
	STRB	R0,[R2],#1
	MOV	R0,#0x04	;PLEN=0x04 IP
	STRB	R0,[R2],#1
	MOV	R0,#0x00	;OPER=0x0001 vprasanje
	STRB	R0,[R2],#1
	MOV	R0,#0x01
	STRB	R0,[R2],#1
	LDR	R0,=ETHMAC	;SHA=lastni MAC
	MOV	R1,#6
EODDAJ5	LDRB	R3,[R0],#1
	STRB	R3,[R2],#1
	SUBS	R1,R1,#1
	BNE	EODDAJ5
	LDRH	R0,[R8,#2]	;SPA=IP izprasevalca 
	ADD	R0,R0,R8
	ADD	R0,R0,#IPIZVOR
	MOV	R1,#4
EODDAJ6	LDRB	R3,[R0],#1
	STRB	R3,[R2],#1
	SUBS	R1,R1,#1
	BNE	EODDAJ6
	MOV	R0,#0		;THA=0
	MOV	R1,#6
EODDAJ7	STRB	R0,[R2],#1
	SUBS	R1,R1,#1
	BNE	EODDAJ7
	MOV	R1,#4		;TPA=IP naslovnika/prehoda iz R6
EODDAJ8	STRB	R6,[R2],#1
	MOV	R6,R6,ROR#8
	SUBS	R1,R1,#1
	BNE	EODDAJ8
	LDR	R0,=0xE0004008	;T0TC - Timer0 v cas ARP vprasanja
	LDR	R1,[R0]
	LDR	R0,=ARPCAS
	STR	R1,[R0]
	B	ETXTPI		;TxProduceIndex povecaj za 1
	LTORG
EODDAJ0	BL	SPROSTI		;sprosti okvir, ki ni IP4
	LDR	PC,[SP],#4
	ALIGN	16
EODDAJ9	LDR	R0,=ARPCAS	;brez ARP preveri cas oddaje
	LDR	R1,[R0]
	LDR	R0,=0xE0004008	;T0TC - Timer0
	LDR	R0,[R0]
	SUB	R1,R0,R1
	LDR	R0,=TIMEOUT	;primerjaj s casovno mejo?
	LDR	R0,[R0]
	CMP	R1,R0
	LDRCC	PC,[SP],#4
	LDR	R0,=ETXBLOK	;brisi obstojeci ETXBLOK
	MOV	R1,#0
	STR	R1,[R0]
	BL	SPROSTI		;sprosti okvir brez MAC naslova
	LDR	PC,[SP],#4
	LTORG

;*** Inicializiraj Ethernet v LPC2368/2387 *** (R0-3)
INIETH	STR	LR,[SP,#-4]!	;resi link
;Remove the soft reset condition from the MAC
	LDR	R0,=0xFFE00000	;MAC1=0 remove soft reset
	MOV	R1,#0
	STR	R1,[R0]
;Configure the PHY via the MIIM interface of the MAC
	LDR	R0,=0xFFE00020	;MCFG=0x18 (nastavi CLK/20)
	MOV	R1,#0x18
	STR	R1,[R0]
	BL	INIPHY		;inicializiraj PHY DP83848C
;Select RMII mode
	LDR	R0,=0xFFE00100	;Command=RMII
	LDR	R1,=0x0200
	STR	R1,[R0]
;Configure the transmit and receive DMA engines, including the descriptor arrays
	BL	ETHRAM		;razrezi Ethernet RAM
	LDR	R0,=0xFFE00108	;RxDescriptor
	LDR	R1,=RXDESC
	STR	R1,[R0]
	LDR	R0,=0xFFE0010C	;RxStatus
	LDR	R1,=RXSTAT
	STR	R1,[R0]
	LDR	R0,=0xFFE00110	;RxDescriptorNumer
	MOV	R1,#RXDESCN
	STR	R1,[R0]
	LDR	R0,=0xFFE0011C	;TxDescriptor 
	LDR	R1,=TXDESC
	STR	R1,[R0]
	LDR	R0,=0xFFE00120	;TxStatus
	LDR	R1,=TXSTAT
	STR	R1,[R0]
	LDR	R0,=0xFFE00124	;TxDescriptorNumber
	MOV	R1,#TXDESCN
	STR	R1,[R0]
;Configure the host registers (MAC1,MAC2 etc.) in the MAC
	LDR	R0,=ETHMAC	;Ethernet MAC naslov
	LDR	R1,=0xFFE00048	;Station Address 2 Register
	LDRB	R2,[R0],#1
	LDRB	R3,[R0],#1
	ORR	R2,R2,R3,LSL#8
	STR	R2,[R1]
	LDR	R1,=0xFFE00044	;Station Address 1 Register
	LDRB	R2,[R0],#1
	LDRB	R3,[R0],#1
	ORR	R2,R2,R3,LSL#8
	STR	R2,[R1]
	LDR	R1,=0xFFE00040	;Station Address 0 Register
	LDRB	R2,[R0],#1
	LDRB	R3,[R0],#1
	ORR	R2,R2,R3,LSL#8
	STR	R2,[R1]
	LDR	R0,=0xFFE00200	;RxFilterCtrl=AcceptPerfect,AcceptBroadcast
	MOV	R1,#0x22
	STR	R1,[R0]
	LDR	R0,=0xFFE00004	;MAC2=Pad,CRCEnable,FullDuplex
	MOV	R1,#0x31
	STR	R1,[R0]
	LDR	R0,=0xFFE00008	;IPGT=0x15
	MOV	R1,#0x15
	STR	R1,[R0]
	LDR	R0,=0xFFE0000C	;IPGR=0x0C12
	LDR	R1,=0x0C12
	STR	R1,[R0]
;Enable the receive and transmit datapaths
	LDR	R0,=0xFFE00100	;Command=DUP,RMII,RxReset,TxReset,TxEnable,RxEnable
	LDR	R1,=0x0633
	STR	R1,[R0]
	LDR	R0,=0xFFE00000	;MAC1=RxEnable
	MOV	R1,#0x0001
	STR	R1,[R0]
;ostale spremenljivke izven Ethernet RTX
	LDR	R0,=MACMAC	;zacetni MAC sogovornika
	MOV	R1,#255
	STRB	R1,[R0],#1
	STRB	R1,[R0],#1
	STRB	R1,[R0],#1
	STRB	R1,[R0],#1
	STRB	R1,[R0],#1
	STRB	R1,[R0],#1
	LDR	R0,=ETXBLOK	;zacetni ETXBLOK
	MOV	R1,#0
	STR	R1,[R0]
	LDR	R0,=KCACHE	;zacetni kazalec 0
	MOV	R1,#0
	STR	R1,[R0]
	LDR	R0,=ECACHE	;brisi vpis 0 v ECACHE
	MOV	R1,#0
	STRH	R1,[R0,#10]
	LDR	PC,[SP],#4

;*** Razrezi Ethernet RAM *** (R0-3)
ETHRAM	LDR	R0,=ZACERX	;razrezi sprejemne bloke, naslov+ETHBLOK
	LDR	R1,=RXDESC
	LDR	R2,=RXCONT
	MOV	R3,#RXDESCN
ETHRAM1	STR	R0,[R1],#4	;Packet
	ADD	R0,R0,#ETHBLOK
	STR	R2,[R1],#4	;Control
	SUBS	R3,R3,#1
	BPL	ETHRAM1
	LDR	R0,=ZACETX	;razrezi oddajne bloke, vsi isti naslov
	LDR	R1,=TXDESC
	MOV	R3,#TXDESCN
ETHRAM2	STR	R0,[R1],#4	;Packet
	MOV	R2,#0		;Control=0
	STR	R2,[R1],#4
	SUBS	R3,R3,#1
	BPL	ETHRAM2
	BX	LR
	LTORG

;*** Inicializiraj PHY DP83848C *** (R0-3)
INIPHY	STR	LR,[SP,#-4]!	;resi link
	MOV	R2,#0x8000	;Reset
	MOV	R3,#0x00	;Basic Mode Control Register
	BL	PHYCMD		;poslji ukaz R2 v PHY register R3
INIPHY1	MOV	R3,#0x00	;Basic Mode Control Register
	BL	PHYSTS		;PHY register R3 preberi stanje v R2
	TST	R2,#0x8000	;zakljucen Reset?
	BNE	INIPHY1
	LDR	R1,=ESPEED	;nastavi Ethernet hitrost?
	LDRB	R1,[R1]
	AND	R1,R1,#0xFE
	MOV	R2,#0x1300	;AutoNegotiation,RestartAN,duplex
	CMP	R1,#10
	MOVEQ	R2,#0x0100	;10M,duplex
	CMP	R1,#100
	MOVEQ	R2,#0x2100	;100M,duplex
	MOV	R3,#0x00	;Basic Mode Control Register
	BL	PHYCMD		;poslji ukaz R2 v PHY register R3
	LDR	R1,=ESPEED	;nastavi MDIX?
	LDRB	R1,[R1]
	LDR	R2,=0x8021	;AutoMDIX,LED=01,PHY=1
	CMP	R1,#10
	LDREQ	R2,=0x0021	;LED=01,PHY=1
	CMP	R1,#11
	LDREQ	R2,=0x4021	;ForceMDIX,LED=01,PHY=1
	CMP	R1,#100
	LDREQ	R2,=0x0021	;LED=01,PHY=1
	CMP	R1,#101
	LDREQ	R2,=0x4021	;ForceMDIX,LED=01,PHY=1
	MOV	R3,#0x19	;PHY Control Register
	BL	PHYCMD		;poslji ukaz R2 v PHY register R3
	MOV	R2,#0x20	;RMII,ReceiveElasticityBuffer=14bit
	MOV	R3,#0x17	;RMII and Bypass Register
	BL	PHYCMD		;poslji ukaz R2 v PHY register R3
	LDR	PC,[SP],#4
	LTORG

;*** Poslji ukaz R2 v PHY register R3 *** (R0-3)
PHYCMD	LDR	R0,=0xFFE00024	;MCMD=0
	MOV	R1,#0
	STR	R1,[R0]
	LDR	R0,=0xFFE00028	;MADR
	ORR	R1,R3,#0x100	;registru R3 dodaj PHY=1
	STR	R1,[R0]
	LDR	R0,=0xFFE0002C	;MWTD poslji ukaz R2
	STR	R2,[R0]
PHYCMD1	LDR	R0,=0xFFE00034	;MIND
	LDR	R1,[R0]
	TST	R1,#1		;BUSY=?
	BNE	PHYCMD1
	BX	LR
	LTORG

;*** PHY register R3 preberi stanje v R2 *** (R0-3)
PHYSTS	LDR	R0,=0xFFE00024	;MCMD=1
	MOV	R1,#1
	STR	R1,[R0]
	LDR	R0,=0xFFE00028	;MADR
	ORR	R1,R3,#0x100	;registru R3 dodaj PHY=1
	STR	R1,[R0]
PHYSTS1	LDR	R0,=0xFFE00034	;MIND
	LDR	R1,[R0]
	TST	R1,#1		;BUSY=?
	BNE	PHYSTS1
	LDR	R0,=0xFFE00024	;MCMD=0
	MOV	R1,#0
	STR	R1,[R0]
	LDR	R0,=0xFFE00030	;MRDD v R2
	LDR	R2,[R0]
	BX	LR
	LTORG

;*** Nastavi prekinitve v VIC v LPC2368/2387 *** (R0-1)
VIC	LDR	R0,=0xFFFFF00C	;VICIntSelect
	LDR	R1,=0x00000800	;SSP1=FIQ
	STR	R1,[R0]
	LDR	R0,=0xFFFFF010	;VICIntEnable
	LDR	R1,=0x00000880	;SSP1+UART1
	STR	R1,[R0]
	BX	LR

;*** Preveri takt ARM procesorja *** (R0-2)
MINTAKT	EQU	40000000	;40MHz
REFTAKT	EQU	58982400	;58.9824MHz=4*14.7456MHz
MAXTAKT	EQU	110000000	;110MHz
INITAKT	LDR	R0,=ARMTAKT	;takt deljiv s 4!
	LDR	R1,[R0]
	BIC	R1,R1,#3
	LDR	R2,=MINTAKT	;preveri min.takt
	CMP	R1,R2
	LDRCC	R1,=REFTAKT
	LDR	R2,=MAXTAKT	;preveri max.takt
	CMP	R1,R2
	LDRCS	R1,=REFTAKT
	STR	R1,[R0]		;shrani preverjeno
	BX	LR
	LTORG

;*** Vkljuci psa cuvaja v LPC2368/2387 *** (R0-1)
PESCAKA	EQU	7000000		;7s@4MHzRCosc
PESJAN	LDR	R0,=0xE0000004	;WDTC
	LDR	R1,=PESCAKA
	STR	R1,[R0]
	LDR	R0,=0xE0000000	;WDMOD=3
	MOV	R1,#3
	STRB	R1,[R0]
	LDR	R0,=0xE0000008	;WDFEED pes vklop
	MOV	R1,#0xAA
	STRB	R1,[R0]
	MOV	R1,#0x55
	STRB	R1,[R0]
	BX	LR
	LTORG

;*** Pes cuva sprejem v LPC2368/2387 *** (R0-1)
MAXTX	EQU	980		;MAX TX 98% (v promilih)
PESCUVA	LDR	R0,=NPTT
	LDR	R0,[R0]
	CMP	R0,#MAXTX
	BXCS	LR
	LDR	R0,=0xE0000008	;WDFEED pes cuva
	MOV	R1,#0xAA
	STRB	R1,[R0]
	MOV	R1,#0x55
	STRB	R1,[R0]
	BX	LR
	LTORG

;*** Inicializiraj parametre iz FLASH *** (R0-3)
INIPAR	LDR	R0,=FNASLOV	;source Flash address
	LDR	R1,=RAMFPAR	;destination RAM address
	LDR	R2,=256
INIPAR1	LDR	R3,[R0],#4	;prepisi 256*4=1024byte
	STR	R3,[R1],#4		
	SUBS	R2,R2,#1
	BNE	INIPAR1
	BX	LR
	LTORG

;*** Vpis parametrov v FLASH pomnilnik *** (R0-4,SP+4)+RIZVEDI
FSECTOR	EQU	25		;sektor 25: 0x0007B000-0x0007BFFF
FNASLOV	EQU	0x0007B000	;zacetni naslov sektorja 25
IAPADDR	EQU	0x7FFFFFF1 	;IAP naslov (THUMB)
FLASH	MRS	R0,CPSR		;izkljuci prekinitve IRQ in FIQ
	ORR	R0,R0,#0x000000C0
	MSR	CPSR_c,R0	;popravi CPSR
	LDR	R0,=IAPCMD	;Prepare sector(s) for write operation
	MOV	R2,#50		;Command code 50
	STR	R2,[R0]
	MOV	R2,#FSECTOR	;Start Sector Number
	STR	R2,[R0,#4]
	STR	R2,[R0,#8]	;End Sector Number
	LDR	R1,=IAPRES
	LDR	R2,=IAPADDR	;klic na IAP naslov
	MOV	LR,PC
	BX	R2
	LDR	R0,=IAPCMD	;Erase sector(s)
	MOV	R2,#52		;Command code 52
	STR	R2,[R0]
	MOV	R2,#FSECTOR	;Start Sector Number
	STR	R2,[R0,#4]
	STR	R2,[R0,#8]	;End Sector Number
	LDR	R2,=ARMTAKT	;system clock frequency (CCLK) in kHz
	LDR	R2,[R2]
	MOV	R2,R2,LSR#10
	STR	R2,[R0,#12]
	LDR	R1,=IAPRES
	LDR	R2,=IAPADDR	;klic na IAP naslov
	MOV	LR,PC
	BX	R2
	LDR	R0,=IAPCMD	;Prepare sector(s) for write operation
	MOV	R2,#50		;Command code 50
	STR	R2,[R0]
	MOV	R2,#FSECTOR	;Start Sector Number
	STR	R2,[R0,#4]
	STR	R2,[R0,#8]	;End Sector Number
	LDR	R1,=IAPRES
	LDR	R2,=IAPADDR	;klic na IAP naslov
	MOV	LR,PC
	BX	R2
	LDR	R0,=IAPCMD	;Copy RAM to Flash
	MOV	R2,#51		;Command code 51
	STR	R2,[R0]
	LDR	R2,=FNASLOV	;Destination Flash address
	STR	R2,[R0,#4]
	LDR	R2,=RAMFPAR	;Source RAM address
	STR	R2,[R0,#8]
	MOV	R2,#1024	;Number of bytes to be written (1024)
	STR	R2,[R0,#12]
	LDR	R2,=ARMTAKT	;System Clock Frequency (CCLK) in kHz
	LDR	R2,[R2]
	MOV	R2,R2,LSR#10
	STR	R2,[R0,#16]
	LDR	R1,=IAPRES
	LDR	R2,=IAPADDR	;klic na IAP naslov
	MOV	LR,PC
	BX	R2
	B	RIZVEDI		;ARM reset
	LTORG

;*** Vkljuci prekinitve IRQ in FIQ v ARM *** (R0-1)
IRQON	MRS	R0,CPSR		;preklopi v nacin FIQ
	BIC	R0,R0,#0x0000001F
	ORR	R0,R0,#0x00000011
	MSR	CPSR_c,R0	;popravi CPSR
	LDR	SP,=FSKLAD	;inicializiraj FIQ SP
	LDR	R12,=0x7FFFFFFF	;HDLC pomikalni register
	LDR	R10,=TABCRC	;naslov tabele HDLC CRC
	MOV	R8,#0		;naslov neobstojecega bloka
	MRS	R0,CPSR		;preklopi v nacin IRQ
	BIC	R0,R0,#0x0000001F
	ORR	R0,R0,#0x00000012
	MSR	CPSR_c,R0	;popravi CPSR
	LDR	SP,=ISKLAD	;inicializiraj IRQ SP
	LDR	R0,=LNASLOV	;prvi LNASLOV VSEM za izklop FIQ?
	LDR	R1,[R0]
	MRS	R0,CPSR		;nacin supervisor in vklop FIQ+IRQ
	MVNS	R1,R1
	BICEQ	R0,R0,#0x0000009F	;samo IRQ
	ORREQ	R0,R0,#0x00000053
	BICNE	R0,R0,#0x000000DF	;FIQ+IRQ
	ORRNE	R0,R0,#0x00000013
	MSR	CPSR_c,R0	;popravi CPSR
	BX	LR

;*** Izberi PIN in GPIO v LPC238/2387 *** (R0-1)
PINGPIO	LDR	R0,=0xE002C000	;PINSEL0
	LDR	R1,=0x405AA05A	;P0.0-1=UART3,P0.2-3=UART0,P0.6-9=SPI1,P0.10-11=UART2,P0.15=UART1
	STR	R1,[R0]
	LDR	R0,=0xE002C004	;PINSEL1
	LDR	R1,=0x00154001	;P0.16=UART1,P0.23-26=AD
	STR	R1,[R0]
	LDR	R0,=0xE002C044	;PINMODE1
	LDR	R1,=0x002A8000	;P0.23-26 brez pullup/pulldown
	STR	R1,[R0]
	LDR	R0,=0xE002C008	;PINSEL2
	LDR	R1,=0x50150105	;P1.0,1,4,8,9,10,14,15=EthernetRMII
	STR	R1,[R0]
	LDR	R0,=0xE002C00C	;PINSEL3
	LDR	R1,=0x00000005	;P1.16,17=EthernetRMII
	STR	R1,[R0]
	LDR	R0,=0xE01FC1A0	;SCS
	LDR	R1,=0x00000021	;main oscillator enable, high-speed GPIO 0&1
	STR	R1,[R0]
	LDR	R0,=0x3FFFC000	;FIO0DIR
	LDR	R1,=0x00000010	;izhod P0.4
	STR	R1,[R0]
	LDR	R0,=0x3FFFC020	;FIO1DIR izhod P1.31
	LDR	R1,=0x80000000
	STR	R1,[R0]
	LDR	R0,=0x3FFFC080	;FIO4DIR izhoda P4.28-29
	LDR	R1,=0x30000000
	STR	R1,[R0]
	LDR	R0,=0x3FFFC037	;FIO1PIN3 izklopi telekomando
	MOV	R1,#0
	STRB	R1,[R0]
	LDR	R0,=0x3FFFC097	;FIO4PIN3 izklopi oddajnik
	MOV	R1,#0xFF
	STRB	R1,[R0]
	BX	LR
	LTORG

;*** Inicializiraj PLL in MAM v LPC2368/2387 *** (R0-2)
PLLMAM	LDR	R0,=0xE01FC1A0	;SCS
	LDR	R1,=0x00000021	;main oscillator enable, high-speed GPIO 0&1
	STR	R1,[R0]
	LDR	R1,[R0]		;main oscillator ready?
	TST	R1,#0x00000040
	BEQ	PLLMAM
	LDR	R0,=0xE01FC104	;CCLKCFG
	MOV	R1,#5		;deljenje /6
	STRB	R1,[R0]
	LDR	R0,=0xE01FC108	;USBCLKCFG
	MOV	R1,#5		;deljenje /6
	STRB	R1,[R0]
	LDR	R0,=0xE01FC10C	;CLKSRCSEL
	MOV	R1,#1		;main oscillator
	STRB	R1,[R0]
	LDR	R0,=0xE01FC084	;PLLCFG=0x0000000B N-1=0,M-1=11
	LDR	R1,=0x0000000B
	STR	R1,[R0]
	LDR	R0,=0xE01FC080	;PLLCON=0x01 PLL-enable
	MOV	R1,#0x01
	STRB	R1,[R0]
	LDR	R0,=0xE01FC08C	;PLLFEED
	MOV	R1,#0xAA
	MOV	R2,#0x55
	STRB	R1,[R0]
	STRB	R2,[R0]
PLLMAM1	LDR	R0,=0xE01FC088	;PLLSTAT cakanje uklenitve
	LDR	R1,[R0]
	TST	R1,#0x04000000
	BEQ	PLLMAM1
	LDR	R0,=0xE01FC080	;PLLCON=0x03 PLL-enable&connect
	MOV	R1,#0x03
	STRB	R1,[R0]
	LDR	R0,=0xE01FC08C	;PLLFEED
	MOV	R1,#0xAA
	MOV	R2,#0x55
	STRB	R1,[R0]
	STRB	R2,[R0]
	LDR	R0,=0xE01FC000	;MAMCR=0
	MOV	R1,#0
	STRB	R1,[R0]
	LDR	R0,=0xE01FC004	;MAMTIM=3
	MOV	R1,#3
	STRB	R1,[R0]
	LDR	R0,=0xE01FC000	;MAMCR=2
	MOV	R1,#2
	STRB	R1,[R0]
	BX	LR
	LTORG

;*** Vklop in takt I/O enot LPC2368/2387 *** (R0-1)
PWRCLK	LDR	R0,=0xE01FC0C4	;PCONP
	LDR	R1,=0x4300141A 	;ETH,UART3&2,AD,SSP1,UART1&0,TIM0
	STR	R1,[R0]
	LDR	R0,=0xE01FC1A8	;PCLKSEL0
	LDR	R1,=0x01100144	;AD,SSP1,UART1&0,TIM0
	STR	R1,[R0]
	LDR	R0,=0xE01FC1AC	;PCLKSEL1
	LDR	R1,=0x10050015	;SYSCON,UART3&2,PCB,GPIO,BATRAM
	STR	R1,[R0]
	BX	LR
	LTORG

;*** Inicializiraj Timer0 *** (R0-1)
TIMER0	STR	LR,[SP,#-4]!
	LDR	R0,=1000000	;miljon mikrosekund
	LDR	R3,=ARMTAKT	;izracunaj modulo iz PCLK
	LDR	R3,[R3]
	ADD	R3,R0,LSR#1	;zaokrozi na najblizji modulo
	BL	NDELI
	LDR	R0,=0xE000400C	;T0PR
	STR	R3,[R0]
	LDR	R0,=0xE0004004	;T0TCR
	MOV	R1,#0x01	;CounterEnable
	STRB	R1,[R0]
	LDR	R0,=SEKUNDA	;resetiraj sekundni stevec
	MOV	R1,#0
	STR	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** Izracunaj tabelo za racunanje CRCja *** (R0-4)
INICRC	LDR	R0,=TABCRC	;tabela dolzine 256*16bit
	MOV	R1,#0
INICRC1	MOV	R2,R1
	MOV	R3,#7
INICRC2	LDR	R4,=0x00008408	;CCITT polinom 1+X^5+X^12+X^16
	MOVS	R2,R2,LSR#1
	EORCS	R2,R2,R4
	SUBS	R3,R3,#1
	BPL	INICRC2
	STRH	R2,[R0],#2
	ADD	R1,R1,#1
	CMP	R1,#256
	BCC	INICRC1
	BX	LR

;*** Dodaj HDLC CRC okvirju (R8) *** (R0-5,R8)
HDLCCRC	LDR	R2,=TABCRC	;tabela za racunanje CRC
	MOV	R3,#0xFFFFFFFF	;zacetni CRC
	LDRH	R4,[R8,#2]
	ADD	R4,R4,R8
	LDRH	R5,[R8]
	ADD	R0,R5,#2	;podaljsaj okvir za CRC
	STRH	R0,[R8]
	B	HDLCCR2
HDLCCR1	LDRB	R0,[R4],#1	;obracunaj CRC za byte v R0
	EOR	R0,R0,R3
	AND	R0,R0,#0x000000FF
	ADD	R0,R0,R0
	LDRH	R1,[R2,R0]	;R2=TABCRC
	AND	R3,R3,#0x0000FF00
	EOR	R3,R1,R3,LSR#8
HDLCCR2	SUBS	R5,R5,#1
	BPL	HDLCCR1
	MVN	R0,R3		;negiran CRC na konec okvirja
	MOV	R1,R0,LSR#8
	STRB	R0,[R4],#1
	STRB	R1,[R4],#1
	BX	LR
	LTORG

;*** Razrezi RAM v bloke dolzine 1632=0x660 v LPC2368/2387 *** (R0-3)
INIBLOK	LDR	R1,=INIBLO2	;45 blokov za LPC2387
	LDR	R0,=0xE002C028	;PINSEL10 preveri bit 3 (/RTCK)?
	LDR	R0,[R0]
	TST	R0,#8
	LDRNE	R1,=INIBLO3	;20 blokov za LPC2368
	LDR	R0,=RAMBLOK
	MOV	R2,#MAXBLOK
INIBLO1	LDR	R3,[R1],#4
	STR	R3,[R0],#4
	SUBS	R2,R2,#1
	BPL	INIBLO1
	LDR	R0,=NICBLOK	;brisi zastavico nic blokov
	MOV	R1,#-1
	STRB	R1,[R0]
	BX	LR
	LTORG
INIBLO2	DCD	0x40002000,0x40002660,0x40002CC0,0x40003320	;4 - LPC2387
	DCD	0x40003980,0x40003FE0,0x40004640,0x40004CA0	;8
	DCD	0x40005300,0x40005960,0x40005FC0,0x40006620	;12
	DCD	0x40006C80,0x400072E0,0x40007940,0x7FD00000	;16
	DCD	0x7FD00660,0x7FD00CC0,0x7FD01320,0x7FD01980	;20
	DCD	0x40008000,0x40008660,0x40008CC0,0x40009320	;24
	DCD	0x40009980,0x40009FE0,0x4000A640,0x4000ACA0	;28
	DCD	0x4000B300,0x4000B960,0x4000BFC0,0x4000C620	;32
	DCD	0x4000CC80,0x4000D2E0,0x4000D940,0x4000DFA0	;36
	DCD	0x4000E600,0x4000EC60,0x4000F2C0,0x4000F920	;40
	DCD	0x7FD02000,0x7FD02660,0x7FD02CC0,0x7FD03320	;44
	DCD	0x7FD03980,0x00000000,0x00000000,0x00000000	;48
INIBLO3	DCD	0x40002000,0x40002660,0x40002CC0,0x40003320	;4 - LPC2368
	DCD	0x40003980,0x40003FE0,0x40004640,0x40004CA0	;8
	DCD	0x40005300,0x40005960,0x40005FC0,0x40006620	;12
	DCD	0x40006C80,0x400072E0,0x40007940,0x7FD00000	;16
	DCD	0x7FD00660,0x7FD00CC0,0x7FD01320,0x7FD01980	;20
	DCD	0x00000000,0x00000000,0x00000000,0x00000000	;24
	DCD	0x00000000,0x00000000,0x00000000,0x00000000	;28
	DCD	0x00000000,0x00000000,0x00000000,0x00000000	;32
	DCD	0x00000000,0x00000000,0x00000000,0x00000000	;36
	DCD	0x00000000,0x00000000,0x00000000,0x00000000	;40
	DCD	0x00000000,0x00000000,0x00000000,0x00000000	;44
	DCD	0x00000000,0x00000000,0x00000000,0x00000000	;48

;*** Prestej proste bloke pomnilnika v R0 *** (R0-3)
	ALIGN	16
PROSTO	MOV	R0,#0
	LDR	R1,=RAMBLOK
	MOV	R2,#MAXBLOK
PROSTO1	LDR	R3,[R1],#4
	MOVS	R3,R3
	ADDNE	R0,R0,#1
	SUBS	R2,R2,#1
	BPL	PROSTO1
	BX	LR
	LTORG

;*** Dodeli blok iz RAMBLOK v R8 v LPC2368/2387 *** (R0,R8)
	MACRO			;makro za iskanje bloka
	MDODELI
	SWP	R8,R8,[R0]	;atomarni ukaz
	MOVS	R8,R8
	BXNE	LR
	ADD	R0,R0,#4
	MEND
	ALIGN	16
DODELI	MOV	R8,#0
	LDR	R0,=NICBLOK	;zastavica nic blokov?
	LDRB	R0,[R0]
	MOVS	R0,R0
	BXEQ	LR
	LDR	R0,=RAMBLOK	;isci blok
	MDODELI	;blok 1
	MDODELI	;blok 2
	MDODELI	;blok 3
	MDODELI	;blok 4
	MDODELI	;blok 5
	MDODELI	;blok 6
	MDODELI	;blok 7
	MDODELI	;blok 8
	MDODELI	;blok 9
	MDODELI	;blok 10
	MDODELI	;blok 11
	MDODELI	;blok 12
	MDODELI	;blok 13
	MDODELI	;blok 14
	MDODELI	;blok 15
	MDODELI	;blok 16
	MDODELI	;blok 17
	MDODELI	;blok 18
	MDODELI	;blok 19
	MDODELI	;blok 20
	MDODELI	;blok 21
	MDODELI	;blok 22
	MDODELI	;blok 23
	MDODELI	;blok 24
	MDODELI	;blok 25
	MDODELI	;blok 26
	MDODELI	;blok 27
	MDODELI	;blok 28
	MDODELI	;blok 29
	MDODELI	;blok 30
	MDODELI	;blok 31
	MDODELI	;blok 32
	MDODELI	;blok 33
	MDODELI	;blok 34
	MDODELI	;blok 35
	MDODELI	;blok 36
	MDODELI	;blok 37
	MDODELI	;blok 38
	MDODELI	;blok 39
	MDODELI	;blok 40
	MDODELI	;blok 41
	MDODELI	;blok 42
	MDODELI	;blok 43
	MDODELI	;blok 44
	MDODELI	;blok 45
	LDR	R0,=NICBLOK	;postavi zastavico nic blokov!
	STRB	R8,[R0]
	BX	LR
	LTORG

;*** Sprosti blok iz R8 v RAMBLOK *** (R0-1,R8)
	ALIGN	16
SPROSTI	MOVS	R8,R8		;neobstojec blok?
	BXEQ	LR
	LDR	R0,=RAMBLOK	;vstavi sprosceni blok v seznam
	MOV	R1,#MAXBLOK
SPROST1	SWP	R8,R8,[R0]	;atomarni ukaz
	MOVS	R8,R8
	BEQ	SPROST3
	ADD	R0,R0,#4
	SUBS	R1,R1,#1
	BPL	SPROST1
SPROST3	LDR	R0,=NICBLOK	;brisi zastavico nic blokov
	MOV	R1,#-1
	STRB	R1,[R0]
	BX	LR
	LTORG

;*** Inicializiraj vse vmesnike v LPC2368/2387 *** (R0-1)
INIVMES	MOV	R1,#0
	LDR	R0,=HRXVMES
	STR	R1,[R0]
	LDR	R0,=HTPVMES
	STR	R1,[R0]
	LDR	R0,=HTXVMES
	STR	R1,[R0]
	LDR	R0,=HTZVMES
	STR	R1,[R0]
	LDR	R0,=SRXVMES
	STR	R1,[R0]
	LDR	R0,=STXVMES
	STR	R1,[R0]
	LDR	R0,=ETXVMES
	STR	R1,[R0]
	BX	LR
	LTORG

;*** Blok R8 v vmesnik R0 brez nadzora *** (R0-1,R8)
	ALIGN	16
VVMES	MOVS	R8,R8
	BXEQ	LR
	LDRH	R1,[R0]
	ADD	R1,R1,#1
	STR	R8,[R0,R1,LSL#2]
	CMP	R1,#MAXVMES
	MOVCS	R1,#0
	STRH	R1,[R0]
	BX	LR
	LTORG

;*** Blok R8 iz vmesnika R0 *** (R0-2,R8)
	ALIGN	16
IZVMES	MOV	R8,#0
	LDRH	R1,[R0]
	LDRH	R2,[R0,#2]
	CMP	R1,R2
	BXEQ	LR
	ADD	R2,R2,#1
	LDR	R8,[R0,R2,LSL#2]
	CMP	R2,#MAXVMES
	MOVCS	R2,#0
	STRH	R2,[R0,#2]
	BX	LR
	LTORG

;*** Polinomski izvor (2^32-1) v R0 *** (R0-2)
	ALIGN	16
PSEVNAK	LDR	R1,=POLINOM
	LDR	R0,[R1]
	MOVS	R0,R0		;izloci stanje samih nicel?
	MOVEQ	R0,#-1
	LDR	R2,=0x80000062	;polinom 1+X^25+X^26+X^30+X^32
	MOVS	R0,R0,LSR#1
	EORCS	R0,R0,R2
	STR	R0,[R1]
	LDR	R1,=MNASLOV	;EXOR z MNASLOV
	LDR	R2,[R1]
	EOR	R0,R0,R2
	MVNS	R0,R0		;izloci same enice
	BEQ	PSEVNAK
	MVNS	R0,R0		;izloci same nicle
	BEQ	PSEVNAK
	BX	LR
	LTORG

;*** Inicializiraj UART0 v LPC2368/2387 *** (R0-3)
U0BAUD	EQU	9600		;baudrate UART0
UART0	STR	LR,[SP,#-4]!
	LDR	R0,=0xE000C00C	;U0LCR=0x83 DLAB=1,no-parity,1stop,8bit
	MOV	R1,#0x83
	STRB	R1,[R0]
	LDR	R0,=U0BAUD
	LDR	R3,=ARMTAKT	;izracunaj modulo iz PCLK/16
	LDR	R3,[R3]
	MOV	R3,R3,LSR#4
	ADD	R3,R0,LSR#1	;zaokrozi na najblizji modulo
	BL	NDELI
	LDR	R0,=0xE000C000	;U0DLL
	STRB	R3,[R0]
	LDR	R0,=0xE000C004	;U0DLM
	MOV	R3,R3,LSR#8
	STRB	R3,[R0]
	LDR	R0,=0xE000C008	;U0FCR=0xC1 RXtrig=14bit,FIFOenable
	MOV	R1,#0xC1
	STRB	R1,[R0]
	LDR	R0,=0xE000C00C	;U0LCR=0x03 DLAB=0,no-parity,1stop,8bit
	MOV	R1,#0x03
	STRB	R1,[R0]
	LDR	R0,=TIPVMES	;resetiraj tipke
	MOV	R1,#0
	STRH	R1,[R0]
	LDR	R0,=ZASKAZ	;resetiraj zaslon
	MOV	R1,#0
	STR	R1,[R0]
	LDR	R0,=ZASTRI
	MOV	R1,#0
	STR	R1,[R0]
	LDR	R0,=ZNACIN	;ukazni nacin
	MOV	R1,#0
	STRB	R1,[R0]
	LDR	R0,=NODZIV	;izkljuci odziv
	MOV	R1,#0
	STRH	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** Zaslon na UART0 v LPC2368/2387 *** (R0-3)
	ALIGN	16
ZASLON	LDR	R0,=0xE000C014	;U0LSR bit5=TxHoldingRegisterEmpty?
	LDRB	R0,[R0]
	TST	R0,#0x20
	BXEQ	LR
	LDR	R0,=ZASKAZ	;4 znaki v vmesniku BATRAM?
	LDRH	R1,[R0]
	LDRH	R2,[R0,#2]
	CMP	R1,R2
	BEQ	ZASLON1
	ADD	R2,R2,#4	;povecaj kazalec
	CMP	R2,#MAXZAS
	MOVCS	R2,#0
	STRH	R2,[R0,#2]
	LDR	R0,=BATRAM	;4 znaki (32bit) iz BATRAM
	LDR	R1,[R0,R2]
	LDR	R0,=0xE000C000	;U0THR
	MOV	R1,R1,ROR#24	;izpisi 1.znak
	STRB	R1,[R0]
	MOV	R1,R1,ROR#24	;izpisi 2.znak
	STRB	R1,[R0]
	MOV	R1,R1,ROR#24	;izpisi 3.znak
	STRB	R1,[R0]
	MOV	R1,R1,ROR#24	;izpisi 4.znak
	STRB	R1,[R0]
	BX	LR
ZASLON1	LDR	R0,=ZASTRI	;1-3 znaki v ZASTRI?
	LDR	R1,[R0]
	LDR	R0,=0xE000C000	;U0THR
	MOV	R2,R1,LSR#16	;izpisi 1.znak?
	TST	R2,#255
	STRBNE	R2,[R0]
	MOV	R2,R1,LSR#8	;izpisi 2.znak?
	TST	R2,#255
	STRBNE	R2,[R0]
	TST	R1,#255		;izpisi 3.znak?
	STRBNE	R1,[R0]
	LDR	R0,=ZASTRI	;brisi ZASTRI
	MOV	R1,#0
	STR	R1,[R0]
	BX	LR
	LTORG

;*** Znak R0 na zaslon/v (R7)+ brez nadzora *** (R0-2,R7,brezSP!!!)
	ALIGN	16
ZNAK	LDR	R1,=ZNACIN
	LDRB	R1,[R1]
	TST	R1,#8
	BEQ	ZNAK1
	STRB	R0,[R7],#1	;znak v (R7)+
	BX	LR
ZNAK1	LDR	R1,=ZASTRI	;dodaj znak v ZASTRI
	LDR	R2,[R1]
	ORR	R0,R0,R2,LSL#8
	STR	R0,[R1]
	TST	R0,#0xFF000000	;ZASTRI vsebuje 4 znake?
	BXEQ	LR
	LDR	R1,=ZASKAZ	;povecaj kazalec
	LDRH	R2,[R1]
	ADD	R2,R2,#4
	CMP	R2,#MAXZAS
	MOVCS	R2,#0
	STRH	R2,[R1]
	LDR	R1,=BATRAM	;4 znaki (32bit) v BATRAM
	STR	R0,[R1,R2]
	LDR	R0,=ZASTRI	;brisi ZASTRI
	MOV	R1,#0
	STR	R1,[R0]
	BX	LR
	LTORG

;*** Besedilo (R3) zakljuceno z 0 na zaslon *** (R0-3)
TXTIZP	STR	LR,[SP,#-4]!	;resi link
TXTIZP1	LDRB	R0,[R3],#1
	MOVS	R0,R0
	LDREQ	PC,[SP],#4
	BL	ZNAK
	B	TXTIZP1

;*** Desetiski izpis R3 na zaslon *** (R0-4)
DECIZP	STR	LR,[SP,#-4]!	;resi link
	MOV	R4,#-1
DECIZP1	MOV	R0,R3		;ostanek v R0
	MOV	R1,#0xA0000000
	MOV	R2,#0x10000000
	MOV	R3,#0		;kvocient v R3
DECIZP2	CMP	R0,R1
	SUBCS	R0,R0,R1
	ADDCS	R3,R3,R2
	MOV	R1,R1,LSR#1
	MOVS	R2,R2,LSR#1
	BNE	DECIZP2
	STRB	R0,[SP,#-1]!	;stevilke v sklad
	ADD	R4,R4,#1
	MOVS	R3,R3
	BNE	DECIZP1
DECIZP3	LDRB	R0,[SP],#1	;stevilke iz sklada
	ADD	R0,R0,#48
	BL	ZNAK		;brez SP!!!
	SUBS	R4,R4,#1
	BPL	DECIZP3
	LDR	PC,[SP],#4

;*** Nepredznaceno deljenje R3/R0=R3, ostanek v R0 *** (R0-3)
NDELI	MOVS	R1,R0		;prepreci deljenje z 0?
	BXEQ	LR
	MOV	R2,#1
	BMI	NDELI2
NDELI1	MOV	R2,R2,LSL#1	;enica delitelja v MSB
	MOVS	R1,R1,LSL#1
	BPL	NDELI1
NDELI2	MOV	R0,R3		;ostanek v R0
	MOV	R3,#0		;kvocient v R3
NDELI3	CMP	R0,R1
	SUBCS	R0,R0,R1
	ADDCS	R3,R3,R2
	MOV	R1,R1,LSR#1
	MOVS	R2,R2,LSR#1
	BNE	NDELI3
	BX	LR

;*** Desetiski izpis R3 na eno decimalko *** (R0-4)
DEC1IZP	STR	LR,[SP,#-4]!	;resi link
	MOV	R0,#10
	BL	NDELI
	STR	R0,[SP,#-4]!
	BL	DECIZP		;celi del
	MOV	R0,#"."
	BL	ZNAK
	LDR	R3,[SP],#4	;decimalka
	BL	DECIZP
	LDR	PC,[SP],#4

;*** Naslov36 izpis R3 na zaslon *** (R0-4)
N36IZP	LDR	R0,=ZNACIN	;vkljucen HEX?
	LDRB	R0,[R0]
	TST	R0,#32
	BNE	HEXIZP
	STR	LR,[SP,#-4]!	;resi link
	MVNS	R0,R3		;naslov VSEM=0xFFFFFFFF?
	BEQ	N36IZP2
N36IZP1	MOV	R0,#36		;R3/36=R0, ostanek R0
	BL	NDELI
	ADD	R0,#48		;ostanek v znak(36)
	CMP	R0,#58
	ADDCS	R0,#7
	BL	ZNAK
	MOVS	R3,R3		;konec izpisa?
	BNE	N36IZP1
	LDR	PC,[SP],#4
N36IZP2	MOV	R0,#"*"		;izpisi naslov VSEM="*"
	BL	ZNAK
	LDR	PC,[SP],#4
	LTORG

;*** Hexadecimalni izpis R3 na zaslon *** (R0-4)
HEXIZP	STR	LR,[SP,#-4]!	;resi link
	MOV	R4,#7
HEXIZP1	MOV	R3,R3,ROR#28
	AND	R0,R3,#15	;izracunaj hexacecimalni znak
	CMP	R0,#10
	ADDCS	R0,R0,#7
	ADD	R0,R0,#48
	BL	ZNAK
	SUBS	R4,R4,#1
	BPL	HEXIZP1
	LDR	PC,[SP],#4

;*** Izpis naslova IP4 iz [R5],#4 na zaslon *** (R0-5)
IP4IZP	STR	LR,[SP,#-4]!
	LDRB	R3,[R5],#1
	BL	DECIZP
	MOV	R0,#"."
	BL	ZNAK
	LDRB	R3,[R5],#1
	BL	DECIZP
	MOV	R0,#"."
	BL	ZNAK
	LDRB	R3,[R5],#1
	BL	DECIZP
	MOV	R0,#"."
	BL	ZNAK
	LDRB	R3,[R5],#1
	BL	DECIZP
	LDR	PC,[SP],#4

;*** Izpisi MAC iz (R5) *** (R0-5)
MACIZP	STR	LR,[SP,#-4]!
	MOV	R4,#6
MACIZP1	LDRB	R3,[R5],#1
	MOV	R0,R3,LSR#4	;prvi HEX znak
	ADD	R0,R0,#48
	CMP	R0,#58
	ADDCS	R0,R0,#7
	BL	ZNAK
	AND	R0,R3,#15	;drugi HEX znak
	ADD	R0,R0,#48
	CMP	R0,#58
	ADDCS	R0,R0,#7
	BL	ZNAK
	SUBS	R4,R4,#1	;konec zanke?
	LDREQ	PC,[SP],#4
	MOV	R0,#"-"		;minus med pari HEX
	BL	ZNAK
	B	MACIZP1

;*** Izpis vsebine okvirja R8 *** (R0-8)
	ALIGN	16
LIZPOKV	LDR	R0,=ZNACIN	;prikazi vse lokalno sprejete okvirje?
	LDRB	R0,[R0]
	TST	R0,#2
	BXEQ	LR
	MOV	R7,#"L"
	B	IZPOKV
	LTORG
	ALIGN	16
RIZPOKV	LDR	R0,=ZNACIN	;prikazi vse sprejete okvirje?
	LDRB	R0,[R0]
	TST	R0,#2
	BXEQ	LR
	MOV	R7,#"R"
	B	IZPOKV
	LTORG
	ALIGN	16
SIZPOKV	LDR	R0,=ZNACIN	;prikazi vse lokalno oddane okvirje?
	LDRB	R0,[R0]
	TST	R0,#2
	BXEQ	LR
	MOV	R7,#"S"
	B	IZPOKV
	LTORG
	ALIGN	16
TIZPOKV	LDR	R0,=ZNACIN	;prikazi vse oddane okvirje brez CRC?
	LDRB	R0,[R0]
	TST	R0,#2
	BXEQ	LR
	STR	LR,[SP,#-4]!
	LDRH	R0,[R8]		;odrezi dolzino CRC		
	SUB	R0,R0,#2
	STRH	R0,[R8]
	MOV	R7,#"T"
	BL	IZPOKV
	LDRH	R0,[R8]		;povrni dolzino CRC		
	ADD	R0,R0,#2
	STRH	R0,[R8]
	LDR	PC,[SP],#4
	LTORG
	ALIGN	16
UIZPOKV	LDR	R0,=ZNACIN	;prikazi uporabne okvirje?
	LDRB	R0,[R0]
	TST	R0,#2
	BXNE	LR
	MOV	R7,#0
	B	IZPOKV
	LTORG
IZPOKV	STR	LR,[SP,#-4]!
	BL	UBRISI		;brisi natipkan ukaz
	MOVS	R0,R7		;izpisi R,T ali nicesar
	BLNE	ZNAK
	LDRH	R5,[R8]		;okvir: stevec R5, kazalec R6
	LDRH	R6,[R8,#2]
	ADD	R6,R6,R8
	LDR	R3,[R6],#4	;stevilka okvirja
	SUB	R5,R5,#4
	MOVS	R7,R7		;zastavica za izpis strevilke?
	BEQ	IZPOKV1
	MOV	R0,#"("
	BL	ZNAK
	BL	HEXIZP
	MOV	R0,#")"
	BL	ZNAK
IZPOKV1	MOV	R7,#1		;izpisi naslove do dveh locil (0)
	MOV	R1,#0
IZPOKV2	LDR	R3,[R6],#4
	SUBS	R5,R5,#4
	BMI	IZPOKV6
	MOVS	R3,R3
	BEQ	IZPOKV3
	MOV	R0,#","		;vejica samo med veljavnimi naslovi
	MOVS	R1,R1
	BLNE	ZNAK
	BL	N36IZP
	MOV	R1,#-1
	B	IZPOKV2
IZPOKV3	MOV	R0,#">"		;znak za locilo ">"
	BL	ZNAK
	MOV	R1,#0
	SUBS	R7,R7,#1
	BPL	IZPOKV2
	BL	MERI		;meritev odziva?
	B	IZPOKV5
IZPOKV4	LDRB	R0,[R6],#1	;izpisi besedilo okvirja
	AND	R0,R0,#0x7F	;omejitev 7bit brez kontrolnih
	CMP	R0,#32
	BLCS	ZNAK
IZPOKV5	SUBS	R5,R5,#1
	BPL	IZPOKV4
IZPOKV6	MOV	R0,#13		;nova vrsta na koncu
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	BL	UPPISI		;ponovno izpisi natipkan ukaz
	LDR	PC,[SP],#4
	LTORG

;*** Brisi natipkan ukaz *** (R0-3)
	ALIGN	16
UBRISI	STR	LR,[SP,#-4]!
	LDR	R0,=TIPVMES
	LDRH	R3,[R0]
UBRISI1	SUBS	R3,R3,#1
	LDRMI	PC,[SP],#4
	MOV	R0,#8
	BL	ZNAK
	MOV	R0,#32
	BL	ZNAK
	MOV	R0,#8
	BL	ZNAK
	B	UBRISI1
	LTORG

;*** Ponovno izpisi natipkan ukaz *** (R0-4)
	ALIGN	16
UPPISI	STR	LR,[SP,#-4]!
	LDR	R0,=TIPVMES
	LDRH	R3,[R0]
	ADD	R4,R0,#2
UPPISI1	SUBS	R3,R3,#1
	LDRMI	PC,[SP],#4
	LDRB	R0,[R4],#1
	BL	ZNAK
	B	UPPISI1
	LTORG

;*** Inicializiraj tabelo dvojnikov *** (R0-2)
INIDVOJ	LDR	R0,=DVOJTAB
	MOV	R1,#-1
	MOV	R2,#1024
INIDVO1	STR	R1,[R0],#4
	SUBS	R2,R2,#1
	BNE	INIDVO1
	BX	LR
	LTORG

;*** Oznaci okvir R8 dvojnik z zastavico R0 *** (R0-3,R8)
	MACRO
	DVOJNI
	LDR	R3,[R2],#-4
	CMP	R3,R1
	BEQ	DVOJNI3
	ORR	R2,R2,#0x1000
	MEND
	ALIGN	16
DVOJNIK	LDRH	R0,[R8,#2]	;preveri stevilko VSEM=0xFFFFFFFF v R1?
	LDR	R1,[R8,R0]
	MVNS	R0,R1		;R0=0 za naslov VSEM?
	BXEQ	LR
	LDR	R0,=DVOJKAZ	;naslov tabele + preverjeni kazalec v R2
	LDRH	R2,[R0]
	LDR	R0,=0x0FFC
	AND	R2,R2,R0
	LDR	R0,=DVOJTAB
	ADD	R2,R2,R0
	MOV	R0,#32
DVOJNI1	;;;;;;;;;;;;;;;;;;;;;;;;;zanka iskanja 32macro*32R0=1024
	DVOJNI	;1
	DVOJNI	;2
	DVOJNI	;3
	DVOJNI	;4
	DVOJNI	;5
	DVOJNI	;6
	DVOJNI	;7
	DVOJNI	;8
	DVOJNI	;9
	DVOJNI	;10
	DVOJNI	;11
	DVOJNI	;12
	DVOJNI	;13
	DVOJNI	;14
	DVOJNI	;15
	DVOJNI	;16
	DVOJNI	;17
	DVOJNI	;18
	DVOJNI	;19
	DVOJNI	;20
	DVOJNI	;21
	DVOJNI	;22
	DVOJNI	;23
	DVOJNI	;24
	DVOJNI	;25
	DVOJNI	;26
	DVOJNI	;27
	DVOJNI	;28
	DVOJNI	;29
	DVOJNI	;30
	DVOJNI	;31
	DVOJNI	;32
	SUBS	R0,R0,#1	;R0=0 za neuspesno iskanje
	BNE	DVOJNI1
DVOJNI2	LDR	R3,=DVOJKAZ	;povecaj in shrani kazalec
	LDRH	R2,[R3]
	ADD	R2,R2,#4
	STRH	R2,[R3]
	LDR	R3,=0x0FFC	;preveri kazalec
	AND	R2,R2,R3
	LDR	R3,=DVOJTAB	;nova stevilka R1 v tabelo
	STR	R1,[R3,R2]
	BX	LR
DVOJNI3	MOV	R0,#-1		;zastavica R0=-1 za dvojnik
	B	DVOJNI2
	LTORG

;*** Obdelava okvirjev iz HDLC sprejemnika *** (R0-9)+OBDELA,PRESKOK,KISSRX
	ALIGN	16
HOBDELA	STR	LR,[SP,#-4]!
	LDR	R0,=HRXVMES	;obstojeci okvir?
	BL	IZVMES
	MOVS	R8,R8
	LDREQ	PC,[SP],#4
	LDRH	R0,[R8,#2]	;izlusci naslov v R1
	ADD	R0,R0,#4
	LDR	R1,[R8,R0]
	LDR	R0,=MNASLOV	;brez naslova >>> KISS sprejemnik?
	LDR	R0,[R0]
	MOVS	R0,R0
	BEQ	KISSRX
	CMP	R0,R1		;moj naslov?
	BEQ	HOBDEL1
	MVNS	R0,R1		;naslov VSEM=0xFFFFFFFF?
	BNE	PRESKOK		;preskok vozlja v ASVju?
HOBDEL1	LDRH	R0,[R8]		;podatki ali potrditev?
	CMP	R0,#8
	BEQ	POTRDI		;sprosti potrditev R8 in potrjene podatke
	CMP	R0,#20		;sprosti prekratek okvir?
	BCC	HOBDEL3
	BL	RIZPOKV		;prikazi vse podatke?
	MOV	R3,R8		;stevilka okvirja v potrditev
	LDRH	R0,[R3,#2]	
	LDR	R8,[R3,R0]
	MVNS	R1,R8		;veljavna stevilka?
	BEQ	HOBDEL2
	LDR	R0,=HTPVMES
	BL	VVMES
	LDR	R0,=MPONOVI	;brisi minimum ponavljanja
	MOV	R1,#0
	STRB	R1,[R0]
HOBDEL2	MOV	R8,R3		;preveri in sprosti dvojnik?
	BL	DVOJNIK
	MOVS	R0,R0
	BEQ	OBDELA		;obdelava sprejetih okvirjev
HOBDEL3	BL	SPROSTI		;sprosti prekratek okvir, dvojnik
	LDR	PC,[SP],#4
	LTORG

;*** Obdelava sprejetih okvirjev *** (R0-8,SP+4)
DATAMIN	EQU	8	;min dolzina podatkov za SLIP okvir
	ALIGN	16
OBDELA	LDRH	R0,[R8,#2]	;izlusci naslednji naslov, prvo locilo?
	ADD	R0,R0,R8
	ADD	R0,R0,#8
	LDR	R1,[R0],#4
	MOVS	R1,R1
	BNE	USMERI		;usmeri okvir R8 po dodatnih naslovih
	LDRH	R1,[R8]		;poisci zacetek vsebine (drugo locilo)
	SUBS	R1,R1,#12
OBDELA1	SUBS	R1,R1,#4
	BMI	OBDELA3		;sprosti okvir brez dveh locil
	LDR	R2,[R0],#4
	MOVS	R2,R2
	BNE	OBDELA1
	LDR	R2,[R0]		;nicla za besedilo?
	MOVS	R2,R2
	BEQ	OBDELA2
	BL	ANAJDI		;najdi vpis v tabelo ARP
	SUB	R0,R0,R8	;zacetek vsebine
	STRH	R0,[R8,#2]
	STRH	R1,[R8]		;dolzina vsebine, sprosti prekratko?
	CMP	R1,#DATAMIN
	BCC	OBDELA3
	LDR	R2,=LNASLOV	;lokalno vkljuceno?
	LDR	R2,[R2]
	MOVS	R2,R2
	LDR	R0,=STXVMES	;v SLIP oddajni vmesnik
	LDRNE	R0,=ETXVMES	;v ETH oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
OBDELA2	BL	UIZPOKV		;prikazi uporabne okvirje
	B	JAVISE		;javi se na ukaz "////"
OBDELA3	BL	SPROSTI		;brez dveh locil, lokalno, prekratka vsebina
	LDR	PC,[SP],#4
	LTORG

;*** Preskok vozlja v ASVju *** (R0-9,SP+4)
	ALIGN	16
PRESKOK	LDR	R2,=LNASLOV	;primerjava R1 z lokalnimi naslovi
	MOV	R3,#MAXLOK
	MOV	R9,#0		;izracunaj oddaljenost cilja v R9
PRESKO1	MOV	R9,R9,LSL#4
	ORR	R9,R9,#10
	LDR	R0,[R2],#4	;konec vpisov v seznamu lokalnih?
	MOVS	R0,R0
	BEQ	PRESKO2
	CMP	R0,R1		;nasel lokalni naslov?
	BEQ	PRESKO3
	SUBS	R3,R3,#1	;konec seznama lokalnih?
	BNE	PRESKO1
PRESKO2	BL	SPROSTI		;ni lokalni, prekratek, dvojnik, ni preskok, brez locila
	LDR	PC,[SP],#4
PRESKO3	LDRH	R0,[R8]		;sprosti prekratek okvir?
	CMP	R0,#20
	BCC	PRESKO2
	BL	RIZPOKV		;prikazi vse podatke?
	MOV	R3,R8		;stevilka okvirja v potrditev
	LDRH	R0,[R3,#2]	
	LDR	R8,[R3,R0]
	LDR	R0,=HTPVMES
	BL	VVMES
	LDR	R0,=MPONOVI	;brisi minimum ponavljanja
	MOV	R1,#0
	STRB	R1,[R0]
	MOV	R8,R3		;preveri in sprosti dvojnik?
	BL	DVOJNIK
	MOVS	R0,R0
	BNE	PRESKO2
	LDRH	R0,[R8,#2]	;izlusci naslednji naslov, ni locilo?
	ADD	R0,R0,R8
	LDR	R1,[R0,#8]
	MOVS	R1,R1
	BEQ	PRESKO2		;sprosti, ce ni preskok
	ADD	R0,R0,#4	;zavrti naslove navzdol
	MOV	R2,#MAXNAS
PRESKO4	LDR	R1,[R0,#4]
	STR	R1,[R0],#4
	MOVS	R1,R1
	BEQ	PRESKO5
	SUBS	R2,R2,#1
	BNE	PRESKO4
	B	PRESKO2		;sprosti brez locila
PRESKO5	LDR	R1,=MNASLOV	;dodaj moj naslov na konec
	LDR	R1,[R1]
	STR	R1,[R0]
	LDRH	R1,[R8,#2]	;oddaljenost cilja iz R9 v okvir
	STR	R9,[R8,R1]
	LDR	R0,=STXVMES	;okvir v SLIP oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
	LTORG

;*** KISS sprejemnik v LPC2368/2387 *** (R0-2,R8,SP+4)
	ALIGN	16
KISSRX	LDR	R0,=LNASLOV	;KISS ali Ethernet<>SLIP?
	LDR	R0,[R0]
	MOVS	R0,R0
	BEQ	KISSRX1
	BL	SPROSTI		;sprosti za Ethernet<>SLIP pretvornik
	LDR	PC,[SP],#4
KISSRX1	BL	RIZPOKV		;prikazi vse okvirje?
	LDRH	R0,[R8]		;podaljsaj vsebino za 1 byte
	ADD	R0,R0,#1
	STRH	R0,[R8]
	LDRH	R1,[R8,#2]	;vsebina 1byte navzgor, zacetek #0 
	ADD	R1,R1,R8
	MOV	R2,#0
KISSRX2	SWPB	R2,R2,[R1]
	ADD	R1,R1,#1
	SUBS	R0,R0,#1
	BNE	KISSRX2
	LDR	R0,=STXVMES	;okvir v SLIP oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
	LTORG

;*** Javi se na ukaz "////" *** (R0-8,SP+4)+ODDAJA
JAVISE	LDRH	R0,[R8,#2]	;poisci ukaz (tri locila)
	ADD	R0,R0,R8
	LDRH	R4,[R8]
	MOV	R2,#2
JAVISE1	LDR	R3,[R0],#4
	SUBS	R4,R4,#4
	BMI	JAVISE9
	MOVS	R3,R3
	SUBEQ	R2,R2,#1
	MOVS	R2,R2
	BPL	JAVISE1
	LDR	R2,=0x2F2F2F2F	;ukaz "////"?
	LDR	R3,[R0]
	SUBS	R4,R4,#4
	BMI	JAVISE9
	CMP	R3,R2
	BNE	JAVISE9
	LDR	R0,=JAVITXT	;javljanje vklopljeno?
	LDRB	R0,[R0]
	CMP	R0,#32
	BCC	JAVISE9
	LDRH	R1,[R8,#2]	;preskoci stevilko okvirja
	ADD	R1,R1,R8
	ADD	R1,R1,#4
	ADD	R2,R1,#8	;naslovi dve mesti navzdol
	MOV	R3,#MAXNAS
JAVISE2	LDR	R0,[R2],#4
	MOVS	R0,R0
	BEQ	JAVISE3
	STR	R0,[R1],#4
	SUBS	R3,R3,#1
	BPL	JAVISE2
JAVISE3	MOV	R0,#0		;prvo locilo znakov
	STR	R0,[R1],#4
	LDR	R0,=MNASLOV	;vstavi moj naslov
	LDR	R0,[R0]
	STR	R0,[R1],#4
	MOV	R0,#0		;drugo locilo znakov
	STR	R0,[R1],#4
	MOV	R0,#0		;oznaka besedila
	STR	R0,[R1],#4
	LDR	R0,=0x2A2A2A2A	;vstavi "****" za preprecitev zankanja
	STR	R0,[R1],#4
	LDRB	R0,[R1]
	CMP	R0,#"#"		;javljanje PHY stanja?
	BEQ	JPHYSTS
	CMP	R0,#"/"		;javljanje stanja?
	BEQ	JSTANJE
	CMP	R0,#">"		;merilni odziv?
	BEQ	JODZIV
	CMP	R0,#"?"		;javljanje besedila?
	BEQ	JBESED
	CMP	R0,#"@"		;telekomanda in javljanje ADC?
	BEQ	KJADC
	LDR	R2,=JAVISE6	;vstavi neznano javljanje
JAVISE4	LDRB	R0,[R2],#1
	CMP	R0,#32
	BCC	JAVISE5
	STRB	R0,[R1],#1
	B	JAVISE4
JAVISE5	LDRH	R0,[R8,#2]	;izracunaj dolzino sestavljenega okvirja
	SUB	R1,R1,R8
	SUB	R1,R1,R0
	STRH	R1,[R8]
	BL	UBRISI		;brisi natipkan ukaz
	LDR	R3,=JAVISE7	;javi neznano javljanje
	BL	TXTIZP
	BL	UPPISI		;ponovni izpisi natipkan ukaz
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
JAVISE6 DCB	" Nepoznan daljinski ukaz (#,/,>,?,@) ****",0
JAVISE7	DCB	"!!! Javljam nepoznan ukaz !!!",13,10,0
	ALIGN	4
	LTORG
JAVISE9	BL	SPROSTI
	LDR	PC,[SP],#4

;*** Javi besedilo *** (R0-8,SP+4)+ODDAJA
JBESED	LDR	R2,=JAVITXT	;vstavi besedilo javljanja
	MOV	R3,#MAXJAVI
JBESED1	LDRB	R0,[R2],#1
	CMP	R0,#32
	BCC	JBESED2
	STRB	R0,[R1],#1
	SUBS	R3,R3,#1
	BNE	JBESED1
JBESED2	LDRH	R0,[R8,#2]	;izracunaj dolzino sestavljenega okvirja
	SUB	R1,R1,R8
	SUB	R1,R1,R0
	STRH	R1,[R8]
	BL	UBRISI		;brisi natipkan ukaz
	LDR	R3,=JBESED3	;javi javljanje besedila
	BL	TXTIZP
	BL	UPPISI		;ponovni izpisi natipkan ukaz
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
JBESED3	DCB	"!!! Javljam besedilo !!!",13,10,0
	ALIGN	4
	LTORG

;*** Merilni odziv *** (R0-8,SP+4)+ODDAJA
JODZIV	BL	UBRISI		;brisi natipkan ukaz
	LDR	R3,=JODZIV1	;javi merilni odziv
	BL	TXTIZP
	BL	UPPISI		;ponovni izpisi natipkan ukaz
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
JODZIV1	DCB	"!!! Merilni odziv !!!",13,10,0
	ALIGN	4
	LTORG

;*** Javi stanje *** (R0-8,SP+4)+ODDAJA
JSTANJE	MOV	R7,R1		;vstavi stanje v (R7)+
	LDR	R1,=ZNACIN
	LDRB	R0,[R1]
	ORR	R0,R0,#8
	STRB	R0,[R1]
	MOV	R0,#32		;presledek
	BL	ZNAK
	BL	STANJE
	LDR	R1,=ZNACIN	;preklop na zaslon
	LDRB	R0,[R1]
	BIC	R0,R0,#8
	STRB	R0,[R1]
	LDRH	R0,[R8,#2]	;izracunaj dolzino sestavljenega okvirja
	SUB	R1,R7,R8
	SUB	R1,R1,R0
	STRH	R1,[R8]
	BL	UBRISI		;brisi natipkan ukaz
	LDR	R3,=JSTANJ1	;javi javljanje stanja
	BL	TXTIZP
	BL	UPPISI		;ponovni izpisi natipkan ukaz
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
JSTANJ1	DCB	"!!! Javljam stanje !!!",13,10,0
	ALIGN	4
	LTORG

;*** Javi PHY stanje *** (R0-8,SP+4)+ODDAJA
JPHYSTS	MOV	R7,R1		;vstavi stanje v (R7)+
	LDR	R1,=ZNACIN
	LDRB	R0,[R1]
	ORR	R0,R0,#8
	STRB	R0,[R1]
	MOV	R0,#32		;presledek
	BL	ZNAK
	MOV	R3,#0x10	;PHY Status Register
	BL	PHYSTS		;PHY register R3 preberi stanje v R2
	MOV	R5,R2
	MOV	R3,#0x1A	;10Base-T Status/Control Register
	BL	PHYSTS		;PHY register R3 preberi stanje v R2
	BL	PHYMAC		;izpisi PHY status (R5) in sogovornikov MAC
	LDR	R1,=ZNACIN	;preklop na zaslon
	LDRB	R0,[R1]
	BIC	R0,R0,#8
	STRB	R0,[R1]
	LDRH	R0,[R8,#2]	;izracunaj dolzino sestavljenega okvirja
	SUB	R1,R7,R8
	SUB	R1,R1,R0
	STRH	R1,[R8]
	BL	UBRISI		;brisi natipkan ukaz
	LDR	R3,=JPHYST1	;javi javljanje stanja
	BL	TXTIZP
	BL	UPPISI		;ponovni izpisi natipkan ukaz
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
JPHYST1	DCB	"!!! Javljam PHY stanje !!!",13,10,0
	ALIGN	4
	LTORG

;*** Telekomanda in javi ADC v LPC2368/2387 *** (R0-8,SP+4)+ODDAJA,RIZVEDI
KJADC	MOV	R7,R1		;vstavi stanje v (R7)+
	MOV	R2,R1		;zakljuci z 0 ukaz iz (R2)+
	MOV	R0,#0
	STRB	R0,[R2,R4]
	BL	HVHOD		;telekomanda?
	MOVS	R1,R1
	BMI	KJADC1
	MOV	R4,R0
	BL	HVHOD		;geslo?
	LDR	R1,=GESLO
	LDR	R1,[R1]
	CMP	R1,#-1		;VSEM?
	MOVEQ	R0,R1
	CMP	R0,R1
	BNE	KJADC1
	CMP	R4,R1		;RESET (ukaz enak geslu)?
	BEQ	RIZVEDI
	TST	R4,#0x00000001	;izvedi telekomando
	LDR	R0,=0x3FFFC03B	;FIO1SET3
	LDREQ	R0,=0x3FFFC03F  ;FIO1CLR3
	MOV	R1,#0x80
	STRB	R1,[R0]
KJADC1	LDR	R1,=ZNACIN	;javi ADC in telekomando
	LDRB	R0,[R1]
	ORR	R0,R0,#8
	STRB	R0,[R1]
	MOV	R0,#32		;presledek
	BL	ZNAK
	BL	ADCK
	LDR	R1,=ZNACIN	;preklop na zaslon
	LDRB	R0,[R1]
	BIC	R0,R0,#8
	STRB	R0,[R1]
	LDRH	R0,[R8,#2]	;izracunaj dolzino sestavljenega okvirja
	SUB	R1,R7,R8
	SUB	R1,R1,R0
	STRH	R1,[R8]
	BL	UBRISI		;brisi natipkan ukaz
	LDR	R3,=KJADC2	;javi javljanje stanja
	BL	TXTIZP
	BL	UPPISI		;ponovni izpisi natipkan ukaz
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
KJADC2	DCB	"!!! Telekomanda in javljanje ADC !!!",13,10,0
	ALIGN	4
	LTORG

;*** Usmeri okvir R8 po dodatnih naslovih *** (R0-8,SP+4)+ODDAJA
	ALIGN	16
USMERI	LDRH	R0,[R8,#2]	;zavrti naslove navzdol
	ADD	R0,R0,R8
	ADD	R0,R0,#4
	MOV	R2,#MAXNAS
USMERI1	LDR	R1,[R0,#4]
	STR	R1,[R0],#4
	MOVS	R1,R1
	BEQ	USMERI2
	SUBS	R2,R2,#1
	BNE	USMERI1
	BL	SPROSTI		;sprosti okvir brez locila
	LDR	PC,[SP],#4
USMERI2	LDR	R1,=MNASLOV	;dodaj moj naslov na konec
	LDR	R1,[R1]
	STR	R1,[R0]
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
	LTORG

;*** Okvir R8 v oddajo HDLC/SLIP *** (R0-3,R8,SP+4)
	ALIGN	16
ODDAJA	LDRH	R0,[R8,#2]	;poisci naslov med lokalnimi?
	ADD	R0,R0,R8
	LDR	R3,[R0,#4]
	LDR	R2,=LNASLOV
	MOV	R1,#MAXLOK
ODDAJA1	LDR	R0,[R2],#4
	MVNS	R0,R0		;lokalno VSEM?
	BEQ	ODDAJA4
	MVNS	R0,R0		;konec vpisov v seznamu lokalnih?
	BEQ	ODDAJA2
	CMP	R0,R3		;nasel lokalni naslov?
	BEQ	ODDAJA4
	SUBS	R1,R1,#1	;konec seznama lokalnih?
	BNE	ODDAJA1
ODDAJA2	BL	PSEVNAK		;nova stevilka okvirja za HDLC
	LDRH	R1,[R8,#2]
	STR	R0,[R8,R1]
	LDR	R0,=MPONOVI	;brisi minimum ponavljanja
	MOV	R1,#0
	STRB	R1,[R0]
	LDR	R0,=NPONOVI	;novo stevilo ponavljanj
	LDRB	R1,[R0]
	STRB	R1,[R8,#4]
	MOV	R0,#0		;zakasnitev ponavljanja 0
	STRB	R0,[R8,#5]
	LDRH	R0,[R8,#2]	;naslov VSEM=0xFFFFFFFF?
	ADD	R0,R0,#4
	LDR	R1,[R8,R0]
	MVNS	R2,R1
	BNE	ODDAJA3
	LDRH	R0,[R8,#2]	;stevilka VSEM in nic ponavljanja
	STR	R1,[R8,R0]
	MOV	R0,#0
	STRB	R0,[R8,#4]
ODDAJA3	BL	HDLCCRC		;izracunaj CRC
	LDR	R0,=HTXVMES	;okvir v HDLC oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
ODDAJA4	MOV	R0,#-1		;stevilka VSEM za SLIP
	LDRH	R1,[R8,#2]
	STR	R0,[R8,R1]
	LDR	R0,=STXVMES	;okvir v SLIP oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
	LTORG

;*** Sprosti potrditev R8 in potrjene podatke *** (R0-8,SP+4)
	ALIGN	16
POTRDI	BL	RIZPOKV		;prikazi vse potrditve?
	LDRH	R0,[R8,#2]	;stevilka potrditve v R3
	LDR	R3,[R8,R0]
	BL	SPROSTI		;sprosti potrdilni okvir
POTRDI1	LDR	R0,=HTXVMES	;podatkovni okvirji
	BL	IZVMES
	MOVS	R8,R8
	BEQ	POTRDI3
	LDRH	R0,[R8,#2]	;stevilka okvirja
	LDR	R4,[R8,R0]
	CMP	R4,R3
	BEQ	POTRDI2
	LDR	R0,=HTZVMES	;nepotrjeni v zacasni vmesnik
	BL	VVMES
	B	POTRDI1
POTRDI2	BL	SPROSTI		;sprosti potrjeni okvir
	LDR	R1,=MPONOVI	;minimum ponavljanja MAX=255
	MOV	R0,#-1
	STRB	R0,[R1]
	B	POTRDI1
POTRDI3	LDR	R0,=HTZVMES	;iz zacasnega vmesnika
	BL	IZVMES
	MOVS	R8,R8
	BEQ	POTRDI4
	LDRB	R0,[R8,#5]	;poisci minimum ponavljanja
	LDR	R1,=MPONOVI
	LDRB	R2,[R1]
	CMP	R2,R0
	STRBCS	R0,[R1]
	LDR	R0,=HTXVMES	;v oddajni vmesnik
	BL	VVMES
	B	POTRDI3
POTRDI4	LDR	R0,=HTPVMES	;cakajoce stevilke potrditev na oddajo?
	LDRH	R1,[R0]
	LDRH	R2,[R0,#2]
	CMP	R1,R2
	LDREQ	PC,[SP],#4
	LDR	R1,=MPONOVI	;minimum ponavljanja MIN=0
	MOV	R0,#0
	STRB	R0,[R1]
	LDR	PC,[SP],#4
	LTORG

;*** Najdi vpis v tabelo ARP (R0,R1,R8) *** (R2-6)
MINIP4	EQU	21		;najmanjsa dolzina IP4 okvirja
IP4MIN	EQU	0x45		;prvi znak IP4 okvirja (MIN in MAX)
IP4MAX	EQU	0x50
IPIZVOR	EQU	12		;odmik IP4 izvora
MINAX25	EQU	16		;najmanjsa dolzina AX25 okvirja (KISS)
AXKISS	EQU	0		;zacetni znak AX25 KISS okvirja
AXIZVOR	EQU	13		;odmik AX.25 izvora
	ALIGN	16
ANAJDI	LDR	R2,=ANACIN	;vpis vklopljen (nacin 2,3,6 ali 7)?
	LDRB	R2,[R2]
	TST	R2,#2
	BXEQ	LR
	TST	R2,#4		;najdi izvor IP4 ali AX25?
	BNE	ANAJDI5
	CMP	R1,#MINIP4	;najmanjsa dolzina IP4 okvirja?
	BXCC	LR
	LDRB	R2,[R0]		;prvi znak IP4 okvirja?
	CMP	R2,#IP4MIN
	BXCC	LR
	CMP	R2,#IP4MAX
	BXCS	LR
	LDR	R2,=ZNASLOV	;prepisi IP posiljatelja
	LDR	R3,[R0,#IPIZVOR]
	STR	R3,[R2],#4
	B	ANAJDI6
ANAJDI5	CMP	R1,#MINAX25	;najmanjsa dolzina AX25 okvirja?
	BXCC	LR
	LDRB	R2,[R0]		;prvi znak AX25 KISS okvirja?
	CMP	R2,#AXKISS
	BXNE	LR
	MOV	R2,#AXIZVOR	;prepisi AX25 izvor modulo 36 v R3
	ADD	R2,R2,R0
	MOV	R3,#0
	MOV	R4,#6
ANAJDI7	LDRB	R5,[R2],#-1	;preveri nov byte sodo stevilo?
	TST	R5,#1
	BXNE	LR
	MOV	R5,R5,LSR#1	;pretvori nov byte v R5
	CMP	R5,#64
	ANDCC	R5,R5,#15	;nova stevilka
	ANDCS	R5,R5,#31	;nova crka
	ADDCS	R5,R5,#9
	ADD	R3,R3,R3,LSL#3	;pomnozi R3 s 36 in pristej R5
	ADD	R3,R5,R3,LSL#2
	SUBS	R4,R4,#1
	BNE	ANAJDI7
	LDR	R2,=ZNASLOV
	STR	R3,[R2],#4
ANAJDI6	LDRH	R3,[R8,#2]	;prepisi naslov
	ADD	R3,R3,R8
	ADD	R3,R3,#12
	MOV	R4,#MAXNAS
ANAJDI1	LDR	R5,[R3],#4
	STR	R5,[R2],#4
	MOVS	R5,R5
	BEQ	ANAJDI2
	SUBS	R4,R4,#1
	BNE	ANAJDI1
ANAJDI2	LDR	R2,=ANACIN	;nacin 3/7=VPIS?
	LDRB	R2,[R2]
	TST	R2,#1
	BNE	AVNOS		;vnos v tabelo ARP - 3/7=vedno!
	LDR	R2,=INASLOV	;primerjaj INASLOV<>ZNASLOV?
	LDR	R3,=ZNASLOV
	ADD	R3,R3,#4
	MOV	R4,#MAXNAS
ANAJDI3 LDR	R5,[R2],#4
	LDR	R6,[R3],#4
	CMP	R5,R6
	BNE	AVNOS		;vnos v tabelo ARP - 2/6=razlicno!
	MOVS	R5,R5
	BEQ	ANAJDI4
	SUBS	R4,R4,#1
	BNE	ANAJDI3
ANAJDI4	MOV	R2,#0		;brisanje privzete poti
	LDR	R3,=ZNASLOV
	STR	R2,[R3,#4]
	B	AVNOS		;brisanje iz tabele ARP - 2/6=enako!
	LTORG

;*** Vnos v tabelo ARP *** (R2-6)
	ALIGN	16
AVNOS	LDR	R5,=ZNASLOV	;poisci enak IP v tabeli ARP
	LDR	R6,=ANASLOV
	MOV	R2,#MAXARP
	LDR	R3,[R5]
AVNOS1	LDR	R4,[R6]
	CMP	R3,R4
	BEQ	AVNOS3
	SUBS	R2,R2,#1
	BEQ	AVNOS2
	ADD	R6,R6,#AKORAK
	B	AVNOS1
AVNOS2	LDR	R3,[R5,#4]	;izloci brisanje neobstojecega IP?
	MOVS	R3,R3
	BXEQ	LR
AVNOS3	LDR	R3,[R5,#4]	;brisanje obstojecega IP?
	MOVS	R3,R3
	BEQ	AVNOS7
	ADD	R2,R6,#AKORAK	;prepisi staro vsebino navzgor
	LDR	R4,=ANASLOV
AVNOS4	CMP	R4,R6
	BEQ	AVNOS5
	LDR	R3,[R6,#-4]!
	STR	R3,[R2,#-4]!
	B	AVNOS4
AVNOS5	MOV	R2,#AKORAK	;prepisi novi veljavni vnos na zacetek
AVNOS6	LDR	R3,[R5],#4
	STR	R3,[R4],#4
	SUBS	R2,R2,#4
	BNE	AVNOS6
	BX	LR
AVNOS7	SUBS	R2,R2,#1	;prepisi staro vsebino navzdol
	BEQ	AVNOS9
	ADD	R5,R6,#AKORAK
	MOV	R4,#AKORAK
AVNOS8	LDR	R3,[R5],#4
	STR	R3,[R6],#4
	SUBS	R4,R4,#4
	BNE	AVNOS8
	B	AVNOS7
AVNOS9	MOV	R2,#0		;neveljaven vnos na konec
	STR	R2,[R6,#4]
	BX	LR
	LTORG

;*** Cilj okvirja [R8] iz ARP tabele v R0 *** (R0-2,R4-5)
IPCILJ	EQU	16		;odmik IP4 cilja
AXCILJ	EQU	6		;odmik AX25 cilja
	ALIGN	16
ACILJ	LDR	R1,=ANACIN	;ARP izklopljen?
	LDRB	R1,[R1]
	TST	R1,#3
	BXEQ	LR
	TST	R1,#4
	BNE	ACILJ3
	LDRH	R1,[R8]		;najmanjsa dolzina IP4 okvirja?
	CMP	R1,#MINIP4
	BXCC	LR
	LDRH	R1,[R8,#2]	;prvi znak IP4 okvirja?
	ADD	R1,R1,R8
	LDRB	R2,[R1]
	CMP	R2,#IP4MIN
	BXCC	LR
	CMP	R2,#IP4MAX
	BXCS	LR
	LDR	R2,[R1,#IPCILJ]	;prepisi ciljni IP naslovnika v R2
	B	ACILJ4
ACILJ3	LDRH	R1,[R8]		;najmanjsa dolzina AX25 okvirja?
	CMP	R1,#MINAX25
	BXCC	LR
	LDRH	R1,[R8,#2]	;prvi znak AX25 KISS okvirja?
	ADD	R1,R1,R8
	LDRB	R2,[R1]
	CMP	R2,#AXKISS
	BXNE	LR
	ADD	R1,R1,#AXCILJ	;cilnji AX25 naslovnika modulo 36 v R2
	MOV	R2,#0
	MOV	R4,#6
ACILJ5	LDRB	R5,[R1],#-1	;pretvori nov byte v R5
	MOV	R5,R5,LSR#1
	CMP	R5,#64
	ANDCC	R5,R5,#15	;nova stevilka
	ANDCS	R5,R5,#31	;nova crka
	ADDCS	R5,R5,#9
	ADD	R2,R2,R2,LSL#3	;pomnozi R2 s 36 in pristej R5
	ADD	R2,R5,R2,LSL#2
	SUBS	R4,R4,#1
	BNE	ACILJ5
ACILJ4	LDR	R1,=ANASLOV	;poisci ciljni IP naslovnika v R2
	MOV	R4,#MAXARP
ACILJ1	LDR	R5,[R1]
	CMP	R5,R2
	BEQ	ACILJ2
	ADD	R1,R1,#AKORAK
	SUBS	R4,R4,#1
	BNE	ACILJ1
	BX	LR
ACILJ2	LDR	R5,[R1,#4]	;preveri naslov cilja
	MOVS	R5,R5
	ADDNE	R0,R1,#4	;veljaven naslov v R0
	BX	LR
	LTORG

;*** Obdelava SLIP okvirjev *** (R0-8)
	ALIGN	16
SOBDELA	STR	LR,[SP,#-4]!
	LDR	R0,=SRXVMES	;iz sprejemnega vmesnika
	BL	IZVMES
	MOVS	R8,R8
	LDREQ	PC,[SP],#4
	LDR	R0,=MNASLOV	;brez naslova >>> KISS oddajnik?
	LDR	R0,[R0]
	MOVS	R0,R0
	BEQ	KISSTX
	LDR	R1,=LNASLOV	;lokalno vkljuceno?
	LDR	R1,[R1]
	MOVS	R1,R1
	BEQ	IPODDAJ		;oddaja IP okvirjev
	BL	LIZPOKV		;prikazi vse lokalno sprejete okvirje
	LDRH	R2,[R8,#2]	;kazalec R2 in zivljenjska doba R1
	ADD	R2,R2,R8
	LDR	R1,[R2]
	CMP	R1,#10		;preskok okvirja v oddajo?
	BEQ	ODDAJA
	AND	R0,R1,#15	;okvir brez preskoka?
	CMP	R0,#15
	BNE	SOBDEL1
	LDR	R3,[R2,#4]	;naslov R3
	LDR	R0,=MNASLOV	;moj naslov?
	LDR	R0,[R0]
	CMP	R0,R3
	BEQ	OBDELA		;obdelava sprejetih okvirjev
	MVNS	R0,R3		;naslov VSEM?
	BEQ	OBDELA		;obdelava sprejetih okvirjev
SOBDEL1	MOVS	R1,R1,LSR#4	;zmanjsaj zivljenjsko dobo
	STR	R1,[R2]
	BNE	SOBDEL2		;preveri zivljenjsko dobo?
	BL	SPROSTI
	LDR	PC,[SP],#4
SOBDEL2	LDR	R0,=STXVMES	;okvir v SLIP oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
	LTORG

;*** Oddaja IP okvirjev *** (R0-5,R8,SP+4)+ODDAJA
	ALIGN	16
IPODDAJ	LDRH	R3,[R8,#2]	;preverjeni kazalec R3?
	CMP	R3,#WINSZAC
	BNE	IPODDA2
	ADD	R3,R3,R8
	MOV	R0,#0		;vstavi locilo
	STR	R0,[R3,#-4]!
	LDR	R0,=MNASLOV	;vstavi MNASLOV
	LDR	R0,[R0]
	STR	R0,[R3,#-4]!
	MOV	R0,#0		;vstavi locilo
	STR	R0,[R3,#-4]!
	LDR	R0,=INASLOV	;prepisi INASLOV
	BL	ACILJ		;cilj iz ARP tabele?
	LDR	R1,[R0]		;neobstojec naslov?
	MOVS	R1,R1
	BEQ	IPODDA2
	MOV	R1,#MAXNAS
	ADD	R0,R0,R1,LSL#2
	MOV	R4,R3
IPODDA1	LDR	R2,[R0,#-4]!
	STR	R2,[R3,#-4]!
	MOVS	R2,R2
	MOVEQ	R3,R4
	SUBS	R1,R1,#1
	BNE	IPODDA1
	SUB	R3,R3,#4	;prostor za stevilko okvirja
	SUB	R3,R3,R8	;izracunaj nov zacetek
	LDRH	R0,[R8,#2]
	STRH	R3,[R8,#2]
	LDRH	R1,[R8]		;izracunaj novo dolzino
	ADD	R1,R1,R0
	SUB	R1,R1,R3
	STRH	R1,[R8]
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
IPODDA2	BL	SPROSTI		;sprosti napacni zacetek
	LDR	PC,[SP],#4
	LTORG

;*** KISS oddajnik *** (R0-2,R8,SP+4)
KISSTX	LDR	R0,=LNASLOV	;lokalno vkljuceno SLIP >>> Ethernet?
	LDR	R0,[R0]
	MOVS	R0,R0
	BEQ	KISSTX0
	LDR	R0,=ETXVMES	;v ETH oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
KISSTX0	LDRH	R0,[R8]		;skrajsa 1 byte
	SUB	R0,R0,#1
	STRH	R0,[R8]
	LDRH	R1,[R8,#2]	;prepisi ostanek 1 byte navzdol
	ADD	R1,R1,R8
KISSTX1	LDRB	R2,[R1,#1]	
	STRB	R2,[R1],#1
	SUBS	R0,R0,#1
	BNE	KISSTX1
	LDR	R0,=MPONOVI	;brisi minimum ponavljanja
	MOV	R1,#0
	STRB	R1,[R0]
	MOV	R0,#0		;brez ponavljanj
	STRB	R0,[R8,#4]
	MOV	R0,#0		;zakasnitev ponavljanja 0
	STRB	R0,[R8,#5]
	BL	HDLCCRC		;izracunaj CRC
	LDR	R0,=HTXVMES	;v HDLC oddajni vmesnik
	BL	VVMES
	LDR	PC,[SP],#4
	LTORG

;*** Inacica programa in ID mikrokrmilnika *** (R0-4)+IAP
INACICA	STR	LR,[SP,#-4]!
	LDR	R3,=INACIC1	;izpisi inacico programa
	BL	TXTIZP
	LDR	R0,=IAPCMD	;Read part identification number
	MOV	R2,#54		;Command code 54
	STR	R2,[R0]
	LDR	R1,=IAPRES
	LDR	R2,=IAPADDR	;klic na IAP naslov
	MOV	LR,PC
	BX	R2
	LDR	R0,=IAPRES	;Result0 v R3
	LDR	R3,[R0,#4]
	BL	HEXIZP
	LDR	R3,=INACIC2
	BL	TXTIZP
	LDR	PC,[SP],#4
INACIC1	DCB	13,10,"*** Ethernet ArmTNC - S53MV 21.08.2011 ID=",0
INACIC2	DCB	" ***",13,10,0
	ALIGN	4
	LTORG

;*** Zacetek programa po resetu LPC2368/2387 ***
ZACNI	LDR	SP,=SKLAD	;inicializiraj SP
	BL	INIPAR		;inicializiraj parametre iz FLASH
	BL	INITAKT		;preveri takt ARM procesorja
	BL	PESJAN		;vkljuci psa cuvaja v LPC2368/2387
	BL	INIBLOK		;razrezi RAM v bloke dolzine 1632=0x660 v LPC2368/2387
	BL	INIVMES		;inicializiraj vse vmesnike v LPC2368/2387
	BL	INICRC		;izracunaj tabelo za racunanje CRCja
	BL	INIDVOJ		;inicializiraj tabelo dvojnikov
	BL	PINGPIO		;izberi PIN in GPIO v LPC2368/2387
	BL	PLLMAM		;inicializiraj PLL in MAM v LPC2368/2387
	BL	PWRCLK		;vklop in takt I/O enot LPC2368/2387
	BL	TIMER0		;inicializiraj Timer0
	BL	UART0		;inicializiraj UART0
	BL	UART1		;inicializiraj UART1
	BL	SSP1		;inicializiraj SSP1 v LPC2368/2387
	BL	INIETH		;inicializiraj Ethernet v LPC2368/2387
	BL	VIC		;nastavi prekinitve
	BL	INACICA		;inacica programa in ID mikrokrmilnika
	BL	IRQON		;vkljuci prekinitve IRQ in FIQ v ARM
	B	ZANKA		;glavna zanka programa
	LTORG

;*** Glavna hitra zanka programa v LPC2368/2387 ***
	ALIGN	16
ZANKA	BL	SLIPTX		;SLIP oddaja UART1
	BL	ETHRX		;sprejem Ethernet okvirjev
	BL	PREKLOP		;HDLC preklop sprejem/oddaja v LPC2368/2387
	BL	SOBDELA		;obdelava SLIP okvirjev 
	BL	HOBDELA		;obdelava okvirjev iz HDLC sprejemnika
	BL	PSEVNAK		;polinomski izvor (2^32-1) v R0
	LDR	R0,=SZANK	;stevec zank
	LDR	R1,[R0]
	ADD	R1,R1,#1
	STR	R1,[R0]
	LDR	R0,=0xE0004008	;T0TC - Timer0
	LDR	R1,[R0]
	LDR	R0,=MIKRSEK	;mikrosekundni stevec
	LDRH	R2,[R0]
	SUB	R1,R1,R2
	MOVS	R1,R1,LSL#16
	BMI	ZANKA
;*** Milisekundna zanka programa ***
	ADD	R2,R2,#1000
	STRH	R2,[R0]
	LDR	R0,=0x3FFFC014	;FIO0PIN0 P0.5=/DCD?
	LDRB	R0,[R0]
	TST	R0,#0x20
	LDR	R2,=SDCD	;stevec DCD
	LDRHEQ	R1,[R2]
	ADDEQ	R1,R1,#1
	STRHEQ	R1,[R2]
	LDR	R0,=0x3FFFC097	;FIO4PIN3 P4.28 sprejem/oddaja?
	LDRB	R0,[R0]
	TST	R0,#0x10
	LDR	R2,=SPTT	;stevec PTT
	LDRHEQ	R1,[R2]
	ADDEQ	R1,R1,#1
	STRHEQ	R1,[R2]
	BL	EODDAJ		;Ethernet oddaja IP okvirjev z ARP
	BL	UKAZ		;ukaz iz UART0 v LPC2368/2387
	BL	ZASLON		;zaslon na UART0 v LPC2368/2387
	LDR	R0,=MILISEK	;milisekundni stevec
	LDRH	R1,[R0]
	ADD	R1,R1,#1
	STRH	R1,[R0]
	CMP	R1,#1000
	BCC	ZANKA
;*** Sekundna zanka programa ***
	MOV	R1,#0
	STRH	R1,[R0]
	LDR	R0,=SDCD	;prepisi SDCD v NDCD in reset SDCD
	LDRH	R2,[R0]
	LDR	R1,=NDCD
	STRH	R2,[R1]
	MOV	R2,#0
	STRH	R2,[R0]
	LDR	R0,=SPTT	;prepisi SPTT v NPTT in reset SPTT
	LDRH	R2,[R0]
	LDR	R1,=NPTT
	STRH	R2,[R1]
	MOV	R2,#0
	STRH	R2,[R0]
	LDR	R0,=SZANK	;prepisi SZANK v NZANK in reset SZANK
	LDR	R2,[R0]
	LDR	R1,=NZANK
	STR	R2,[R1]
	MOV	R2,#0
	STR	R2,[R0]
	LDR	R0,=SEKUNDA	;sekundni stevec
	LDR	R1,[R0]
	ADD	R1,R1,#1
	STR	R1,[R0]
	BL	PESCUVA	;pes cuva sprejem v LPC2368/2387
	BL	SSTANJE	;izpis stanja vsako sekundo?
	BL	STSPEED	;nastavi Ethernet hitrost / izpis PHY vsako sekundo
	BL	ODZIV	;oddaja meritve odziva?
	BL	SCACHE	;staranje EthernetARP cacheja
	BL	KOKODAK	;kokodakanje istega sporocila?
	B	ZANKA
	LTORG

;*** Izpis stanja vsako sekundo *** (R0-4)
SSTANJE	LDR	R0,=ZNACIN
	LDRB	R0,[R0]
	TST	R0,#4
	BXEQ	LR
	STR	LR,[SP,#-4]!	;resi link
	BL	UBRISI		;brisi natipkan ukaz
	BL	STANJE
	BL	UPPISI		;ponovni izpisi natipkan ukaz
	LDR	PC,[SP],#4

;*** Izpisi %DCD, %PTT, bloki, zanke in cas *** (R0-4)
STANJE	STR	LR,[SP,#-4]!	;resi link
	LDR	R3,=STANJE1	;odstotek DCD XX.X%
	BL	TXTIZP
	LDR	R0,=NDCD
	LDRH	R3,[R0]
	BL	DEC1IZP
	LDR	R3,=STANJE2	;odstotek PTT XX.X%
	BL	TXTIZP
	LDR	R0,=NPTT
	LDRH	R3,[R0]
	BL	DEC1IZP
	LDR	R3,=STANJE3	;stevilo prostih blokov
	BL	TXTIZP
	BL	PROSTO
	MOV	R3,R0
	BL	DECIZP
	LDR	R3,=STANJE4	;stevilo zank/s
	BL	TXTIZP
	LDR	R0,=NZANK
	LDR	R3,[R0]
	BL	DECIZP
	LDR	R3,=STANJE5	;cas delovanja
	BL	TXTIZP
	LDR	R0,=SEKUNDA
	LDR	R3,[R0]
	MOV	R0,#60		;preracunaj v dneve/ure/minute/sekunde
	BL	NDELI
	STR	R0,[SP,#-4]!
	MOV	R0,#60
	BL	NDELI
	STR	R0,[SP,#-4]!
	MOV	R0,#24
	BL	NDELI
	STR	R0,[SP,#-4]!
	BL	DECIZP		;izpisi d/h/min/s
	LDR	R3,=STANJE6
	BL	TXTIZP
	LDR	R3,[SP],#4
	BL	DECIZP
	LDR	R3,=STANJE7
	BL	TXTIZP
	LDR	R3,[SP],#4
	BL	DECIZP
	LDR	R3,=STANJE8
	BL	TXTIZP
	LDR	R3,[SP],#4
	BL	DECIZP
	LDR	R3,=STANJE9
	BL	TXTIZP
	LDR	PC,[SP],#4
STANJE1 DCB	"DCD: ",0
STANJE2	DCB	"% PTT: ",0
STANJE3	DCB	"% ",0
STANJE4	DCB	"blok ",0
STANJE5	DCB	"zank/s ",0
STANJE6	DCB	"d/",0
STANJE7	DCB	"h/",0
STANJE8	DCB	"min/",0
STANJE9	DCB	"s",13,10,0
	ALIGN	4
	LTORG

;*** Izpisi ADC telemetrijo in telekomando v LPC2368/2387 *** (R0-6)
ADCK	STR	LR,[SP,#-4]!	;resi link
	LDR	R5,=NENOTA	;Yskala/enota
	LDR	R3,=ADCK1	;#1
	BL	TXTIZP
	LDR	R0,=0xE0034000	;AD0CR START=001,PDN=1,CLKS=11,CLKDIV=16,SEL=1
	LDR	R1,=0x01201002
	STR	R1,[R0]
	BL	ADCK4		;preberi in izpisi ADC TLM
	LDR	R3,=ADCK2	;#2
	BL	TXTIZP
	LDR	R0,=0xE0034000	;AD0CR START=001,PDN=1,CLKS=11,CLKDIV=16,SEL=3
	LDR	R1,=0x01201008
	STR	R1,[R0]
	BL	ADCK4		;preberi in izpisi ADC TLM
	LDR	R3,=ADCK3	;telekomanda
	BL	TXTIZP
	LDR	R0,=0x3FFFC037	;FIO1PIN3 P1.31 telekomanda?
	LDRB	R3,[R0]
	MOV	R3,R3,LSR#7
	BL	DECIZP
	LDR	PC,[SP],#4
ADCK1	DCB	"1:",0
ADCK2	DCB	" 2:",0
ADCK3	DCB	" K:",0
	ALIGN	4
ADCK4	STR	LR,[SP,#-4]!	;preberi in izpisi ADC TLM
ADCK5	LDR	R0,=0xE0034004	;AD0GDR
	LDR	R3,[R0]
	TST	R3,#0x80000000
	BEQ	ADCK5
	MOV	R3,R3,LSL#16
	MOV	R3,R3,LSR#22
	MOV	R6,R3
	BL	DECIZP		;surovi izpis ADC
	MOV	R0,#"="
	BL	ZNAK
	LDR	R0,[R5],#4	;mnozenje s konstanto
	MUL	R3,R6,R0
	LDR	R0,[R5],#4	;odmik od vrednosti/1024
	ADDS	R3,R0,R3,ASR#10
	RSBMI	R3,R3,#0	;obrni predznak?
	MOV	R0,#"-"
	BLMI	ZNAK
	BL	DEC1IZP		;izpis na eno decimalko
	LDR	R3,[R5],#4	;izpis 4 znakov merske enote
	BL	ADCK6
	BL	ADCK6
	BL	ADCK6
	BL	ADCK6
	LDR	PC,[SP],#4
ADCK6	MOV	R3,R3,ROR#24	;izpis znaka brez nicle
	ANDS	R0,R3,#255
	BNE	ZNAK
	BX	LR
	LTORG

;*** Staranje EthernetARP cacheja *** (R0-4)
SCACHE	LDR	R0,=KCACHE	;kazalec v R3
	LDR	R3,[R0]
	LDR	R2,=ECACHE	;osnovni naslov v R2
	ADD	R2,R2,#10
	MOV	R4,#MCACHE
SCACHE1	CMP	R3,#MCACHE	;preveri kazalec?
	MOVCS	R3,#MCACHE
	SUBCS	R3,R3,#1
	ADD	R1,R2,R3,LSL#4
	LDRH	R0,[R1]		;konec veljavnih vpisov?
	MOVS	R0,R0
	BXEQ	LR
	SUB	R0,R0,#1	;zmanjsaj zivljenjsko dobo
	STRH	R0,[R1]
	SUB	R3,R3,#1
	SUBS	R4,R4,#1
	BNE	SCACHE1
	BX	LR
	LTORG

;*** Nastavi Ethernet hitrost / izpis PHY vsako sekundo *** (R0-5)
STSPEED	STR	LR,[SP,#-4]!	;resi link
	MOV	R3,#0x10	;PHY Status Register
	BL	PHYSTS		;PHY register R3 preberi stanje v R2
	MOV	R5,R2
	MOV	R3,#0x1A	;10Base-T Status/Control Register
	BL	PHYSTS		;PHY register R3 preberi stanje v R2
	LDR	R0,=0xFFE00018	;SUPP=100M(RMII)
	MOV	R1,#0x100
	TST	R5,#2		;hitrost 10M=1?
	MOVNE	R1,#0
	TST	R5,#1		;veljaven podatek LINK=1?
	STRNE	R1,[R0]
	LDR	R0,=ZNACIN	;sekundni izpis vklopljen?
	LDRB	R0,[R0]
	TST	R0,#16
	LDREQ	PC,[SP],#4
	BL	UBRISI		;brisi natipkan ukaz
	BL	PHYMAC		;izpisi PHY status (R5) in sogovornikov MAC
	BL	UPPISI		;ponovni izpisi natipkan ukaz
	LDR	PC,[SP],#4

;*** Izpisi PHY status (R5) in sogovornikov MAC *** (R0-5)
PHYMAC	STR	LR,[SP,#-4]!	;resi link
	LDR	R3,=PHYMAC1	;izpis MDI
	TST	R5,#0x4000
	LDRNE	R3,=PHYMAC2	;izpis MDIX?
	BL	TXTIZP
	LDR	R3,=PHYMAC3	;izpis POL?
	TST	R5,#0x1000
	BLNE	TXTIZP
	LDR	R3,=PHYMAC4	;izpis ANC?
	TST	R5,#0x0010
	BLNE	TXTIZP
	LDR	R3,=PHYMAC5	;izpis DUP?
	TST	R5,#0x0004
	BLNE	TXTIZP
	LDR	R3,=PHYMAC6	;izpis 10M?
	TST	R5,#0x0002
	BLNE	TXTIZP
	LDR	R3,=PHYMAC7	;izpis LINK?
	TST	R5,#0x0001
	BLNE	TXTIZP
	LDR	R3,=PHYMAC8	;izpisi sogovornikov MAC
	BL	TXTIZP
	LDR	R5,=MACMAC
	BL	MACIZP
	MOV	R0,#13
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	LDR	PC,[SP],#4
PHYMAC1	DCB	"MDI",0
PHYMAC2	DCB	"MDIX",0
PHYMAC3	DCB	" POL",0
PHYMAC4	DCB	" ANC",0
PHYMAC5	DCB	" DUP",0
PHYMAC6	DCB	" 10M",0
PHYMAC7	DCB	" LINK",0
PHYMAC8	DCB	" MAC: ",0
	ALIGN	4
	LTORG

;*** Sestavi odziv N byte *** (R0-4,R8)+ODDAJA
ODZZAC	EQU	8
ODZIV	STR	LR,[SP,#-4]!	;resi link
	LDR	R0,=NODZIV	;odziv vkljucen?
	LDRH	R0,[R0]
	MOVS	R0,R0
	LDREQ	PC,[SP],#4
	LDR	R0,=MNASLOV	;KISS RX/TX?
	LDR	R0,[R0]
	MOVS	R0,R0
	LDREQ	PC,[SP],#4	
	LDR	R0,=NASLOV	;NASLOV obstaja?
	LDR	R0,[R0]
	MOVS	R0,R0
	LDREQ	PC,[SP],#4
	BL	DODELI		;dodeli blok za odziv, obstaja?
	MOVS	R8,R8
	LDREQ	PC,[SP],#4
	MOV	R0,#ODZZAC	;zacetek sestavljanja odziva
	STRH	R0,[R8,#2]
	ADD	R4,R0,R8	;kazalec sestavljanja R4
	ADD	R4,R4,#4	;prostor za stevilko
	LDR	R2,=NASLOV	;naslov v okvir
	MOV	R3,#MAXNAS
ODZIV1	LDR	R0,[R2],#4
	MOVS	R0,R0
	BEQ	ODZIV2
	STR	R0,[R4],#4
	SUBS	R3,R3,#1
	BNE	ODZIV1
ODZIV2	MOV	R0,#0		;locilo na koncu naslova v okvir
	STR	R0,[R4],#4
	LDR	R0,=MNASLOV	;moj naslov v okvir
	LDR	R0,[R0]
	STR	R0,[R4],#4
	MOV	R0,#0		;locilo po mojem naslovu v okvir
	STR	R0,[R4],#4
	MOV	R0,#0		;oznaka besedila v okvir
	STR	R0,[R4],#4
	LDR	R0,=0x2F2F2F2F	;oznaka javljanja "////"
	STR	R0,[R4],#4
	LDR	R0,=0x3E3E3E3E	;oznaka meritve odziva ">>>>"
	STR	R0,[R4],#4
	LDR	R0,=0xE0004008	;vstavi T0TC - Timer0 v R3
	LDR	R3,[R0]
	STR	R3,[R4],#4
	LDR	R0,=NODZIV	;vstavi preizkusno zaporedje N byte
	LDRH	R2,[R0]
ODZIV3	MOV	R0,#8
ODZIV4	ADDS	R3,R3,R3	;polinom 1+X^28+X^31
	EORMI	R3,R3,#1
	TST	R3,#0x10000000
	EORNE	R3,R3,#1
	SUBS	R0,R0,#1
	BNE	ODZIV4
	STRB	R3,[R4],#1	;nov byte v odziv
	SUBS	R2,R2,#1
	BNE	ODZIV3
	SUB	R4,R4,R8	;izracunaj dolzino sestavljenega okvirja
	LDRH	R1,[R8,#2]
	SUB	R4,R4,R1
	STRH	R4,[R8]
	BL	UBRISI		;brisi natipkan ukaz
	MOV	R0,#"!"		;napisi ! za oddani odziv
	BL	ZNAK
	BL	UPPISI		;ponovni izpisi natipkan ukaz
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
	LTORG

;*** Meritev odziva *** (R0-7)
MERI	STR	LR,[SP,#-4]!	;resi link
	CMP	R5,#16		;dolzina podatkov?
	LDRCC	PC,[SP],#4
	LDR	R0,[R6]		;nicla za besedilo?
	MOVS	R0,R0
	LDRNE	PC,[SP],#4
	LDR	R0,[R6,#4]	;"////" za javise?
	LDR	R1,=0x2F2F2F2F
	CMP	R0,R1
	BEQ	MERI1
	LDR	R0,[R6,#4]	;"****" za javljanje?
	LDR	R1,=0x2A2A2A2A
	CMP	R0,R1
	LDRNE	PC,[SP],#4
MERI1	LDR	R0,[R6,#8]	;">>>>" za meritev odziva?
	LDR	R1,=0x3E3E3E3E
	CMP	R0,R1
	LDRNE	PC,[SP],#4
	MOV	R0,#32		;izpisi odziv
	BL	ZNAK
	LDR	R0,=0xE0004008	;T0TC - Timer0 v R3
	LDR	R3,[R0]
	LDR	R7,[R6,#12]	;odstej cas odziva R7
	SUBS	R3,R3,R7
	RSBMI	R3,R3,#0	;obrni predznak?
	MOV	R0,#"-"
	BLMI	ZNAK
	MOV	R0,#100		;deli s 100 za korak 0.1ms
	BL	NDELI
	BL	DEC1IZP
	LDR	R3,=MERI5
	BL	TXTIZP
	SUB	R5,R5,#16	;preskoci glavo odziva
	ADD	R6,R6,#16
	MOV	R3,R5		;izpisi stevilo byte
	BL	DECIZP
	LDR	R3,=MERI6
	BL	TXTIZP
	MOV	R3,#0		;resetiraj stevec napak R3
	BL	MERI4
MERI2	MOV	R0,#8
MERI3	ADDS	R7,R7,R7	;polinom 1+X^28+X^31
	EORMI	R7,R7,#1
	TST	R7,#0x10000000
	EORNE	R7,R7,#1
	SUBS	R0,R0,#1
	BNE	MERI3
	LDRB	R1,[R6],#1	;primerjaj izracunano in sprejeto
	EOR	R1,R1,R7
	TST	R1,#255
	ADDNE	R3,R3,#1
MERI4	SUBS	R5,R5,#1
	BPL	MERI2
	BL	DECIZP		;izpisi stevilo napak
	LDR	R3,=MERI7
	BL	TXTIZP
	LDR	PC,[SP],#4
MERI5	DCB	"ms ",0
MERI6	DCB	"byte ",0
MERI7	DCB	"napak",0
	ALIGN	4
	LTORG

;*** Ukaz iz UART0 v LPC2368/2387 *** (R0-2)+IZVEDI
	ALIGN	16
UKAZ	LDR	R0,=0xE000C014	;U0LSR bit0=ReceiveDataReady?
	LDRB	R1,[R0]
	TST	R1,#0x01
	BXEQ	LR
	STR	LR,[SP,#-4]!	;resi link
	LDR	R0,=0xE000C000	;U0RBR sprejeti znak 7bit v R0
	LDRB	R0,[R0]
	AND	R0,R0,#0x7F
	LDR	R2,=TIPVMES	;vmesnik R2 in kazalec R1
	LDRH	R1,[R2]
	CMP	R0,#127		;brisanje DEL?
	BEQ	UKAZ1
	CMP	R0,#8		;brisanje BS?
	BEQ	UKAZ1
	CMP	R0,#32		;CR ali kontrolni znak za konec ukaza?
	BCC	UKAZ4
	CMP	R1,#MAXUKAZ	;znak v vmesnik za tipke
	LDRCS	PC,[SP],#4
	ADD	R1,R1,#1
	STRH	R1,[R2]
	ADD	R1,R1,#1
	STRB	R0,[R2,R1]
	BL	ZNAK
	LDR	PC,[SP],#4
UKAZ1	SUBS	R1,R1,#1	;popravi kazalec nazaj
	LDRMI	PC,[SP],#4
	STRH	R1,[R2]
	BNE	UKAZ3		;brisi veljavno vrstico?
	MOV	R0,#32
	MOV	R1,#MAXUKAZ
	ADD	R2,R2,#2
UKAZ2	STRB	R0,[R2],#1
	SUBS	R1,R1,#1
	BPL	UKAZ2
UKAZ3	MOV	R0,#8		;brisi znak na zaslonu
	BL	ZNAK
	MOV	R0,#32
	BL	ZNAK
	MOV	R0,#8
	BL	ZNAK
	LDR	PC,[SP],#4
UKAZ4	ADD	R1,R1,#1	;povecaj kazalec
	STRH	R1,[R2]
	ADD	R1,R1,#1
	MOV	R0,#13		;CR v vmesnik, CR+LF na zaslon
	STRB	R0,[R2,R1]
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	BL	IZVEDI		;izvedi natipkan ukaz
	LDR	R0,=TIPVMES	;resetiraj tipke
	MOV	R1,#0
	STRH	R1,[R0]
	LDR	PC,[SP],#4
	LTORG

;*** Kokodakanje istega sporocila *** (R0-3)+SESTAVI
KOKODAK	STR	LR,[SP,#-4]!	;resi link
	LDR	R0,=ZNACIN	;cvekalni nacin?
	LDRB	R1,[R0]
	TST	R1,#1
	LDREQ	PC,[SP],#4
	LDR	R0,=TIPVMES	;prazen ukaz?
	LDRH	R1,[R0]
	MOVS	R1,R1
	LDRNE	PC,[SP],#4
	LDR	R0,=KSTEVEC	;odstevaj uro kokodakanja
	LDRB	R1,[R0]
	SUBS	R1,R1,#1
	STRB	R1,[R0]
	LDRNE	PC,[SP],#4
	LDRB	R1,[R0,#1]	;nova casovna meja
	STRB	R1,[R0]
	MOVS	R1,R1		;cvekanje brez kokodakanja?
	LDREQ	PC,[SP],#4
	LDR	R1,=TIPVMES	;preveri odtipkano vrstico?
	ADD	R1,R1,#2
	MOV	R2,#MAXUKAZ
KOKODA1	LDRB	R0,[R1],#1
	CMP	R0,#32
	BCC	KOKODA2
	SUBS	R2,R2,#1
	BPL	KOKODA1
	LDR	PC,[SP],#4
KOKODA2	LDR	R3,=TIPVMES	;kokodakanje odtipkane vrstice
	ADD	R3,R3,#2
KOKODA3	LDRB	R0,[R3],#1
	CMP	R0,#32
	BCC	KOKODA4
	BL	ZNAK
	B	KOKODA3
KOKODA4	MOV	R0,#13		;povratek v novo vrsto
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	B	SESTAVI
	LTORG

;*** Sestavi sporocilo *** (R0-4,R8,SP+4)+ODDAJA
SESTZAC	EQU	8
SESTAVI	LDR	R0,=TIPVMES	;samo CR v ukazu?
	LDRB	R0,[R0,#2]
	CMP	R0,#32
	BCS	SESTAV2
	LDR	R0,=ZNACIN	;preklop v ukazni nacin
	LDRB	R1,[R0]
	BIC	R1,R1,#1
	STRB	R1,[R0]
	LDR	R3,=SESTAV1
	BL	TXTIZP
	LDR	PC,[SP],#4
SESTAV1	DCB	"*** Ukazni nacin ***",13,10,0
	ALIGN	4
SESTAV2	LDR	R0,=MNASLOV	;KISS RX/TX?
	LDR	R0,[R0]
	MOVS	R0,R0
	BEQ	SESTAV3	
	LDR	R0,=NASLOV	;NASLOV obstaja?
	LDR	R0,[R0]
	MOVS	R0,R0
	BEQ	SESTAV3	
	BL	DODELI		;dodeli blok za sporocilo
	MOVS	R8,R8
	BNE	SESTAV5
SESTAV3	LDR	R3,=SESTAV4
	BL	TXTIZP
	LDR	PC,[SP],#4
SESTAV4	DCB	"*** Sporocilo izgubljeno ***",13,10,0
	ALIGN	4
SESTAV5	MOV	R0,#SESTZAC	;zacetek sestavljanja
	STRH	R0,[R8,#2]
	ADD	R4,R0,R8	;kazalec sestavljanja R4
	ADD	R4,R4,#4	;prostor za stevilko
	LDR	R2,=NASLOV	;naslov v okvir
	MOV	R3,#MAXNAS
SESTAV6	LDR	R0,[R2],#4
	MOVS	R0,R0
	BEQ	SESTAV7
	STR	R0,[R4],#4
	SUBS	R3,R3,#1
	BNE	SESTAV6
SESTAV7	MOV	R0,#0		;locilo na koncu naslova v okvir
	STR	R0,[R4],#4
	LDR	R0,=MNASLOV	;moj naslov v okvir
	LDR	R0,[R0]
	STR	R0,[R4],#4
	MOV	R0,#0		;locilo po mojem naslovu v okvir
	STR	R0,[R4],#4
	MOV	R0,#0		;oznaka besedila v okvir
	STR	R0,[R4],#4
	LDR	R2,=TIPVMES	;besedilo ukaza v okvir
	ADD	R2,R2,#2
SESTAV8	LDRB	R0,[R2],#1
	STRB	R0,[R4],#1
	CMP	R0,#32
	BCS	SESTAV8
	SUB	R4,R4,R8	;izracunaj dolzino sestavljenega okvirja
	LDRH	R1,[R8,#2]
	SUB	R4,R4,R1
	STRH	R4,[R8]
	B	ODDAJA		;okvir R8 v oddajo HDLC/SLIP
	LTORG

;*** Desetisko stevilo (R2) v R0 zastavica R1 *** (R0-2)
DVHOD	MOV	R1,#-1		;neveljavna zastavica -1
	LDRB	R0,[R2]
	CMP	R0,#32		;konec ukaza?
	BXCC	LR
	ADD	R2,R2,#1
	SUBS	R0,R0,#48
	BCC	DVHOD
	CMP	R0,#10
	BCS	DVHOD
DVHOD1	LDRB	R1,[R2]		;veljavna stevilka?
	SUBS	R1,R1,#48
	BCC	DVHOD2
	CMP	R1,#10
	BCS	DVHOD2
	ADD	R0,R0,R0,LSL#2	;pomnozi z 10 in pristej stevilko
	ADD	R0,R1,R0,LSL#1
	ADD	R2,R2,#1
	B	DVHOD1
DVHOD2	MOV	R1,#0		;veljavna zastavica 0
	BX	LR

;*** IP4 naslov v R3 zastavica R1 *** (R0-3)
IVHOD	STR	LR,[SP,#-4]!
	BL	DVHOD		;vnos prve IP stevilke?
	MOVS	R1,R1
	LDRMI	PC,[SP],#4
	AND	R3,R0,#255
	BL	DVHOD		;vnos druge IP stevilke?
	MOVS	R1,R1
	LDRMI	PC,[SP],#4
	AND	R0,R0,#255
	ORR	R3,R0,R3,ROR#8
	BL	DVHOD		;vnos tretje IP stevilke?
	MOVS	R1,R1
	LDRMI	PC,[SP],#4
	AND	R0,R0,#255
	ORR	R3,R0,R3,ROR#8
	BL	DVHOD		;vnos cetrte IP stevilke?
	AND	R0,R0,#255
	ORR	R3,R0,R3,ROR#8
	MOV	R3,R3,ROR#8
	LDR	PC,[SP],#4

;*** Hexadecimalno stevilo (R2) v R0 zastavica R1 *** (R0-2)
HVHOD	MOV	R1,#-1		;neveljavna zastavica -1
	LDRB	R0,[R2]
	CMP	R0,#32		;konec ukaza?
	BXCC	LR
	ADD	R2,R2,#1
	CMP	R0,#48		;nepravi znak <0?
	BCC	HVHOD
	CMP	R0,#96		;male crke v velike
	SUBCS	R0,R0,#32
	CMP	R0,#71		;neprava crka >F?
	BCS	HVHOD
	CMP	R0,#58
	SUBCS	R0,R0,#23	;crka v hex
	CMP	R0,#42		;nepravi znaki 58...64?
	BCC	HVHOD
	AND	R0,R0,#15
HVHOD1	LDRB	R1,[R2]
	CMP	R1,#48		;nepravi znak <0 ali konec ukaza?
	BCC	HVHOD2
	CMP	R1,#96		;male crke v velike
	SUBCS	R1,R1,#32
	CMP	R1,#71		;neprava crka >F?
	BCS	HVHOD2
	CMP	R1,#58
	SUBCS	R1,R1,#23	;crka v hex
	CMP	R1,#42		;nepravi znaki 58...64?
	BCC	HVHOD2
	AND	R1,R1,#15
	ADD	R0,R1,R0,LSL#4	;pomnozi s 16 in pristej stevilko
	ADD	R2,R2,#1
	B	HVHOD1
HVHOD2	MOV	R1,#0		;veljavna zastavica 0
	BX	LR

;*** Naslov36 (R2) v R0 zastavica R1 *** (R0-2)
NVHOD	LDR	R0,=ZNACIN	;vkljucen HEX?
	LDRB	R0,[R0]
	TST	R0,#32
	BNE	HVHOD
	MOV	R1,#-1		;neveljavna zastavica -1
	LDRB	R0,[R2]
	CMP	R0,#32		;konec ukaza?
	BXCC	LR
	ADD	R2,R2,#1	;povecaj kazalec
	CMP	R0,#"*"		;naslov VSEM?
	BEQ	NVHOD3	
	CMP	R0,#48		;nepravi znak <0?
	BCC	NVHOD
	CMP	R0,#96		;male crke v velike
	SUBCS	R0,R0,#32
	CMP	R0,#91		;neprava crka >Z?
	BCS	NVHOD
	CMP	R0,#58		;veljavna stevilka+71?
	ADDCC	R0,#71
	CMP	R0,#65		;nepravi znaki 58...64?
	BCC	NVHOD
	ADD	R0,R0,#9
	AND	R0,R0,#63
	STR	R3,[SP,#-4]!	;resi R3
	MOV	R3,#1
NVHOD1	ADD	R3,R3,R3,LSL#3	;pomnozi R3 s 36
	MOV	R3,R3,LSL#2
	LDRB	R1,[R2]
	CMP	R1,#48		;konec ukaza ali nepravi znak <0?
	BCC	NVHOD2
	CMP	R1,#96		;male crke v velike
	SUBCS	R1,R1,#32
	CMP	R1,#91		;neprava crka >Z?
	BCS	NVHOD2
	CMP	R1,#58		;veljavna stevilka+71?
	ADDCC	R1,#71
	CMP	R1,#65		;nepravi znaki 58...64?
	BCC	NVHOD2
	ADD	R1,R1,#9
	AND	R1,R1,#63
	MLA	R0,R1,R3,R0	;R0=R1*R3+R0
	ADD	R2,R2,#1	;povecaj kazalec
	B	NVHOD1
NVHOD2	LDR	R3,[SP],#4	;vrni R3
	MOV	R1,#0		;veljavna zastavica 0
	BX	LR
NVHOD3	MOV	R0,#-1		;naslov VSEM
	MOV	R1,#0		;veljavna zastavica 0
	BX	LR

;*** Izvedi natipkan ukaz *** (R0-6)+SESTAVI
IZVEDI	STR	LR,[SP,#-4]!
	LDR	R0,=ZNACIN	;ukazni/pogovorni nacin?
	LDRB	R0,[R0]
	TST	R0,#1
	BNE	SESTAVI
	LDR	R2,=TIPVMES	;ukaz v (R2)
	ADD	R2,R2,#2
	LDRB	R0,[R2],#1	;prvi znak ukaza
	CMP	R0,#96		;mala crka v veliko?
	SUBCS	R0,R0,#32
	CMP	R0,#"A"		;ukaz A?
	BEQ	AIZVEDI
	CMP	R0,#"B"		;ukaz B?
	BEQ	BIZVEDI
	CMP	R0,#"C"		;ukaz C?
	BEQ	CIZVEDI	
	CMP	R0,#"D"		;ukaz D?
	BEQ	DIZVEDI	
	CMP	R0,#"E"		;ukaz E?
	BEQ	EIZVEDI
	CMP	R0,#"F"		;ukaz F?
	BEQ	FIZVEDI
	CMP	R0,#"G"		;ukaz G?
	BEQ	GIZVEDI
	CMP	R0,#"H"		;ukaz H?
	BEQ	HIZVEDI
	CMP	R0,#"I"		;ukaz I?
	BEQ	IIZVEDI
	CMP	R0,#"J"		;ukaz J?
	BEQ	JIZVEDI
	CMP	R0,#"K"		;ukaz K?
	BEQ	KIZVEDI
	CMP	R0,#"L"		;ukaz L?
	BEQ	LIZVEDI
	CMP	R0,#"M"		;ukaz M?
	BEQ	MIZVEDI
	CMP	R0,#"N"		;ukaz N?
	BEQ	NIZVEDI
	CMP	R0,#"O"		;ukaz O?
	BEQ	OIZVEDI
	CMP	R0,#"P"		;ukaz P?
	BEQ	PIZVEDI
	CMP	R0,#"Q"		;ukaz Q?
	BEQ	QIZVEDI
	CMP	R0,#"R"		;ukaz R?
	BEQ	RIZVEDI
	CMP	R0,#"S"		;ukaz S?
	BEQ	SIZVEDI
	CMP	R0,#"T"		;ukaz T?
	BEQ	TIZVEDI
	CMP	R0,#"U"		;ukaz U?
	BEQ	UIZVEDI
	CMP	R0,#"V"		;ukaz V?
	BEQ	VIZVEDI
	CMP	R0,#"W"		;ukaz W?
	BEQ	WIZVEDI
	CMP	R0,#"X"		;ukaz X?
	BEQ	XIZVEDI
	CMP	R0,#"Y"		;ukaz Y?
	BEQ	YIZVEDI
	CMP	R0,#"Z"		;ukaz Z?
	BEQ	ZIZVEDI
	CMP	R0,#"?"		;ukaz "?"
	LDR	R3,=IZVEDI1	;nepoznan ukaz
	LDREQ	R3,=IZVEDI2	;seznam ukazov
	BL	TXTIZP
	LDR	PC,[SP],#4
IZVEDI1	DCB	"!!! Nepoznan ukaz (A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z,?)",13,10,0
IZVEDI2	DCB	"*** Seznam veljavnih ukazov Ethernet ArmTNC ***",13,10
	DCB	"A <IP/AX> <naslov#1> <naslov#2> <naslov#3> - (A)RP usmerjanje",13,10
	DCB	"B <baudrate> - nastavi (B)audrate za UART1 (SLIP)",13,10
	DCB	"C <perioda> - (C)vekanje / kokodakanje (izhod: prazna vrstica)",13,10
	DCB	"D <IP> <sprejmi> <zavrni> - IP (D)domena",13,10
	DCB	"E <hitrost-X> <naslov> - (E)thernet hitrost, MDIX in MAC naslov",13,10
	DCB	"F <kljuc> - vpis trenutnih parametrov v (F)LASH in RESET EATNC",13,10
	DCB	"G <prehod> <maska> <trajanje> - (G)ateway in EthernetARP cache",13,10
	DCB	"H <preklop> - oblika vnosa/izpisa naslovov N36/(H)EX",13,10
	DCB	"I <naslov#1> <naslov#2> <naslov#3> - (I)P/AX privzeti naslov",13,10
	DCB	"J <besedilo> - besedilo (J)avljanja (izklop: prazna vrstica)",13,10
	DCB	"K <ukaz> <geslo> - (K)omanda in geslo z izpisom ADC",13,10
	DCB	"L <naslov#1> <naslov#2> <naslov#3> - naslovi (L)okalne zanke",13,10
	DCB	"M <naslov> - (M)oj naslov (0=KISS/SLIP<>Ethernet)",13,10
	DCB	"N <naslov#1> <naslov#2> <naslov#3> - (N)aslov za pogovor/meritev",13,10
	DCB	"O <stevilo> - meritev (O)dziva stevila byte, 0=izklop",13,10
	DCB	"P <stevilo> <zakasnitev> <minblok> - (P)onavljanja",13,10
	DCB	"Q <quartz> <takt> - (Q)uartz in takt ARM procesorja",13,10
	DCB	"R - (R)ESET EATNCja",13,10
	DCB	"S <slot> <glava> <rep> - zakasnitve (S)lot, glava in rep",13,10
	DCB	"T <z DCD> <brez DCD> - (T)ecnoba preklopa na oddajo /65536",13,10
	DCB	"U - vkljuci izpis (U)porabnih okvirjev",13,10
	DCB	"V - vkljuci izpis (V)seh okvirjev",13,10
	DCB	"W <zakasnitev> - HayesAT/EthernetARP (W)AIT",13,10
	DCB	"X <vklop/izklop> - izpis MDI(X), POL, ANC, DUP, 10M, LINK, MAC",13,10
	DCB	"Y <m1> <o1> <e1> <m2> <o2> <e2> - (Y)skala/enota TLM 1/2",13,10
	DCB	"Z <vklop/izklop> - izpis %DCD, %PTT, prosto, (Z)ank/s, cas",13,10
	DCB	"? - izpisi ta seznam",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz A - IP4/AX25 usmerjanje *** (R0-6,R8-9,SP+4)
AIZVEDI	LDRB	R0,[R2]
	CMP	R0,#32		;konec ukaza (R2)?
	BCC	AIZVED4
	ADDEQ	R2,R2,#1	;preskoci presledke (R2)?
	BEQ	AIZVEDI
	CMP	R0,#"!"		;! za vnos nacina usmerjanja?
	BNE	AIZVED1
	ADD	R2,R2,#1
	BL	DVHOD
	MOVS	R1,R1
	BMI	AIZVED4	
	LDR	R3,=ANACIN
	STRB	R0,[R3]
	B	AIZVED4
AIZVED1	LDR	R0,=ANACIN	;vnos naslova IP4 ali AX25 (R2)?
	LDRB	R4,[R0]
	TST	R4,#4
	BNE	AIZVE15
	BL	DVHOD		;vnos prve IP stevilke (R2)?
	MOVS	R1,R1
	BMI	AIZVED4
	AND	R3,R0,#255
	BL	DVHOD		;druga IP stevilka (R2)?
	MOVS	R1,R1
	BMI	AIZVED4
	AND	R0,R0,#255
	ORR	R3,R0,R3,ROR#8
	BL	DVHOD		;tretja IP stevilka (R2)?
	MOVS	R1,R1
	BMI	AIZVED4
	AND	R0,R0,#255
	ORR	R3,R0,R3,ROR#8
	BL	DVHOD		;cetrta IP stevilka (R2)?
	MOVS	R1,R1
	BMI	AIZVED4
	AND	R0,R0,#255
	ORR	R3,R0,R3,ROR#8
	MOV	R3,R3,ROR#8
	B	AIZVE16
AIZVE15	BL	NVHOD		;AX25 naslov modulo 36 (R2)?
	MOVS	R1,R1
	BMI	AIZVED4
	MOV	R3,R0
AIZVE16	LDR	R4,=ZNASLOV
	STR	R3,[R4],#4
	MOV	R3,#MAXNAS	;vnos naslova (R2)
AIZVED2	MOV	R0,#0
	STR	R0,[R4]
	BL	NVHOD
	MOVS	R1,R1
	BMI	AIZVED3
	STR	R0,[R4],#4
	SUBS	R3,R3,#1
	BNE	AIZVED2
AIZVED3	BL	AVNOS		;vnos v tabelo ARP
AIZVED4	LDR	R0,=ANACIN	;izpis nacina IP4 ali AX25
	LDRB	R4,[R0]
	TST	R4,#4
	LDREQ	R3,=AIZVED9
	LDRNE	R3,=AIZVE10
	BL	TXTIZP
	AND	R0,R4,#7	;izpis stevilke nacina
	ADD	R0,R0,#48
	BL	ZNAK
	AND	R4,R4,#3	;izpis nacina uporabe tabele
	LDR	R3,=AIZVE11
	CMP	R4,#1
	LDREQ	R3,=AIZVE12
	CMP	R4,#2
	LDREQ	R3,=AIZVE13
	CMP	R4,#3
	LDREQ	R3,=AIZVE14
	BL	TXTIZP
	LDR	R9,=ANASLOV	;zanka po vpisih v tabeli ARP
	MOV	R8,#MAXARP
AIZVED5	LDR	R0,[R9,#4]
	MOVS	R0,R0
	BEQ	AIZVED8
	MOV	R5,R9
	LDR	R0,=ANACIN	;izpis naslova IP4 iz [R5],#4 ?
	LDRB	R3,[R0]
	TST	R3,#4
	BLEQ	IP4IZP
	LDR	R0,=ANACIN	;izpis naslova AX25 iz [R5],#4 ?
	LDRB	R3,[R0]
	TST	R3,#4
	LDRNE	R3,[R5],#4
	BLNE	N36IZP
	MOV	R6,#MAXNAS	;izpis naslova
AIZVED6	LDR	R3,[R5],#4
	MOVS	R3,R3
	BEQ	AIZVED7
	CMP	R6,#MAXNAS
	MOVEQ	R0,#">"
	MOVNE	R0,#","
	BL	ZNAK
	BL	N36IZP
	SUBS	R6,R6,#1
	BNE	AIZVED6
AIZVED7	MOV	R0,#13		;nova vrsta
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
AIZVED8	ADD	R9,R9,#AKORAK	;nov vpis v tabeli
	SUBS	R8,R8,#1
	BNE	AIZVED5
	LDR	PC,[SP],#4
AIZVED9	DCB	"*** IP4 usmerjanje: ",0
AIZVE10	DCB	"*** AX25 usmerjanje: ",0
AIZVE11	DCB	"=IZKLOP",13,10,0
AIZVE12	DCB	"=BRANJE",13,10,0
AIZVE13	DCB	"=VPIS-PRIVZETO",13,10,0
AIZVE14	DCB	"=VPIS",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz B - nastavi baudrate modulo UART1 *** (R0-4,SP+4)
BIZVEDI	BL	DVHOD		;vnos baudrate?
	MOVS	R1,R1
	BMI	BIZVED1
	LDR	R3,=ARMTAKT	;izracunaj modulo iz PCLK/16
	LDR	R3,[R3]
	MOV	R3,R3,LSR#4
	ADD	R3,R0,LSR#1	;zaokrozi na najblizji modulo
	BL	NDELI
	MOVS	R3,R3		;nenicelni kvocient
	MOVEQ	R3,#1
	LDR	R0,=BAUDMOD
	STRH	R3,[R0]
BIZVED1	LDR	R3,=BIZVED2	;izracunaj baudrate iz modula
	BL	TXTIZP
	LDR	R3,=ARMTAKT	;PCLK/16
	LDR	R3,[R3]
	MOV	R3,R3,LSR#4
	LDR	R0,=BAUDMOD
	LDRH	R0,[R0]
	BL	NDELI
	BL	DECIZP
	LDR	R3,=BIZVED3
	BL	TXTIZP
	LDR	PC,[SP],#4
BIZVED2	DCB	"*** Baudrate UART1: ",0
BIZVED3	DCB	"bit/s (FLASH+RESET)",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz C - preklop v pogovorni nacin / kokodakanje *** (R0-3,SP+4)
CIZVEDI	BL	DVHOD		;perioda kokodakanja?
	MOVS	R1,R1
	MOVMI	R0,#0
	LDR	R1,=KSTEVEC
	STRB	R0,[R1]
	STRB	R0,[R1,#1]
	LDR	R1,=TIPVMES	;brisi veljavno vrstico
	ADD	R1,R1,#2
	MOV	R2,#MAXUKAZ
	MOV	R0,#32
CIZVED1	STRB	R0,[R1],#1
	SUBS	R2,R2,#1
	BPL	CIZVED1
	LDR	R0,=ZNACIN	;preklop v pogovorni nacin
	LDRB	R1,[R0]
	ORR	R1,R1,#1
	STRB	R1,[R0]
	LDR	R0,=KSTEVEC	;izpisi pogovorni nacin?
	LDRB	R1,[R0,#1]
	MOVS	R1,R1
	BNE	CIZVED2
	LDR	R3,=CIZVED3
	BL	TXTIZP	
	LDR	PC,[SP],#4
CIZVED2	LDR	R3,=CIZVED4	;izpisi periodo kokodakanja
	BL	TXTIZP
	LDR	R0,=KSTEVEC
	LDRB	R3,[R0,#1]
	BL	DECIZP
	LDR	R3,=CIZVED5
	BL	TXTIZP
	LDR	PC,[SP],#4
CIZVED3	DCB	"*** Pogovorni nacin ***",13,10,0
CIZVED4	DCB	"*** Kokodakanje s periodo ",0
CIZVED5	DCB	"s ***",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz D - IP domena *** (R0-5,SP+4)
DIZVEDI	LDR	R5,=DOMENA
	BL	IVHOD		;vnos IP domene?
	MOVS	R1,R1
	BMI	DIZVED1
	STR	R3,[R5],#4
	BL	IVHOD		;vnos maske sprejmi?
	MOVS	R1,R1
	BMI	DIZVED1
	STR	R3,[R5],#4
	BL	IVHOD		;vnos maske zavrni?
	MOVS	R1,R1
	BMI	DIZVED1
	STR	R3,[R5],#4
DIZVED1	LDR	R3,=DIZVED2	;izpis stirih IP stevilk domene
	BL	TXTIZP
	LDR	R5,=DOMENA
	BL	IP4IZP		;izpis naslova IP4 iz [R5],#4
	LDR	R3,=DIZVED3	;izpis stirih stevilk maske sprejmi
	BL	TXTIZP
	BL	IP4IZP		;izpis naslova IP4 iz [R5],#4
	LDR	R3,=DIZVED4	;izpis stirih stevilk maske zavrni
	BL	TXTIZP
	BL	IP4IZP		;izpis naslova IP4 iz [R5],#4
	MOV	R0,#13
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	LDR	PC,[SP],#4
DIZVED2	DCB	"*** IP domena: ",0
DIZVED3	DCB	" Sprejmi: ",0
DIZVED4	DCB	" Zavrni: ",0
	ALIGN	4
	LTORG

;*** Ukaz E - Ethernet hitrost, MDIX in MAC naslov *** (R0-6,SP+4)
EIZVEDI	BL	DVHOD		;vnesi Ethernet hitrost in MDIX
	MOVS	R1,R1
	BMI	EIZVED2
	LDR	R1,=ESPEED
	STRB	R0,[R1]
	LDR	R5,=ETHMAC	;vnesi Ethernet MAC naslov
	MOV	R6,#6
EIZVED1	BL	HVHOD
	MOVS	R1,R1
	BMI	EIZVED2
	STRB	R0,[R5],#1
	SUBS	R6,R6,#1
	BNE	EIZVED1
EIZVED2	LDR	R3,=EIZVED3	;izpisi Ethernet hitrost in MDIX
	BL	TXTIZP
	LDR	R3,=EIZVED4
	LDR	R0,=ESPEED
	LDRB	R0,[R0]
	CMP	R0,#10
	LDREQ	R3,=EIZVED5
	CMP	R0,#11
	LDREQ	R3,=EIZVED6
	CMP	R0,#100
	LDREQ	R3,=EIZVED7
	CMP	R0,#101
	LDREQ	R3,=EIZVED8
	BL	TXTIZP
	LDR	R3,=EIZVED9	;izpisi Ethernet MAC naslov
	BL	TXTIZP
	LDR	R5,=ETHMAC
	BL	MACIZP
	LDR	R3,=EIZVED0
	BL	TXTIZP
	LDR	PC,[SP],#4
EIZVED3	DCB	"*** Ethernet: ",0
EIZVED4	DCB	"AutoNegotiation",0
EIZVED5	DCB	"10Mbit/s",0
EIZVED6	DCB	"10Mbit/s-X",0
EIZVED7	DCB	"100Mbit/s",0
EIZVED8	DCB	"101Mbit/s-X",0
EIZVED9	DCB	" MAC: ",0
EIZVED0	DCB	" (FLASH+RESET)",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz F - vpis parametrov v FLASH *** (R0-3,SP+4/RESET)
FIZVEDI	BL	DVHOD
	LDR	R1,=123456789	;kljuc
	CMP	R0,R1
	BEQ	FLASH
	LDR	R3,=FIZVED1
	BL	TXTIZP
	LDR	PC,[SP],#4
FIZVED1	DCB	"*** Napacen kljuc ***",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz G - Gateway/maska in EthernetARP cache *** (R0-7,SP+4)
GIZVEDI	LDR	R5,=GATEWAY
	BL	IVHOD		;vnos IP prizvetega prehoda?
	MOVS	R1,R1
	BMI	GIZVED1
	STR	R3,[R5],#4
	BL	IVHOD		;vnos maske privzetega prehoda?
	MOVS	R1,R1
	BMI	GIZVED1
	STR	R3,[R5],#4
	BL	DVHOD		;vstavi cache trajanje
	MOVS	R1,R1
	BMI	GIZVED1
	LDR	R1,=TCACHE
	STRH	R0,[R1]
GIZVED1	LDR	R3,=GIZVED3	;izpis IP privzetega prehoda
	BL	TXTIZP
	LDR	R5,=GATEWAY
	BL	IP4IZP		;izpis naslova IP4 iz [R5],#4
	LDR	R3,=GIZVED4	;izpis maske privzetega prehoda
	BL	TXTIZP
	BL	IP4IZP		;izpis naslova IP4 iz [R5],#4
	LDR	R3,=GIZVED5	;izpisi cache trajanje
	BL	TXTIZP
	LDR	R0,=TCACHE
	LDRH	R3,[R0]
	BL	DECIZP
	LDR	R3,=GIZVED6
	BL	TXTIZP
	LDR	R0,=KCACHE	;izpisi vsebino cacheja
	LDR	R6,[R0]
	MOV	R7,#MCACHE
GIZVED2	CMP	R6,#MCACHE	;preveri kazalec?
	MOVCS	R6,#MCACHE
	SUBCS	R6,#1
	LDR	R5,=ECACHE	;izracunaj naslov
	ADD	R5,R5,R6,LSL#4
	LDRH	R0,[R5,#10]	;preveri veljaven vnos?
	MOVS	R0,R0
	LDREQ	PC,[SP],#4
	BL	IP4IZP		;izpis naslova IP4 iz [R5],#4
	MOV	R0,#">"		;puscica
	BL	ZNAK
	BL	MACIZP		;izpisi MAC
	MOV	R0,#32		;izpisi cas ARP odgovora
	BL	ZNAK
	LDR	R3,[R5,#2]
	BL	DECIZP
	LDR	R3,=GIZVED7
	BL	TXTIZP
	LDRH	R3,[R5]		;izpisi trajanje
	BL	DECIZP
	LDR	R3,=GIZVED6
	BL	TXTIZP
	SUB	R6,R6,#1
	SUBS	R7,R7,#1
	BNE	GIZVED2
	LDR	PC,[SP],#4
GIZVED3	DCB	"*** Gateway: ",0
GIZVED4	DCB	" / ",0
GIZVED5	DCB	" ARPcache: ",0
GIZVED6	DCB	"s",13,10,0
GIZVED7	DCB	"us/",0
	ALIGN	4
	LTORG

;*** Ukaz H - oblika izpisa N36/HEX *** (R0-4,SP+4)
HIZVEDI	BL	DVHOD		;izberi obliko N36/HEX?
	MOVS	R1,R1
	BMI	HIZVED1
	LDR	R2,=ZNACIN
	LDRB	R1,[R2]
	BIC	R1,R1,#32
	MOVS	R0,R0
	ORRNE	R1,R1,#32
	STRB	R1,[R2]
HIZVED1	LDR	R3,=ZNACIN	;izpisi obliko N36/HEX
	LDRB	R0,[R3]
	LDR	R3,=HIZVED2
	TST	R0,#32
	LDRNE	R3,=HIZVED3
	BL	TXTIZP
	LDR	PC,[SP],#4
HIZVED2	DCB	"*** Oblika: 0=N36(crke+stevilke)",13,10,0
HIZVED3	DCB	"*** Oblika: 1=HEX(8znakov)",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz I - IP naslov *** (R0-7,SP+4)
IIZVEDI	LDR	R6,=INASLOV	;vnos naslova
	MOV	R5,#MAXNAS
	BL	NVHOD
	MOVS	R1,R1
	BMI	IIZVED3
	STR	R0,[R6],#4
	SUB	R5,R5,#1
IIZVED1	BL	NVHOD
	MOVS	R1,R1
	BMI	IIZVED2
	STR	R0,[R6],#4
	SUBS	R5,R5,#1
	BNE	IIZVED1
	B	IIZVED3
IIZVED2	MOV	R0,#0		;nicla na koncu <MAXNAS
	STR	R0,[R6]
IIZVED3	LDR	R3,=IIZVED7	;izpis naslova
	BL	TXTIZP
	LDR	R6,=INASLOV	;INASLOV obstaja?
	LDR	R0,[R6]
	MOVS	R0,R0
	BEQ	IIZVED6
	MOV	R5,#MAXNAS	;izpis veljavnega naslova
	MOV	R7,#32
IIZVED4	LDR	R3,[R6],#4
	MOVS	R3,R3
	BEQ	IIZVED5
	MOV	R0,R7
	MOV	R7,#","
	BL	ZNAK
	BL	N36IZP
	SUBS	R5,R5,#1
	BNE	IIZVED4
IIZVED5	MOV	R0,#13
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	LDR	PC,[SP],#4
IIZVED6	LDR	R3,=IIZVED8	;izpis IZKLOP
	BL	TXTIZP
	LDR	PC,[SP],#4
IIZVED7	DCB	"*** IP/AX privzeto:",0
IIZVED8	DCB	" 0=IZKLOP",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz J - besedilo javljanja na "////" *** (R0-4,SP+4)
JIZVEDI	LDRB	R0,[R2],#1
	CMP	R0,#32		;konec ukaza ali presledek za besedilo?
	BCC	JIZVED2
	BNE	JIZVEDI
	LDR	R1,=JAVITXT	;vnos besedila javljanja
	MOV	R4,#MAXJAVI
JIZVED1	LDRB	R0,[R2],#1
	STRB	R0,[R1],#1
	CMP	R0,#32
	BCC	JIZVED2
	SUBS	R4,R4,#1
	BNE	JIZVED1
JIZVED2	LDR	R1,=JAVITXT	;javljanje vklopljeno?
	LDRB	R0,[R1]
	CMP	R0,#32
	BCC	JIZVED5
	LDR	R3,=JIZVED6	;izpis besedila javljanja
	BL	TXTIZP
	LDR	R3,=JAVITXT
	MOV	R4,#MAXJAVI
JIZVED3	LDRB	R0,[R3],#1
	CMP	R0,#32
	BCC	JIZVED4
	BL	ZNAK
	SUBS	R4,R4,#1
	BNE	JIZVED3
JIZVED4	MOV	R0,#13		;nova vrsta na koncu
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	LDR	PC,[SP],#4
JIZVED5	LDR	R3,=JIZVED7	;izpis javljanje izklopljeno
	BL	TXTIZP
	LDR	PC,[SP],#4
JIZVED6	DCB	"*** Javi: ",0
JIZVED7	DCB	"*** Javljanje izklopljeno ***",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz K - komanda in geslo z izpisom ADC v LPC2368/2387 *** (R0-6)
KIZVEDI	BL	HVHOD		;nova telekomanda?
	MOVS	R1,R1
	BMI	KIZVED1
	TST	R0,#0x00000001
	LDR	R0,=0x3FFFC03B	;FIO1SET3
	LDREQ	R0,=0x3FFFC03F  ;FIO1CLR3
	MOV	R1,#0x80
	STRB	R1,[R0]
	BL	HVHOD		;novo geslo?
	MOVS	R1,R1
	BMI	KIZVED1
	LDR	R1,=GESLO
	STR	R0,[R1]
KIZVED1	LDR	R3,=KIZVED2	;izpisi ADC in telekomando
	BL	TXTIZP
	BL	ADCK
	LDR	R3,=KIZVED3	;izpisi geslo
	BL	TXTIZP
	LDR	R0,=GESLO
	LDR	R3,[R0]
	BL	HEXIZP
	MOV	R0,#13
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	LDR	PC,[SP],#4
KIZVED2 DCB	"*** ",0
KIZVED3	DCB	" Geslo: "
	ALIGN	4
	LTORG

;*** Ukaz L - naslovi lokalne zanke *** (R0-7,SP+4)
LIZVEDI	LDR	R6,=LNASLOV	;vnos naslova
	MOV	R5,#MAXLOK
	BL	NVHOD
	MOVS	R1,R1
	BMI	LIZVED3
	STR	R0,[R6],#4
	SUB	R5,R5,#1
LIZVED1	BL	NVHOD
	MOVS	R1,R1
	BMI	LIZVED2
	STR	R0,[R6],#4
	SUBS	R5,R5,#1
	BNE	LIZVED1
	B	LIZVED3
LIZVED2	MOV	R0,#0		;nicla na koncu <MAXLOK
	STR	R0,[R6]
LIZVED3	LDR	R3,=LIZVED7	;izpis lokalnih naslovov
	BL	TXTIZP
	LDR	R6,=LNASLOV
	LDR	R0,[R6]		;izklop?
	MOVS	R0,R0
	BEQ	LIZVED6
	MOV	R5,#MAXLOK	;izpisi naslove
	MOV	R7,#32
LIZVED4	LDR	R3,[R6],#4
	MOVS	R3,R3
	BEQ	LIZVED5
	MOV	R0,R7
	MOV	R7,#"+"
	BL	ZNAK
	BL	N36IZP
	SUBS	R5,R5,#1
	BNE	LIZVED4
LIZVED5	MOV	R0,#13
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	LDR	PC,[SP],#4
LIZVED6	LDR	R3,=LIZVED8	;izpisi izklop
	BL	TXTIZP
	LDR	PC,[SP],#4
LIZVED7	DCB	"*** Lokalni naslovi:",0
LIZVED8	DCB	" 0=KISS/SLIP (izklopljen Ethernet)",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz M - moj naslov *** (R0-4,SP+4)
MIZVEDI	BL	NVHOD
	MOVS	R1,R1
	BMI	MIZVED1
	LDR	R1,=MNASLOV
	STR	R0,[R1]
MIZVED1	LDR	R3,=MIZVED3
	BL	TXTIZP
	LDR	R0,=MNASLOV
	LDR	R3,[R0]
	MOVS	R3,R3
	BEQ	MIZVED2
	BL	N36IZP
	MOV	R0,#13
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	LDR	PC,[SP],#4
MIZVED2	LDR	R3,=MIZVED4
	BL	TXTIZP
	LDR	PC,[SP],#4
MIZVED3	DCB	"*** Moj naslov: ",0
MIZVED4	DCB	"0=KISS/SLIP<>Ethernet",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz N - naslov *** (R0-7,SP+4)
NIZVEDI	LDR	R6,=NASLOV	;vnos naslova
	MOV	R5,#MAXNAS
	BL	NVHOD
	MOVS	R1,R1
	BMI	NIZVED3
	STR	R0,[R6],#4
	SUB	R5,R5,#1
NIZVED1	BL	NVHOD
	MOVS	R1,R1
	BMI	NIZVED2
	STR	R0,[R6],#4
	SUBS	R5,R5,#1
	BNE	NIZVED1
	B	NIZVED3
NIZVED2	MOV	R0,#0		;nicla na koncu <MAXNAS
	STR	R0,[R6]
NIZVED3	LDR	R3,=NIZVED7	;izpis naslova
	BL	TXTIZP
	LDR	R6,=NASLOV
	LDR	R0,[R6]		;NASLOV obstaja?
	MOVS	R0,R0
	BEQ	NIZVED6
	MOV	R5,#MAXNAS	;izpis veljavnega naslova
	MOV	R7,#32
NIZVED4	LDR	R3,[R6],#4
	MOVS	R3,R3
	BEQ	NIZVED5
	MOV	R0,R7
	MOV	R7,#","
	BL	ZNAK
	BL	N36IZP
	SUBS	R5,R5,#1
	BNE	NIZVED4
NIZVED5	MOV	R0,#13
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	LDR	PC,[SP],#4
NIZVED6	LDR	R3,=NIZVED8	;izpis IZKLOP
	BL	TXTIZP
	LDR	PC,[SP],#4
NIZVED7	DCB	"*** Naslov:",0
NIZVED8	DCB	" 0=IZKLOP",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz O - meritev odziva stevila byte, 0=izklop *** (R0-4,SP+4)
MODZIV	EQU	1488		;max byte odziva
OIZVEDI	BL	DVHOD
	MOVS	R1,R1
	BMI	OIZVED1
	CMP	R0,#MODZIV
	MOVCS	R0,#MODZIV
	LDR	R1,=NODZIV
	STRH	R0,[R1]
OIZVED1	LDR	R3,=OIZVED2	;izpisi stevilo byte
	BL	TXTIZP
	LDR	R0,=NODZIV
	LDRH	R3,[R0]
        MOVS	R3,R3
	BEQ	OIZVED4
	BL	DECIZP
	LDR	R3,=OIZVED3
	BL	TXTIZP
	LDR	PC,[SP],#4
OIZVED4	LDR	R3,=OIZVED5	;izklop
	BL	TXTIZP
	LDR	PC,[SP],#4
OIZVED2	DCB	"*** Odziv: ",0
OIZVED3	DCB	"byte",13,10,0
OIZVED5	DCB	"0=IZKLOP",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz P - stevilo ponavljanj, zakasnitev minblok *** (R0-4,SP+4)
PIZVEDI	BL	DVHOD		;stvilo ponavljanj
	MOVS	R1,R1
	BMI	PIZVED1
	LDR	R1,=NPONOVI
	STRB	R0,[R1]
	BL	DVHOD		;zakasnitev
	MOVS	R1,R1
	BMI	PIZVED1
	LDR	R1,=TPONOVI
	STR	R0,[R1]
	BL	DVHOD		;minblok
	MOVS	R1,R1
	BMI	PIZVED1
	LDR	R1,=MINBLOK
	STRB	R0,[R1]
PIZVED1	LDR	R3,=PIZVED2	;izpisi stevilo ponavljanj
	BL	TXTIZP
	LDR	R0,=NPONOVI
	LDRB	R3,[R0]
	BL	DECIZP
	LDR	R3,=PIZVED3	;izpisi zakasnitev
	BL	TXTIZP
	LDR	R0,=TPONOVI
	LDR	R3,[R0]
	BL	DECIZP
	LDR	R3,=PIZVED4	;izpisi minblok
	BL	TXTIZP
	LDR	R0,=MINBLOK
	LDRB	R3,[R0]
	BL	DECIZP
	LDR	R3,=PIZVED5
	BL	TXTIZP
	LDR	PC,[SP],#4
PIZVED2	DCB	"*** Ponovi: ",0
PIZVED3	DCB	"-krat Zakasnitev: ",0
PIZVED4	DCB	"us Min: ",0
PIZVED5	DCB	"blok",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz Q - nastavi quartz in takt ARM procesorja *** (R0-4,SP+4)
QIZVEDI	BL	DVHOD		;vnos quartz?
	MOVS	R1,R1
	BMI	QIZVED1
	MOV	R4,R0
	BL	DVHOD		;vnos takt?
	MOVS	R1,R1
	BMI	QIZVED1
	CMP	R0,R4,LSL#2	;primerjaj quartz*4<>takt
	BNE	QIZVED1
	LDR	R1,=MINTAKT	;preveri min.takt
	CMP	R0,R1
	BCC	QIZVED1
	LDR	R1,=MAXTAKT	;preveri max.takt
	CMP	R0,R1
	BCS	QIZVED1
	LDR	R1,=ARMTAKT	;shrani novi takt
	STR	R0,[R1]
QIZVED1	LDR	R3,=QIZVED2	;izpisi quartz=takt/4
	BL	TXTIZP
	LDR	R0,=ARMTAKT
	LDR	R3,[R0]
	MOV	R3,R3,LSR#2
	BL	DECIZP
	LDR	R3,=QIZVED3	;izpisi takt
	BL	TXTIZP
	LDR	R0,=ARMTAKT
	LDR	R3,[R0]
	BL	DECIZP
	LDR	R3,=QIZVED4
	BL	TXTIZP
	LDR	PC,[SP],#4
QIZVED2	DCB	"*** Quartz: ",0
QIZVED3	DCB	"Hz*4=takt: ",0
QIZVED4	DCB	"Hz (FLASH+RESET)",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz R - RESET *** (R0,SP+4)
RIZVEDI	LDR	R0,=0xE0000008	;WDFEED pes grize!!!
	MOV	R1,#0xAA
	STRB	R1,[R0]
	MOV	R1,#0
	STRB	R1,[R0]
	LDR	PC,[SP],#4	;naj se ne bi izvedel...
	LTORG

;*** Ukaz S - slot, glava in rep *** (R0-4,SP+4)
SIZVEDI	BL	DVHOD
	MOVS	R1,R1
	BMI	SIZVED1
	LDR	R1,=TSLOT
	STR	R0,[R1]
	BL	DVHOD
	MOVS	R1,R1
	BMI	SIZVED1
	LDR	R1,=TGLAVA
	STR	R0,[R1]
	BL	DVHOD
	MOVS	R1,R1
	BMI	SIZVED1
	LDR	R1,=TREP
	STR	R0,[R1]
SIZVED1	LDR	R3,=SIZVED2	;izpisi slot
	BL	TXTIZP
	LDR	R0,=TSLOT
	LDR	R3,[R0]
	BL	DECIZP
	LDR	R3,=SIZVED3	;izpisi glavo
	BL	TXTIZP
	LDR	R0,=TGLAVA
	LDR	R3,[R0]
	BL	DECIZP
	LDR	R3,=SIZVED4	;izpisi rep
	BL	TXTIZP
	LDR	R0,=TREP
	LDR	R3,[R0]
	BL	DECIZP
	LDR	R3,=SIZVED5
	BL	TXTIZP
	LDR	PC,[SP],#4
SIZVED2	DCB	"*** Slot: ",0
SIZVED3	DCB	"us Glava: ",0
SIZVED4	DCB	"us Rep: ",0
SIZVED5	DCB	"us",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz T - tecnoba z DCD in brez DCD *** (R0-4,SP+4)
TIZVEDI	BL	DVHOD
	MOVS	R1,R1
	BMI	TIZVED1
	LDR	R1,=TECEN1
	STRH	R0,[R1]
	BL	DVHOD
	MOVS	R1,R1
	BMI	TIZVED1
	LDR	R1,=TECEN2
	STRH	R0,[R1]
TIZVED1	LDR	R3,=TIZVED2	;izpisi tecnobo z DCD
	BL	TXTIZP
	LDR	R0,=TECEN1
	LDRH	R3,[R0]
	BL	DECIZP
	LDR	R3,=TIZVED3	;izpisi tecnobo brez DCD
	BL	TXTIZP
	LDR	R0,=TECEN2
	LDRH	R3,[R0]
	BL	DECIZP
	LDR	R3,=TIZVED4
	BL	TXTIZP
	LDR	PC,[SP],#4
TIZVED2	DCB	"*** Tecnoba: ",0
TIZVED3	DCB	"/65536 brez DCD: ",0
TIZVED4	DCB	"/65536",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz U - uporabni okvirji na zaslon *** (R0-3,SP+4)
UIZVEDI	LDR	R0,=ZNACIN
	LDRB	R1,[R0]
	BIC	R1,R1,#2
	STRB	R1,[R0]
	LDR	R3,=UIZVED1
	BL	TXTIZP	
	LDR	PC,[SP],#4
UIZVED1	DCB	"*** Uporabni okvirji na zaslon ***",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz V - vsi okvirji na zaslon *** (R0-3,SP+4)
VIZVEDI	LDR	R0,=ZNACIN
	LDRB	R1,[R0]
	ORR	R1,R1,#2
	STRB	R1,[R0]
	LDR	R3,=VIZVED1
	BL	TXTIZP	
	LDR	PC,[SP],#4
VIZVED1	DCB	"*** Vsi okvirji na zaslon ***",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz W - HayesAT/EthernetARP wait *** (R0-4,SP+4)
WIZVEDI	BL	DVHOD
	MOVS	R1,R1
	BMI	WIZVED1
	LDR	R1,=TIMEOUT
	STR	R0,[R1]
WIZVED1	LDR	R3,=WIZVED2
	BL	TXTIZP
	LDR	R0,=TIMEOUT
	LDR	R3,[R0]
	BL	DECIZP
	LDR	R3,=WIZVED3
	BL	TXTIZP
	LDR	PC,[SP],#4
WIZVED2	DCB	"*** HayesAT/EthernetARP WAIT: ",0
WIZVED3	DCB	"us",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz X - PHY status in sogovornikov MAC *** (R0-6,SP+4)
XIZVEDI	BL	DVHOD
	MOVS	R1,R1
	BMI	XIZVED1
	LDR	R2,=ZNACIN	;vklop/izklop
	LDRB	R1,[R2]
	BIC	R1,R1,#16
	MOVS	R0,R0
	ORRNE	R1,R1,#16
	STRB	R1,[R2]
	LDR	R3,=XIZVED2
	LDRNE	R3,=XIZVED3
	BL	TXTIZP
	LDR	PC,[SP],#4
XIZVED1	MOV	R3,#0x10	;PHY Status Register
	BL	PHYSTS		;PHY register R3 preberi stanje v R2
	MOV	R5,R2
	MOV	R3,#0x1A	;10Base-T Status/Control Register
	BL	PHYSTS		;PHY register R3 preberi stanje v R2
	BL	PHYMAC		;izpisi PHY status (R5) in sogovornikov MAC
	LDR	PC,[SP],#4
XIZVED2	DCB	"*** Izpis PHY: 0=IZKLOP",13,10,0
XIZVED3	DCB	"*** Izpis PHY: 1=VKLOP",13,10,0
	ALIGN	4
	LTORG

;*** Ukaz Y - skala in enota ADC TLM 1/2 *** (R0-6,SP+4)
YIZVEDI	LDR	R6,=NENOTA	;vnos konstant in enot (HEX)
	MOV	R5,#MENOTA
YIZVED1	BL	HVHOD
	MOVS	R1,R1
	BMI	YIZVED2
	STR	R0,[R6],#4
	SUBS	R5,R5,#1
	BNE	YIZVED1
YIZVED2	LDR	R3,=YIZVED4	;izpis konstant in enot (HEX)
	BL	TXTIZP
	LDR	R6,=NENOTA
	MOV	R5,#MENOTA
YIZVED3	MOV	R0,#32
	BL	ZNAK
	LDR	R3,[R6],#4
	BL	HEXIZP
	SUBS	R5,R5,#1
	BNE	YIZVED3
	MOV	R0,#13
	BL	ZNAK
	MOV	R0,#10
	BL	ZNAK
	LDR	PC,[SP],#4
YIZVED4	DCB	"*** Yskala/enota:",0
	ALIGN	4
	LTORG

;*** Ukaz Z - %DCD, %PTT, bloki, zanke in cas *** (R0-4,SP+4)
ZIZVEDI	BL	DVHOD
	MOVS	R1,R1
	BMI	ZIZVED1
	LDR	R2,=ZNACIN	;vklop/izklop
	LDRB	R1,[R2]
	BIC	R1,R1,#4
	MOVS	R0,R0
	ORRNE	R1,R1,#4
	STRB	R1,[R2]
	LDR	R3,=ZIZVED2
	LDRNE	R3,=ZIZVED3
	BL	TXTIZP
	LDR	PC,[SP],#4
ZIZVED1	BL	STANJE		;izpis stanja
	LDR	PC,[SP],#4
ZIZVED2	DCB	"*** Izpis stanja: 0=IZKLOP",13,10,0
ZIZVED3	DCB	"*** Izpis stanja: 1=VKLOP",13,10,0
	ALIGN	4
	LTORG

;*** Konec delovanja zbirnika ARM ***
	END
